(* Content-type: application/vnd.wolfram.cdf.text *)

(*** Wolfram CDF File ***)
(* http://www.wolfram.com/cdf *)

(* CreatedBy='Mathematica 8.0' *)

(*************************************************************************)
(*                                                                       *)
(*  The Mathematica License under which this file was created prohibits  *)
(*  restricting third parties in receipt of this file from republishing  *)
(*  or redistributing it by any means, including but not limited to      *)
(*  rights management or terms of use, without the express consent of    *)
(*  Wolfram Research, Inc.                                               *)
(*                                                                       *)
(*************************************************************************)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       835,         17]
NotebookDataLength[    612849,      17844]
NotebookOptionsPosition[    557619,      16440]
NotebookOutlinePosition[    594684,      17221]
CellTagsIndexPosition[    594641,      17218]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {
    ButtonBox[Cell[GraphicsData["CompressedBitmap", "\<\
eJzVWL1uFDEQduzd2/wgISEkRHco0NGlAN0DAAXcC1CdIqSkQKAkokjDC9Aj
UoBESUt5LW9AR5UHiQ782fPtzXq9l70lKKLwrj3jmfHOfPaM98Xs5ODV69nJ
4f5s/PRo9vbgcP94/OTNkSe5DWPML9/ujA36v31XHlPz6ebuB7O3t2fMuv0t
9M3I/Dh5H3ps3x4/M9+fv6zCoAzsxcVF3TAuA8+Znx+/BBpGhdAwBj2O2rRR
eFYwUctTL8eFzNRyaMJ3YjBh2/BdpTk9PTXn5+dmsViY+XxuptOpnwzeKPRB
Aw8N8zzNBbYzZ2dngYwRRbQ6vEVlISIgQwwjm6EVmVXhDX5PE2CDhcWXPdSl
HynqSmHr1aHJR7vM4scRKpsSR8QMTv/64JH/1jYGSoktaXjruOJd/AV2iDtA
lLixsBCm9ULNTouNL4TH6Cl6Fv3okyrwQaOnMYdzc9hxSeQw12Jkg4oYIvof
TZyei4GTsFE/7WLslV1iqmqZ4rfobXGJbroHYjYwXQ0+rWYossoGQkCJCAMl
oo7BsgkCMN8liAIvpQ1BGWU/330Y59neKOs8m3Qw6HS6B85nYBj0NHgiExxu
dYgmk0mIHN45f+eOJpuENwY2HlqJ4U5bW5062sjTH6htc7cNh1Glkgo9z4OK
fYseMcCsVsfWP9FnJroK/OTm0e6Sti6SdIDUts05p1pxMulUU4RnTEM9DyWb
qAYUqk7VrqE6XVYq2zz4cssfDpHtRkQ1VBAZwse/04D9f0CxAhQmBsldubql
Eyhh2xeyqcFhHFcdJ71w0ql581rQMZKAEAEsivG2UpPiMFGoYaSuOxW1Kxpt
ncmUH2WX0HB1yo+5aVgWUiIIFVXrmpX5QJvTVdcyZ6yXR7rsXX1O2mmtnfU1
9Wlb9zSmqkbgdThAt8l2B/7cwCraJRimHGBga9CIEI87oo5CmZI6FYtT4p7Q
6/J2FLrK2oVSTDagMLSg1oW6ldk6NHJqgVQ2FKelas+Kt8vO9npqVhbOYbmR
W9Wz0dK1C67KJGTLNBQxw22PxlS1xEz/Gz3xpG/pTdyW9biNzT43/Corj/2h
z93kBwXzGiEku463W15+9eV4jRs+g+nPlrQcZSgkNCOBed+LvdJ8o4foykt8
1VoUf3SAFm9+rpECJc/tSGSZy9Bu9UxQ9/GUn0fjfy1zO+4M76F3w6Xj7Qpp
gm44vkxZs4zy22d3zdUUDcz7/m7GBdwaOseThreW6fMvz2z8AbMc9mc=\
\>"], "Graphics",
      Evaluatable->False,
      GeneratedCell->False,
      CellAutoOverwrite->False,
      ImageSize->{218, 23},
      ImageMargins->{{0, 0}, {0, 0}},
      ImageRegion->{{0, 1}, {0, 1}}],
     Active->True,
     Appearance->{Automatic, None},
     BaseStyle->"Hyperlink",
     ButtonData:>{
       URL["http://www.wolframscience.com"], None},
     ButtonNote->"A New Kind of Science"]}
  }]], "TitleCell1",
 CellMargins->{{Inherited, Inherited}, {0, Inherited}}],

Cell[TextData[{
 "From: ",
 StyleBox["A New Kind of Science",
  FontSlant->"Italic"],
 ", by Stephen Wolfram \[Copyright] 2002 Stephen Wolfram, LLC"
}], "Text",
 ShowCellBracket->False,
 CellMargins->{{36, Inherited}, {Inherited, 5}}],

Cell["NOTES FOR CHAPTER 11", "TitleHeader"],

Cell[CellGroupData[{

Cell["The Notion of Computation", "Title"],

Cell[CellGroupData[{

Cell["Computations in Cellular Automata", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 639 \[CenterDot] Squaring cellular automaton\
\>", "Subsection"], Cell[" (page 1109)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "_", ",", "3"}], "}"}], "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "2", ",", "3"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "1", ",", "4"}], "}"}], "\[Rule]", "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "|", "2"}], ",", "3", ",", "_"}], "}"}], "\[Rule]", "5"}],
     ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "1"}], ")"}]}], ",", "4", ",", "_"}], "}"}], 
     "\[Rule]", 
     RowBox[{"7", "-", "p"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"7", ",", "2", ",", "6"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"7", ",", "_", ",", "_"}], "}"}], "\[Rule]", "7"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "7", ",", 
       RowBox[{"p", ":", 
        RowBox[{"(", 
         RowBox[{"1", "|", "2"}], ")"}]}]}], "}"}], "\[Rule]", "p"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"p", ":", 
        RowBox[{"(", 
         RowBox[{"5", "|", "6"}], ")"}]}], ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"7", "-", "p"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"5", "|", "6"}], ",", 
       RowBox[{"p", ":", 
        RowBox[{"(", 
         RowBox[{"1", "|", "2"}], ")"}]}], ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"7", "-", "p"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"5", "|", "6"}], ",", "0", ",", "0"}], "}"}], "\[Rule]", "1"}],
     ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"p", ":", 
        RowBox[{"(", 
         RowBox[{"1", "|", "2"}], ")"}]}], ",", "_"}], "}"}], "\[Rule]", 
     "p"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], "}"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Append", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", "n", "}"}]}], "]"}], ",", "3"}], "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n", "=", "2"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"CAEvolveList", "[", 
     RowBox[{
      RowBox[{"GeneralCARule", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "_", ",", "3"}], "}"}], "\[Rule]", "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "2", ",", "3"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", "4"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "1", ",", "4"}], "}"}], "\[Rule]", "4"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "|", "2"}], ",", "3", ",", "_"}], "}"}], "\[Rule]", 
          "5"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"p", ":", 
             RowBox[{"(", 
              RowBox[{"0", "|", "1"}], ")"}]}], ",", "4", ",", "_"}], "}"}], 
          "\[Rule]", 
          RowBox[{"7", "-", "p"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"7", ",", "2", ",", "6"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"7", ",", "_", ",", "_"}], "}"}], "\[Rule]", "7"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "7", ",", 
            RowBox[{"p", ":", 
             RowBox[{"(", 
              RowBox[{"1", "|", "2"}], ")"}]}]}], "}"}], "\[Rule]", "p"}], 
         ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"p", ":", 
             RowBox[{"(", 
              RowBox[{"5", "|", "6"}], ")"}]}], ",", "_"}], "}"}], "\[Rule]", 
          RowBox[{"7", "-", "p"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"5", "|", "6"}], ",", 
            RowBox[{"p", ":", 
             RowBox[{"(", 
              RowBox[{"1", "|", "2"}], ")"}]}], ",", "_"}], "}"}], "\[Rule]", 
          RowBox[{"7", "-", "p"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"5", "|", "6"}], ",", "0", ",", "0"}], "}"}], "\[Rule]", 
          "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"p", ":", 
             RowBox[{"(", 
              RowBox[{"1", "|", "2"}], ")"}]}], ",", "_"}], "}"}], "\[Rule]", 
          "p"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], 
        "}"}], "]"}], ",", " ", 
      RowBox[{"PadRight", "[", 
       RowBox[{
        RowBox[{"Append", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", "n", "}"}]}], "]"}], ",", "3"}], "]"}], ",", 
        RowBox[{
         RowBox[{"n", "^", "2"}], "+", "n", "+", "2"}]}], "]"}], ",", 
      RowBox[{"4", " ", 
       RowBox[{"n", "^", "2"}]}]}], "]"}]}], "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.513087211950428*^9, 3.513087214633243*^9}, {
  3.5202619742516747`*^9, 3.5202619747669277`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "1", "3", "0", "0", "0", "0", "0"},
    {"1", "4", "5", "0", "0", "0", "0", "0"},
    {"4", "6", "2", "1", "0", "0", "0", "0"},
    {"7", "1", "5", "1", "0", "0", "0", "0"},
    {"1", "7", "2", "6", "0", "0", "0", "0"},
    {"1", "2", "3", "1", "1", "0", "0", "0"},
    {"1", "3", "5", "1", "1", "0", "0", "0"},
    {"0", "5", "2", "6", "1", "0", "0", "0"},
    {"0", "2", "5", "1", "6", "0", "0", "0"},
    {"0", "2", "2", "6", "1", "1", "0", "0"},
    {"0", "2", "2", "1", "6", "1", "0", "0"},
    {"0", "2", "2", "1", "1", "6", "0", "0"},
    {"0", "2", "2", "1", "1", "1", "1", "0"},
    {"0", "2", "2", "1", "1", "1", "1", "0"},
    {"0", "2", "2", "1", "1", "1", "1", "0"},
    {"0", "2", "2", "1", "1", "1", "1", "0"},
    {"0", "2", "2", "1", "1", "1", "1", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.41373432515137*^9, 3.413734421860474*^9, 
  3.4282541275292377`*^9, 3.432324952328662*^9, 3.432325565679257*^9, 
  3.432325785084764*^9, 3.4323258271632223`*^9, 3.432326455458933*^9, 
  3.5002114276675777`*^9, 3.513087217184497*^9, 3.5202619754855413`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 640 \[CenterDot] Primes cellular automaton\
\>", "Subsection"], Cell[" (page 1109)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"13", ",", "3", ",", "13"}], "}"}], "\[Rule]", "12"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"6", ",", "_", ",", "4"}], "}"}], "\[Rule]", "15"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"10", ",", "_", ",", 
      RowBox[{"3", "|", "11"}]}], "}"}], "\[Rule]", "15"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"13", ",", "7", ",", "_"}], "}"}], "\[Rule]", "8"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"13", ",", "8", ",", "7"}], "}"}], "\[Rule]", "13"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"15", ",", "8", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"8", ",", "_", ",", "_"}], "}"}], "\[Rule]", "7"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"15", ",", "1", ",", "_"}], "}"}], "\[Rule]", "2"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "1", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "_", ",", "_"}], "}"}], "\[Rule]", "8"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"2", "|", "4", "|", "5"}], ",", "_", ",", "_"}], "}"}], 
    "\[Rule]", "13"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"15", ",", "2", ",", "_"}], "}"}], "\[Rule]", "4"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "4", ",", "8"}], "}"}], "\[Rule]", "4"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "4", ",", "_"}], "}"}], "\[Rule]", "5"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "5", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"15", ",", "3", ",", "_"}], "}"}], "\[Rule]", "12"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{"2", "|", "3", "|", "8"}], ")"}]}], ",", "_"}], "}"}], 
    "\[Rule]", "x"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{"11", "|", "12"}], ")"}]}], ",", "_"}], "}"}], "\[Rule]", 
    RowBox[{"x", "-", "1"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"11", ",", "_", ",", "_"}], "}"}], "\[Rule]", "13"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"13", ",", "_", ",", 
      RowBox[{
      "1", "|", "2", "|", "3", "|", "5", "|", "6", "|", "10", "|", "11"}]}], 
     "}"}], "\[Rule]", "15"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"13", ",", "0", ",", "8"}], "}"}], "\[Rule]", "15"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"14", ",", "_", ",", 
      RowBox[{"6", "|", "10"}]}], "}"}], "\[Rule]", "15"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"10", ",", 
      RowBox[{"0", "|", "9", "|", "13"}], ",", 
      RowBox[{"6", "|", "10"}]}], "}"}], "\[Rule]", "15"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"6", ",", "_", ",", "6"}], "}"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "10"}], "}"}], "\[Rule]", "9"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"6", "|", "10"}], ",", "15", ",", "9"}], "}"}], "\[Rule]", 
    "14"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"6", "|", "10"}], ",", 
      RowBox[{"9", "|", "14", "|", "15"}]}], "}"}], "\[Rule]", "10"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"6", "|", "10"}], ",", "_"}], "}"}], "\[Rule]", "6"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"6", "|", "10"}], ",", "15", ",", "_"}], "}"}], "\[Rule]", 
    "13"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"13", "|", "14"}], ",", "_", ",", 
      RowBox[{"9", "|", "15"}]}], "}"}], "\[Rule]", "14"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"13", "|", "14"}], ",", "_", ",", "_"}], "}"}], "\[Rule]", 
    "13"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "15"}], "}"}], "\[Rule]", "15"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", 
      RowBox[{"9", "|", "14"}]}], "}"}], "\[Rule]", "9"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rule", "=", 
      RowBox[{"GeneralCARule", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"13", ",", "3", ",", "13"}], "}"}], "\[Rule]", "12"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"6", ",", "_", ",", "4"}], "}"}], "\[Rule]", "15"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"10", ",", "_", ",", 
            RowBox[{"3", "|", "11"}]}], "}"}], "\[Rule]", "15"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"13", ",", "7", ",", "_"}], "}"}], "\[Rule]", "8"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"13", ",", "8", ",", "7"}], "}"}], "\[Rule]", "13"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"15", ",", "8", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"8", ",", "_", ",", "_"}], "}"}], "\[Rule]", "7"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"15", ",", "1", ",", "_"}], "}"}], "\[Rule]", "2"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "1", ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "_", ",", "_"}], "}"}], "\[Rule]", "8"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"2", "|", "4", "|", "5"}], ",", "_", ",", "_"}], "}"}], 
          "\[Rule]", "13"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"15", ",", "2", ",", "_"}], "}"}], "\[Rule]", "4"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "4", ",", "8"}], "}"}], "\[Rule]", "4"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "4", ",", "_"}], "}"}], "\[Rule]", "5"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "5", ",", "_"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"15", ",", "3", ",", "_"}], "}"}], "\[Rule]", "12"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"x", ":", 
             RowBox[{"(", 
              RowBox[{"2", "|", "3", "|", "8"}], ")"}]}], ",", "_"}], "}"}], 
          "\[Rule]", "x"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"x", ":", 
             RowBox[{"(", 
              RowBox[{"11", "|", "12"}], ")"}]}], ",", "_"}], "}"}], 
          "\[Rule]", 
          RowBox[{"x", "-", "1"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"11", ",", "_", ",", "_"}], "}"}], "\[Rule]", "13"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"13", ",", "_", ",", 
            RowBox[{
            "1", "|", "2", "|", "3", "|", "5", "|", "6", "|", "10", "|", 
             "11"}]}], "}"}], "\[Rule]", "15"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"13", ",", "0", ",", "8"}], "}"}], "\[Rule]", "15"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"14", ",", "_", ",", 
            RowBox[{"6", "|", "10"}]}], "}"}], "\[Rule]", "15"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"10", ",", 
            RowBox[{"0", "|", "9", "|", "13"}], ",", 
            RowBox[{"6", "|", "10"}]}], "}"}], "\[Rule]", "15"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"6", ",", "_", ",", "6"}], "}"}], "\[Rule]", "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", "10"}], "}"}], "\[Rule]", "9"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"6", "|", "10"}], ",", "15", ",", "9"}], "}"}], "\[Rule]",
           "14"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"6", "|", "10"}], ",", 
            RowBox[{"9", "|", "14", "|", "15"}]}], "}"}], "\[Rule]", "10"}], 
         ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"6", "|", "10"}], ",", "_"}], "}"}], "\[Rule]", "6"}], 
         ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"6", "|", "10"}], ",", "15", ",", "_"}], "}"}], "\[Rule]",
           "13"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"13", "|", "14"}], ",", "_", ",", 
            RowBox[{"9", "|", "15"}]}], "}"}], "\[Rule]", "14"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"13", "|", "14"}], ",", "_", ",", "_"}], "}"}], "\[Rule]",
           "13"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", "15"}], "}"}], "\[Rule]", "15"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", 
            RowBox[{"9", "|", "14"}]}], "}"}], "\[Rule]", "9"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], 
        "}"}], "]"}]}], "}"}], ",", 
    RowBox[{"CAEvolveList", "[", 
     RowBox[{"rule", ",", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", "15", "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"10", ",", "0", ",", "4", ",", "8"}], "}"}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", "7", "}"}]}], "]"}]}], "]"}], ",", "15"}], "]"}]}], 
   "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.513087225418785*^9, 3.5130872277863207`*^9}, {
  3.520261984580617*^9, 3.520261985093656*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
     "0", "10", "0", "4", "8", "0", "0", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
     "9", "6", "0", "4", "13", "7", "0", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9", 
     "0", "6", "15", "5", "13", "8", "0", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9", "0", 
     "0", "10", "13", "3", "13", "8", "7", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9", "0", "0", 
     "9", "6", "15", "12", "0", "13", "7", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "9", "0", "0", "9", 
     "0", "10", "13", "11", "0", "0", "8", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "9", "0", "0", "9", "0", 
     "9", "6", "15", "10", "13", "0", "8", "7", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "9", "0", "0", "9", "0", "9", 
     "0", "10", "9", "6", "0", "15", "8", "7", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "9", "0", "0", "9", "0", "9", "0", 
     "9", "10", "15", "6", "15", "0", "1", "7", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "9", "0", "0", "9", "0", "9", "0", "9", 
     "9", "10", "13", "10", "13", "0", "1", "8", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "9", "0", "0", "9", "0", "9", "0", "9", "9", 
     "9", "6", "15", "6", "0", "15", "1", "8", "7", "0", "0", "0"},
    {"0", "0", "0", "0", "9", "0", "0", "9", "0", "9", "0", "9", "9", "9", 
     "0", "10", "0", "6", "15", "0", "2", "8", "7", "0", "0", "0"},
    {"0", "0", "0", "9", "0", "0", "9", "0", "9", "0", "9", "9", "9", "0", 
     "9", "6", "15", "10", "13", "0", "2", "13", "7", "0", "0", "0"},
    {"0", "0", "9", "0", "0", "9", "0", "9", "0", "9", "9", "9", "0", "9", 
     "0", "10", "9", "6", "0", "15", "2", "13", "8", "0", "0", "0"},
    {"0", "9", "0", "0", "9", "0", "9", "0", "9", "9", "9", "0", "9", "0", 
     "9", "10", "15", "6", "15", "0", "4", "13", "8", "7", "0", "0"},
    {"9", "0", "0", "9", "0", "9", "0", "9", "9", "9", "0", "9", "0", "9", 
     "9", "10", "13", "10", "13", "0", "5", "13", "13", "7", "0", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.413734325227429*^9, 3.41373442194657*^9, 
  3.428254147375736*^9, 3.432324952427558*^9, 3.432325565771096*^9, 
  3.432325785157928*^9, 3.4323258272380857`*^9, 3.432326455544435*^9, 
  3.5002114342190742`*^9, 3.513087230141033*^9, 3.520261987455635*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Phenomenon of Universality", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell[TextData[{
      "Universality in ",
      StyleBox["Mathematica",
       FontSlant->"Italic"]
     }], "Subsection"], Cell[" (page 1110)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"n", "!"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"n", "!"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.4137343253008623`*^9, 3.4137344220188837`*^9, 
  3.4282541688771887`*^9, 3.432324952523884*^9, 3.4323255658416023`*^9, 
  3.4323257852172194`*^9, 3.432325827325488*^9, 3.432326455640588*^9, 
  3.500211442143073*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "n_", "]"}], ":=", 
   RowBox[{"n", " ", 
    RowBox[{"f", "[", 
     RowBox[{"n", "-", "1"}], "]"}]}]}], ";", 
  RowBox[{
   RowBox[{"f", "[", "1", "]"}], "=", "1"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "n_", "]"}], ":=", 
   RowBox[{"n", " ", 
    RowBox[{"f", "[", 
     RowBox[{"n", "-", "1"}], "]"}]}]}], ";", 
  RowBox[{
   RowBox[{"f", "[", "1", "]"}], "=", "1"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.413734325384933*^9, 3.41373442210296*^9, 
  3.428254176872398*^9, 3.432324952624032*^9, 3.432325565938075*^9, 
  3.432325785305216*^9, 3.432325827405629*^9, 3.432326455725644*^9, 
  3.500211447083671*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Product", "[", 
   RowBox[{"i", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Product", "[", 
   RowBox[{"i", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.413734325467391*^9, 3.413734422185*^9, 
  3.4282541818707447`*^9, 3.432324952710182*^9, 3.432325566041931*^9, 
  3.432325785384161*^9, 3.432325827493581*^9, 3.4323264558086653`*^9, 
  3.500211452844401*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"t", "=", "1"}], "}"}], ",", 
    RowBox[{
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"t", "=", 
        RowBox[{"t", " ", "i"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "t"}]}], 
   "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"t", "=", "1"}], "}"}], ",", 
    RowBox[{
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"t", "=", 
        RowBox[{"t", " ", "i"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "t"}]}], 
   "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.4137343255509663`*^9, 3.413734422252652*^9, 
  3.428254187088051*^9, 3.432324952797249*^9, 3.432325566140376*^9, 
  3.432325785471781*^9, 3.432325827560014*^9, 3.4323264559151783`*^9, 
  3.50021145826994*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t", "=", "1"}], ",", "i"}], "}"}], ",", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", "n"}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"t", "*=", "i"}]}], "]"}], ";", "t"}]}], 
   "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t", "=", "1"}], ",", "i"}], "}"}], ",", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", "n"}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"t", "*=", "i"}]}], "]"}], ";", "t"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.41373432563496*^9, 3.413734422335956*^9, 
  3.428254193058823*^9, 3.432324952874872*^9, 3.432325566243826*^9, 
  3.4323257855523853`*^9, 3.432325827656708*^9, 3.432326456005802*^9, 
  3.5002114639614573`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Times", ",", 
    RowBox[{"Range", "[", "n", "]"}]}], "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Times", ",", 
    RowBox[{"Range", "[", "n", "]"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.4137343257019997`*^9, 3.413734422413465*^9, 
  3.4282541977999277`*^9, 3.4323249529633837`*^9, 3.432325566328594*^9, 
  3.432325785635756*^9, 3.4323258277521563`*^9, 3.4323264560947933`*^9, 
  3.500211468552149*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{"Times", ",", "1", ",", 
    RowBox[{"Range", "[", "n", "]"}]}], "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{"Times", ",", "1", ",", 
    RowBox[{"Range", "[", "n", "]"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.413734325785671*^9, 3.413734422482957*^9, 
  3.42825420265985*^9, 3.432324953045664*^9, 3.43232556642311*^9, 
  3.432325785735832*^9, 3.432325827828199*^9, 3.432326456199401*^9, 
  3.5002114751249113`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", "==", "1"}], ",", "1", ",", 
    RowBox[{"n", " ", 
     RowBox[{"f", "[", 
      RowBox[{"n", "-", "1"}], "]"}]}]}], "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", "==", "1"}], ",", "1", ",", 
    RowBox[{"n", " ", 
     RowBox[{"f", "[", 
      RowBox[{"n", "-", "1"}], "]"}]}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.428254207506278*^9, 3.42825420809741*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.413734325869604*^9, 3.41373442253904*^9, 
  3.428254208498412*^9, 3.43232495311308*^9, 3.4323255665303373`*^9, 
  3.432325785807517*^9, 3.4323258279146347`*^9, 3.432326456278776*^9, 
  3.500211480799953*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#2", "[", "#1", "]"}], "&"}], ",", "1", ",", 
    RowBox[{"Array", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"t", ",", 
         RowBox[{"#1", " ", "t"}]}], "]"}], "&"}], ",", "n"}], "]"}]}], 
   "]"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "n_", "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#2", "[", "#1", "]"}], "&"}], ",", "1", ",", 
    RowBox[{"Array", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{"t", ",", 
         RowBox[{"#1", " ", "t"}]}], "]"}], "&"}], ",", "n"}], "]"}]}], 
   "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.413734325952705*^9, 3.41373442263584*^9, 
  3.428254213462571*^9, 3.432324953197463*^9, 3.4323255666922827`*^9, 
  3.4323257858743362`*^9, 3.4323258279923763`*^9, 3.432326456378109*^9, 
  3.5002114874940767`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "=", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"#1", "==", "1"}], ",", "1", ",", 
     RowBox[{"#1", " ", 
      RowBox[{"#0", "[", 
       RowBox[{"#1", "-", "1"}], "]"}]}]}], "]"}], "&"}]}]], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "=", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"#1", "==", "1"}], ",", "1", ",", 
      RowBox[{"#1", " ", 
       RowBox[{"#0", "[", 
        RowBox[{"#1", "-", "1"}], "]"}]}]}], "]"}], "&"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4323230685451717`*^9, 3.432323070027542*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"f", "[", "n", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"n", ",", "5"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "6", ",", "24", ",", "120"}], "}"}]], "Output",
 CellChangeTimes->{3.413734326019944*^9, 3.4137344227140903`*^9, 
  3.4282542190098457`*^9, 3.432324953264183*^9, 3.432325566817878*^9, 
  3.432325785942912*^9, 3.4323258281317244`*^9, 3.432326456615109*^9, 
  3.5002114936368017`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["A Universal Cellular Automaton", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 648 \[CenterDot] Universal cellular automaton\
\>", "Subsection"], Cell[" (page 1110)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "3", ",", "7", ",", "18", ",", "_"}], "}"}], 
     "\[Rule]", "12"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "5", ",", 
       RowBox[{"7", "|", "8"}], ",", "0", ",", "_"}], "}"}], "\[Rule]", 
     "12"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "3", ",", "10", ",", "18", ",", "_"}], "}"}], 
     "\[Rule]", "16"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "5", ",", 
       RowBox[{"10", "|", "11"}], ",", "0", ",", "_"}], "}"}], "\[Rule]", 
     "16"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "5", ",", "8", ",", "18", ",", "_"}], "}"}], 
     "\[Rule]", "7"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "5", ",", "14", ",", 
       RowBox[{"0", "|", "18"}], ",", "_"}], "}"}], "\[Rule]", "12"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "8", ",", "5", ",", "_"}], "}"}], "\[Rule]",
      "7"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "14", ",", "5", ",", "_"}], "}"}], 
     "\[Rule]", "12"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "5", ",", "11", ",", "18", ",", "_"}], "}"}], 
     "\[Rule]", "10"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "5", ",", "17", ",", 
       RowBox[{"0", "|", "18"}], ",", "_"}], "}"}], "\[Rule]", "16"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"11", "|", "17"}], ")"}]}], ",", "5", ",", "_"}], "}"}], 
     "\[Rule]", 
     RowBox[{"x", "-", "1"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"0", "|", "9", "|", "18"}], ",", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"7", "|", "10", "|", "16"}], ")"}]}], ",", "3", ",", "_"}], 
      "}"}], "\[Rule]", 
     RowBox[{"x", "+", "1"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"0", "|", "9", "|", "18"}], ",", "12", ",", "3", ",", "_"}], 
      "}"}], "\[Rule]", "14"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", 
       RowBox[{"0", "|", "9", "|", "18"}], ",", 
       RowBox[{"7", "|", "10", "|", "12", "|", "16"}], ",", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"3", "|", "5"}], ")"}]}]}], "}"}], "\[Rule]", 
     RowBox[{"8", "-", "x"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_", ",", 
       RowBox[{"8", "|", "11", "|", "14", "|", "17"}], ",", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"3", "|", "5"}], ")"}]}]}], "}"}], "\[Rule]", 
     RowBox[{"8", "-", "x"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "13", ",", "4", ",", "_", ",", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "18"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"18", ",", "_", ",", "4", ",", "_", ",", "_"}], "}"}], 
     "\[Rule]", "18"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "18", ",", "_", ",", "4"}], "}"}], 
     "\[Rule]", "18"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "_", ",", "4", ",", "_", ",", "_"}], "}"}], "\[Rule]",
      "0"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "0", ",", "_", ",", "4"}], "}"}], "\[Rule]",
      "0"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "_", ",", 
       RowBox[{"0", "|", "18"}], ",", "1", ",", "_"}], "}"}], "\[Rule]", 
     "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "_", ",", "_", ",", "_", ",", "_"}], "}"}], "\[Rule]",
      "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "4", ",", "_", ",", "_"}], "}"}], "\[Rule]",
      "9"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "4", ",", "12", ",", "_", ",", "_"}], "}"}], 
     "\[Rule]", "7"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "4", ",", "16", ",", "_", ",", "_"}], "}"}], 
     "\[Rule]", "10"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "18"}], ")"}]}], ",", "_", ",", "6", ",", "_", ",",
        "_"}], "}"}], "\[Rule]", "x"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "2", ",", "6", ",", "15", ",", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "18"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"12", "|", "16"}], ",", "6", ",", "7", ",", "_"}], "}"}], 
     "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"12", "|", "16"}], ",", "6", ",", "10", ",", "_"}], "}"}], 
     "\[Rule]", "18"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "9", ",", "10", ",", "6", ",", "_"}], "}"}], 
     "\[Rule]", "16"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "9", ",", "7", ",", "6", ",", "_"}], "}"}], "\[Rule]",
      "12"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"9", ",", "15", ",", "6", ",", "7", ",", "9"}], "}"}], 
     "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"9", ",", "15", ",", "6", ",", "10", ",", "9"}], "}"}], 
     "\[Rule]", "18"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"9", ",", "_", ",", "6", ",", "_", ",", "_"}], "}"}], "\[Rule]",
      "9"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "6", ",", "7", ",", "9", ",", 
       RowBox[{"12", "|", "16"}]}], "}"}], "\[Rule]", "12"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "6", ",", "10", ",", "9", ",", 
       RowBox[{"12", "|", "16"}]}], "}"}], "\[Rule]", "16"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"12", "|", "16"}], ",", "6", ",", "7", ",", "9", ",", "_"}], 
      "}"}], "\[Rule]", "12"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"12", "|", "16"}], ",", "6", ",", "10", ",", "9", ",", "_"}], 
      "}"}], "\[Rule]", "16"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "13", ",", "_", ",", "_", ",", "_"}], "}"}], 
     "\[Rule]", "9"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "_", ",", "_", ",", "_", ",", "_"}], "}"}], "\[Rule]",
      "6"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "9", ",", "13", ",", "3"}], "}"}], 
     "\[Rule]", "9"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "9", ",", "13", ",", "3", ",", "_"}], "}"}], 
     "\[Rule]", "15"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_", ",", "15", ",", "3"}], "}"}], 
     "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "3", ",", "15", ",", 
       RowBox[{"0", "|", "18"}], ",", "_"}], "}"}], "\[Rule]", "13"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "13", ",", "3", ",", "_", ",", 
       RowBox[{"0", "|", "18"}]}], "}"}], "\[Rule]", "6"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "18"}], ")"}]}], ",", "15", ",", "9", ",", "_", 
       ",", "_"}], "}"}], "\[Rule]", "x"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "6", ",", "13", ",", "_", ",", "_"}], "}"}], 
     "\[Rule]", "15"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "4", ",", "15", ",", "_", ",", "_"}], "}"}], 
     "\[Rule]", "13"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_", ",", "15", ",", "6"}], "}"}], 
     "\[Rule]", "6"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "2", ",", "6", ",", "15"}], "}"}], 
     "\[Rule]", "1"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "1", ",", "6", ",", "_"}], "}"}], "\[Rule]",
      "2"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "1", ",", "6", ",", "_", ",", "_"}], "}"}], "\[Rule]",
      "9"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "3", ",", "2", ",", "_", ",", "_"}], "}"}], "\[Rule]",
      "1"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "_", ",", "_", ",", "_"}], "}"}], "\[Rule]",
      "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "3", ",", "2", ",", "_"}], "}"}], "\[Rule]",
      "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "1", ",", "9", ",", "1", ",", "6"}], "}"}], "\[Rule]",
      "6"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "9", ",", "1", ",", "6"}], "}"}], "\[Rule]",
      "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "4", ",", "2", ",", "_", ",", "_"}], "}"}], "\[Rule]",
      "1"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"3", "|", "5"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", 
       RowBox[{"3", "|", "5"}], ",", "_", ",", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "18"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", 
       RowBox[{"x", ":", 
        RowBox[{"(", 
         RowBox[{
         "1", "|", "2", "|", "7", "|", "8", "|", "9", "|", "10", "|", "11", 
          "|", "12", "|", "13", "|", "14", "|", "15", "|", "16", "|", "17"}], 
         ")"}]}], ",", "_", ",", "_"}], "}"}], "\[Rule]", "x"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "18", ",", 
       RowBox[{"7", "|", "10"}], ",", "18"}], "}"}], "\[Rule]", "18"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "0", ",", 
       RowBox[{"7", "|", "10"}], ",", "0"}], "}"}], "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", 
       RowBox[{"0", "|", "18"}], ",", "_", ",", "_"}], "}"}], "\[Rule]", 
     "9"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "x_", ",", "_", ",", "_"}], "}"}], 
     "\[Rule]", "x"}]}], "}"}], "\n"}], "\n", 
 RowBox[{"Flatten", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4", ",", 
           RowBox[{"18", " ", 
            RowBox[{"(", 
             RowBox[{"1", "-", "a"}], ")"}]}], ",", "6"}], "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{"9", ",", 
           RowBox[{"{", 
            RowBox[{
             SuperscriptBox["2", 
              RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
               RowBox[{
                RowBox[{"2", " ", "r"}], "+", "1"}]}]], "-", "3"}], "}"}]}], 
          "]"}]}], "]"}], ",", 
       RowBox[{"10", "-", 
        RowBox[{"3", " ", "rtab"}]}]}], "}"}], "]"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"9", ",", "1"}], "}"}], ",", 
      RowBox[{"{", "r", "}"}]}], "]"}], ",", "9", ",", "13"}], "}"}], 
  "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"UCAInit", "[", "a_", "]"}], "=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"r", "=", "1"}], ",", 
      RowBox[{"rtab", "=", 
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"90", ",", "2", ",", "8"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", 
              RowBox[{"18", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", "a"}], ")"}]}], ",", "6"}], "}"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{"9", ",", 
              RowBox[{"{", 
               RowBox[{
                SuperscriptBox["2", 
                 RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
                  RowBox[{
                   RowBox[{"2", " ", "r"}], "+", "1"}]}]], "-", "3"}], 
               "}"}]}], "]"}]}], "]"}], ",", 
          RowBox[{"10", "-", 
           RowBox[{"3", " ", "rtab"}]}]}], "}"}], "]"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"9", ",", "1"}], "}"}], ",", 
         RowBox[{"{", "r", "}"}]}], "]"}], ",", "9", ",", "13"}], "}"}], 
     "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "10", ",", 
   RowBox[{"18", " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", "a"}], ")"}]}], ",", "7", ",", "6", ",", "10", ",", 
   "9", ",", "7", ",", "9", ",", "7", ",", "9", ",", "10", ",", "9", ",", "7",
    ",", "9", ",", "10", ",", "9", ",", "1", ",", "9", ",", "13"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.4137343261884604`*^9, 3.413734422846263*^9, 
  3.428254237288571*^9, 3.432324953495603*^9, 3.432325566928721*^9, 
  3.43232578607557*^9, 3.432325828197949*^9, 3.4323264567478952`*^9, 
  3.500211505473015*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"init", "=", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"UCAInit", "[", "0", "]"}], ",", 
        RowBox[{"UCAInit", "[", "1", "]"}], ",", 
        RowBox[{"UCAInit", "[", "0", "]"}]}], "]"}]}], ",", 
     RowBox[{"t", "=", "10"}], ",", 
     RowBox[{"rule", "=", 
      RowBox[{"GeneralCARule", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "3", ",", "7", ",", "18", ",", "_"}], "}"}], 
           "\[Rule]", "12"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "5", ",", 
             RowBox[{"7", "|", "8"}], ",", "0", ",", "_"}], "}"}], "\[Rule]", 
           "12"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "3", ",", "10", ",", "18", ",", "_"}], "}"}], 
           "\[Rule]", "16"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "5", ",", 
             RowBox[{"10", "|", "11"}], ",", "0", ",", "_"}], "}"}], 
           "\[Rule]", "16"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "5", ",", "8", ",", "18", ",", "_"}], "}"}], 
           "\[Rule]", "7"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "5", ",", "14", ",", 
             RowBox[{"0", "|", "18"}], ",", "_"}], "}"}], "\[Rule]", "12"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "8", ",", "5", ",", "_"}], "}"}], 
           "\[Rule]", "7"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "14", ",", "5", ",", "_"}], "}"}], 
           "\[Rule]", "12"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "5", ",", "11", ",", "18", ",", "_"}], "}"}], 
           "\[Rule]", "10"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "5", ",", "17", ",", 
             RowBox[{"0", "|", "18"}], ",", "_"}], "}"}], "\[Rule]", "16"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"11", "|", "17"}], ")"}]}], ",", "5", ",", "_"}], 
            "}"}], "\[Rule]", 
           RowBox[{"x", "-", "1"}]}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", 
             RowBox[{"0", "|", "9", "|", "18"}], ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"7", "|", "10", "|", "16"}], ")"}]}], ",", "3", ",", 
             "_"}], "}"}], "\[Rule]", 
           RowBox[{"x", "+", "1"}]}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", 
             RowBox[{"0", "|", "9", "|", "18"}], ",", "12", ",", "3", ",", 
             "_"}], "}"}], "\[Rule]", "14"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", 
             RowBox[{"0", "|", "9", "|", "18"}], ",", 
             RowBox[{"7", "|", "10", "|", "12", "|", "16"}], ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"3", "|", "5"}], ")"}]}]}], "}"}], "\[Rule]", 
           RowBox[{"8", "-", "x"}]}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "_", ",", 
             RowBox[{"8", "|", "11", "|", "14", "|", "17"}], ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"3", "|", "5"}], ")"}]}]}], "}"}], "\[Rule]", 
           RowBox[{"8", "-", "x"}]}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "13", ",", "4", ",", "_", ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"0", "|", "18"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"18", ",", "_", ",", "4", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "18"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "18", ",", "_", ",", "4"}], "}"}], 
           "\[Rule]", "18"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "_", ",", "4", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "0"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "0", ",", "_", ",", "4"}], "}"}], 
           "\[Rule]", "0"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4", ",", "_", ",", 
             RowBox[{"0", "|", "18"}], ",", "1", ",", "_"}], "}"}], "\[Rule]",
            "3"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4", ",", "_", ",", "_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "4"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "4", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "9"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "4", ",", "12", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "7"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "4", ",", "16", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "10"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"0", "|", "18"}], ")"}]}], ",", "_", ",", "6", ",", 
             "_", ",", "_"}], "}"}], "\[Rule]", "x"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "2", ",", "6", ",", "15", ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"0", "|", "18"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", 
             RowBox[{"12", "|", "16"}], ",", "6", ",", "7", ",", "_"}], "}"}],
            "\[Rule]", "0"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", 
             RowBox[{"12", "|", "16"}], ",", "6", ",", "10", ",", "_"}], 
            "}"}], "\[Rule]", "18"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "9", ",", "10", ",", "6", ",", "_"}], "}"}], 
           "\[Rule]", "16"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "9", ",", "7", ",", "6", ",", "_"}], "}"}], 
           "\[Rule]", "12"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"9", ",", "15", ",", "6", ",", "7", ",", "9"}], "}"}], 
           "\[Rule]", "0"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"9", ",", "15", ",", "6", ",", "10", ",", "9"}], "}"}], 
           "\[Rule]", "18"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"9", ",", "_", ",", "6", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "9"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "6", ",", "7", ",", "9", ",", 
             RowBox[{"12", "|", "16"}]}], "}"}], "\[Rule]", "12"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "6", ",", "10", ",", "9", ",", 
             RowBox[{"12", "|", "16"}]}], "}"}], "\[Rule]", "16"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"12", "|", "16"}], ",", "6", ",", "7", ",", "9", ",", 
             "_"}], "}"}], "\[Rule]", "12"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"12", "|", "16"}], ",", "6", ",", "10", ",", "9", ",", 
             "_"}], "}"}], "\[Rule]", "16"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"6", ",", "13", ",", "_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "9"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"6", ",", "_", ",", "_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "6"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "9", ",", "13", ",", "3"}], "}"}], 
           "\[Rule]", "9"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "9", ",", "13", ",", "3", ",", "_"}], "}"}], 
           "\[Rule]", "15"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "_", ",", "15", ",", "3"}], "}"}], 
           "\[Rule]", "3"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "3", ",", "15", ",", 
             RowBox[{"0", "|", "18"}], ",", "_"}], "}"}], "\[Rule]", "13"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "13", ",", "3", ",", "_", ",", 
             RowBox[{"0", "|", "18"}]}], "}"}], "\[Rule]", "6"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"0", "|", "18"}], ")"}]}], ",", "15", ",", "9", ",", 
             "_", ",", "_"}], "}"}], "\[Rule]", "x"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "6", ",", "13", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "15"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "4", ",", "15", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "13"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "_", ",", "15", ",", "6"}], "}"}], 
           "\[Rule]", "6"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "2", ",", "6", ",", "15"}], "}"}], 
           "\[Rule]", "1"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "1", ",", "6", ",", "_"}], "}"}], 
           "\[Rule]", "2"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "1", ",", "6", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "9"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "3", ",", "2", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "1"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2", ",", "_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "3"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "3", ",", "2", ",", "_"}], "}"}], 
           "\[Rule]", "3"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "1", ",", "9", ",", "1", ",", "6"}], "}"}], 
           "\[Rule]", "6"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "9", ",", "1", ",", "6"}], "}"}], 
           "\[Rule]", "4"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "4", ",", "2", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "1"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"3", "|", "5"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", 
             RowBox[{"3", "|", "5"}], ",", "_", ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"0", "|", "18"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{
               "1", "|", "2", "|", "7", "|", "8", "|", "9", "|", "10", "|", 
                "11", "|", "12", "|", "13", "|", "14", "|", "15", "|", "16", 
                "|", "17"}], ")"}]}], ",", "_", ",", "_"}], "}"}], "\[Rule]", 
           "x"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "18", ",", 
             RowBox[{"7", "|", "10"}], ",", "18"}], "}"}], "\[Rule]", "18"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "0", ",", 
             RowBox[{"7", "|", "10"}], ",", "0"}], "}"}], "\[Rule]", "0"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", 
             RowBox[{"0", "|", "18"}], ",", "_", ",", "_"}], "}"}], "\[Rule]",
            "9"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "x_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "x"}]}], "}"}], ",", "2"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"CAEvolveList", "[", 
    RowBox[{"rule", ",", "init", ",", "t"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "4", ",", "10", ",", "18", ",", "7", ",", "6", ",", "10", ",", "9", ",", 
     "7", ",", "9", ",", "7", ",", "9", ",", "10", ",", "9", ",", "7", ",", 
     "9", ",", "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "4", ",", 
     "10", ",", "0", ",", "7", ",", "6", ",", "10", ",", "9", ",", "7", ",", 
     "9", ",", "7", ",", "9", ",", "10", ",", "9", ",", "7", ",", "9", ",", 
     "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "4", ",", "10", ",", 
     "18", ",", "7", ",", "6", ",", "10", ",", "9", ",", "7", ",", "9", ",", 
     "7", ",", "9", ",", "10", ",", "9", ",", "7", ",", "9", ",", "10", ",", 
     "9", ",", "1", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "10", ",", "4", ",", "7", ",", "18", ",", "10", ",", "6", ",", 
     "7", ",", "9", ",", "7", ",", "9", ",", "10", ",", "9", ",", "7", ",", 
     "9", ",", "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "0", ",", 
     "10", ",", "4", ",", "7", ",", "0", ",", "10", ",", "6", ",", "7", ",", 
     "9", ",", "7", ",", "9", ",", "10", ",", "9", ",", "7", ",", "9", ",", 
     "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "18", ",", "10", ",",
      "4", ",", "7", ",", "18", ",", "10", ",", "6", ",", "7", ",", "9", ",", 
     "7", ",", "9", ",", "10", ",", "9", ",", "7", ",", "9", ",", "10", ",", 
     "9", ",", "1", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "10", ",", "18", ",", "7", ",", "4", ",", "10", ",", "18", ",",
      "7", ",", "6", ",", "7", ",", "9", ",", "10", ",", "9", ",", "7", ",", 
     "9", ",", "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "0", ",", 
     "10", ",", "0", ",", "7", ",", "4", ",", "10", ",", "0", ",", "7", ",", 
     "6", ",", "7", ",", "9", ",", "10", ",", "9", ",", "7", ",", "9", ",", 
     "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "18", ",", "10", ",",
      "18", ",", "7", ",", "4", ",", "10", ",", "18", ",", "7", ",", "6", ",",
      "7", ",", "9", ",", "10", ",", "9", ",", "7", ",", "9", ",", "10", ",", 
     "9", ",", "1", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "10", ",", "18", ",", "7", ",", "18", ",", "10", ",", "4", ",",
      "7", ",", "18", ",", "7", ",", "6", ",", "10", ",", "9", ",", "7", ",", 
     "9", ",", "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "0", ",", 
     "10", ",", "0", ",", "7", ",", "0", ",", "10", ",", "4", ",", "7", ",", 
     "0", ",", "7", ",", "6", ",", "10", ",", "9", ",", "7", ",", "9", ",", 
     "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "18", ",", "10", ",",
      "18", ",", "7", ",", "18", ",", "10", ",", "4", ",", "7", ",", "18", 
     ",", "7", ",", "6", ",", "10", ",", "9", ",", "7", ",", "9", ",", "10", 
     ",", "9", ",", "1", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "10", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", 
     ",", "7", ",", "4", ",", "7", ",", "18", ",", "10", ",", "6", ",", "7", 
     ",", "9", ",", "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "0", 
     ",", "10", ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", 
     ",", "4", ",", "7", ",", "0", ",", "10", ",", "6", ",", "7", ",", "9", 
     ",", "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "18", ",", "10",
      ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", 
     "4", ",", "7", ",", "18", ",", "10", ",", "6", ",", "7", ",", "9", ",", 
     "10", ",", "9", ",", "1", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "10", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", 
     ",", "7", ",", "18", ",", "7", ",", "4", ",", "10", ",", "18", ",", "7", 
     ",", "6", ",", "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "0", 
     ",", "10", ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", 
     ",", "0", ",", "7", ",", "4", ",", "10", ",", "0", ",", "7", ",", "6", 
     ",", "10", ",", "9", ",", "1", ",", "9", ",", "13", ",", "18", ",", "10",
      ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", 
     "18", ",", "7", ",", "4", ",", "10", ",", "18", ",", "7", ",", "6", ",", 
     "10", ",", "9", ",", "1", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "10", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", 
     ",", "7", ",", "18", ",", "7", ",", "18", ",", "10", ",", "4", ",", "7", 
     ",", "18", ",", "10", ",", "6", ",", "1", ",", "9", ",", "13", ",", "0", 
     ",", "10", ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", 
     ",", "0", ",", "7", ",", "0", ",", "10", ",", "4", ",", "7", ",", "0", 
     ",", "10", ",", "6", ",", "1", ",", "9", ",", "13", ",", "18", ",", "10",
      ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", 
     "18", ",", "7", ",", "18", ",", "10", ",", "4", ",", "7", ",", "18", ",",
      "10", ",", "6", ",", "1", ",", "9", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "10", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", 
     ",", "7", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7",
      ",", "4", ",", "10", ",", "18", ",", "1", ",", "6", ",", "13", ",", "0",
      ",", "10", ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", 
     ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", ",", "4", 
     ",", "10", ",", "0", ",", "1", ",", "6", ",", "13", ",", "18", ",", "10",
      ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", 
     "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", "4", ",",
      "10", ",", "18", ",", "1", ",", "6", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "9", ",", "10", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",",
      "7", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", 
     ",", "18", ",", "10", ",", "3", ",", "2", ",", "18", ",", "15", ",", "9",
      ",", "10", ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", 
     ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", ",", "0", 
     ",", "10", ",", "3", ",", "2", ",", "0", ",", "15", ",", "9", ",", "10", 
     ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", 
     "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", "18", 
     ",", "10", ",", "3", ",", "2", ",", "18", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "10", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", 
     ",", "7", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7",
      ",", "5", ",", "11", ",", "3", ",", "1", ",", "3", ",", "15", ",", "18",
      ",", "10", ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", 
     ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", ",", "5", 
     ",", "11", ",", "3", ",", "1", ",", "3", ",", "15", ",", "0", ",", "10", 
     ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", 
     "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", "5", ",",
      "11", ",", "3", ",", "1", ",", "3", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "10", ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", 
     ",", "7", ",", "18", ",", "7", ",", "18", ",", "10", ",", "3", ",", "7", 
     ",", "5", ",", "11", ",", "3", ",", "1", ",", "18", ",", "13", ",", "9", 
     ",", "10", ",", "0", ",", "7", ",", "0", ",", "10", ",", "0", ",", "7", 
     ",", "0", ",", "7", ",", "0", ",", "10", ",", "3", ",", "7", ",", "5", 
     ",", "11", ",", "3", ",", "1", ",", "0", ",", "13", ",", "9", ",", "10", 
     ",", "18", ",", "7", ",", "18", ",", "10", ",", "18", ",", "7", ",", 
     "18", ",", "7", ",", "18", ",", "10", ",", "3", ",", "7", ",", "5", ",", 
     "11", ",", "3", ",", "1", ",", "18", ",", "13"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.413734326267308*^9, 3.413734422902813*^9, 
  3.4282542388170013`*^9, 3.432324953558642*^9, 3.4323255670074673`*^9, 
  3.432325786137178*^9, 3.432325828275405*^9, 3.4323264568099623`*^9, 
  3.500211506642981*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 655 \[CenterDot] More colors", "Subsection"], Cell[
     " (page 1111)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CA3ToCA2", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_", ",", "c_"}], "}"}], "\[Rule]", "d_"}], "]"}], ":=", 
   RowBox[{"Union", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Thread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Flatten", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"l", ",", "a", ",", "b", ",", "c", ",", "r"}], "}"}], 
               "/.", "\[InvisibleSpace]", "coding"}], "]"}], ",", "11", ",", 
             "1"}], "]"}], "\[LeftDoubleBracket]", 
           RowBox[{"{", 
            RowBox[{"2", ",", "3", ",", "4"}], "}"}], 
           "\[RightDoubleBracket]"}], "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"d", "/.", "\[InvisibleSpace]", "coding"}], ")"}]}], "]"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"l", ",", "0", ",", "2"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "0", ",", "2"}], "}"}]}], "]"}], ",", "2"}], "]"}],
     "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"coding", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"0", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ",", 
    RowBox[{"1", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ",", 
    RowBox[{"2", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}]}]}], "}"}]}]}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CA3ToCA2", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a_", ",", "b_", ",", "c_"}], "}"}], "\[Rule]", "d_"}], "]"}], ":=", 
  RowBox[{"Union", "[", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Thread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"l", ",", "a", ",", "b", ",", "c", ",", "r"}], "}"}], "/.",
               "\[InvisibleSpace]", "coding"}], "]"}], ",", "11", ",", "1"}], 
           "]"}], "\[LeftDoubleBracket]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "4"}], "}"}], 
          "\[RightDoubleBracket]"}], "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"d", "/.", "\[InvisibleSpace]", "coding"}], ")"}]}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"l", ",", "0", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "0", ",", "2"}], "}"}]}], "]"}], ",", "2"}], "]"}], 
   "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"coding", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"0", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ",", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"CA3ToCA2", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", "2"}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "0", ",", "0"}], "}"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0"}], "}"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "0"}], "}"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
      "0", ",", "0", ",", "0", ",", "1"}], "}"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "0", ",", "0"}], "}"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0"}], "}"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
      "1", ",", "0", ",", "0", ",", "0"}], "}"}], "\[Rule]", "0"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.413734326348712*^9, 3.413734422983141*^9, 
  3.428254281389867*^9, 3.432324953631487*^9, 3.432325567093771*^9, 
  3.432325786222391*^9, 3.432325828359975*^9, 3.4323264568845797`*^9, 
  3.500211516964237*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Emulating Other Systems with Cellular Automata", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 657 \[CenterDot] Mobile automata", "Subsection"], Cell[
     " (page 1111)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MAToCA", "[", "rules_", "]"}], ":=", 
   RowBox[{"Append", "[", 
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"g", ",", "rules"}], "]"}], "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "x_", ",", "_", ",", "_"}], "}"}], 
      "\[Rule]", "x"}]}], "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a_", ",", "b_", ",", "c_"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"d_", ",", "e_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "a", ",", 
       RowBox[{"b", "+", "2"}], ",", "c", ",", "_"}], "}"}], "\[Rule]", "d"}],
     ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"e", "==", "1"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", 
         RowBox[{"b", "+", "2"}], ",", "c", ",", "_", ",", "_"}], "}"}], 
       "\[Rule]", 
       RowBox[{"c", "+", "2"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "a", ",", 
         RowBox[{"b", "+", "2"}], ",", "c"}], "}"}], "\[Rule]", 
       RowBox[{"a", "+", "2"}]}]}], "]"}]}], "}"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}], "\n", 
 RowBox[{
  RowBox[{"MAToCA", "[", "rules_", "]"}], ":=", 
  RowBox[{"Append", "[", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"Map", "[", 
      RowBox[{"g", ",", "rules"}], "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "x_", ",", "_", ",", "_"}], "}"}], 
     "\[Rule]", "x"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a_", ",", "b_", ",", "c_"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"d_", ",", "e_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "a", ",", 
       RowBox[{"b", "+", "2"}], ",", "c", ",", "_"}], "}"}], "\[Rule]", "d"}],
     ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"e", "==", "1"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", 
         RowBox[{"b", "+", "2"}], ",", "c", ",", "_", ",", "_"}], "}"}], 
       "\[Rule]", 
       RowBox[{"c", "+", "2"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "a", ",", 
         RowBox[{"b", "+", "2"}], ",", "c"}], "}"}], "\[Rule]", 
       RowBox[{"a", "+", "2"}]}]}], "]"}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.513087237770522*^9, 3.513087240277431*^9}, {
  3.513089134087641*^9, 3.5130891354632883`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rule", " ", "=", " ", 
      RowBox[{"GeneralCARule", "[", 
       RowBox[{
        RowBox[{"MAToCA", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "1"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "0"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}]}], "}"}], "]"}], ",", "2"}], 
       "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"CAEvolveList", "[", 
     RowBox[{"rule", ",", " ", 
      RowBox[{"PadRight", "[", 
       RowBox[{
        RowBox[{"PadLeft", "[", 
         RowBox[{
          RowBox[{"{", "2", "}"}], ",", "10"}], "]"}], ",", "20"}], "]"}], 
      ",", " ", "5"}], "]"}]}], "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.520262028659319*^9, 3.520262028818345*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "2", "0", "0", "0", "0", 
     "0", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "2", "1", "0", "0", "0", "0", 
     "0", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "1", "3", "0", "0", "0", "0", 
     "0", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "2", "0", "0", "0", 
     "0", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "1", "2", "1", "0", "0", "0", 
     "0", "0", "0", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "3", "1", "1", "0", "0", "0", 
     "0", "0", "0", "0", "0", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.5130891461186657`*^9, 3.5202620318410378`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 658 \[CenterDot] Turing machines", "Subsection"], Cell[
     " (page 1111)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TMToCA", "[", 
    RowBox[{"rules_", ",", 
     RowBox[{"k_", ":", "2"}]}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"#", ",", "k"}], "]"}], "&"}], ",", "rules"}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], "}"}], 
    "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"s_", ",", "a_"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"sp_", ",", "ap_", ",", "d_"}], "}"}]}], ",", "k_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"d", "==", "1"}], ",", "Identity", ",", "Reverse"}], "]"}], 
      "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"k", " ", "s"}], "+", "a"}], ",", "x_", ",", "_"}], "}"}], 
      "]"}], "\[Rule]", 
     RowBox[{
      RowBox[{"k", " ", "sp"}], "+", "x"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{
        RowBox[{"k", " ", "s"}], "+", "a"}], ",", "_"}], "}"}], "\[Rule]", 
     "ap"}]}], "}"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}], "\n", 
 RowBox[{
  RowBox[{"TMToCA", "[", 
   RowBox[{"rules_", ",", 
    RowBox[{"k_", ":", "2"}]}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"g", "[", 
         RowBox[{"#", ",", "k"}], "]"}], "&"}], ",", "rules"}], "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], "}"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"s_", ",", "a_"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"sp_", ",", "ap_", ",", "d_"}], "}"}]}], ",", "k_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"d", "==", "1"}], ",", "Identity", ",", "Reverse"}], "]"}], 
      "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"k", " ", "s"}], "+", "a"}], ",", "x_", ",", "_"}], "}"}], 
      "]"}], "\[Rule]", 
     RowBox[{
      RowBox[{"k", " ", "sp"}], "+", "x"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{
        RowBox[{"k", " ", "s"}], "+", "a"}], ",", "_"}], "}"}], "\[Rule]", 
     "ap"}]}], "}"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"TMToCA", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"3", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "0", ",", "1"}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"3", ",", "1", ",", "1"}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", 
           RowBox[{"-", "1"}]}], "}"}]}]}], "}"}], "]"}], "]"}], ",", " ", 
    RowBox[{"ReplacePart", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "15", "}"}]}], "]"}], ",", "2", ",", "5"}], "]"}], ",", 
    "10"}], "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.513087249704514*^9, 3.513087251962989*^9}, 
   3.520262039465253*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "2", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "6", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "1", "5", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "1", "1", "6", "0", "0", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "1", "1", "1", "4", "0", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "1", "1", "1", "1", "2", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "1", "1", "1", "7", "1", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "1", "1", "3", "0", "1", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "1", "1", "0", "4", "1", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "1", "1", "0", "1", "3", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "1", "1", "0", "1", "0", "4", "0", "0", "0", "0", "0", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.4137343264831247`*^9, 3.413734423115094*^9, 
  3.428254307633094*^9, 3.4323249537649307`*^9, 3.432325567247517*^9, 
  3.432325786355687*^9, 3.432325828494547*^9, 3.432326457051458*^9, 
  3.500211530238145*^9, 3.513087254995802*^9, 3.520262041441004*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 659 \[CenterDot] Substitution systems\
\>", "Subsection"], Cell[" (page 1111)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SSToCA", "[", "rules_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"b", ",", "b", ",", 
        RowBox[{"p", "[", 
         RowBox[{"x_", ",", "_"}], "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"s", "[", "x", "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"s", "[", 
         RowBox[{"v", ":", 
          RowBox[{"(", 
           RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", 
        RowBox[{"p", "[", 
         RowBox[{"x_", ",", "_"}], "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"p", "[", 
       RowBox[{"v", ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"p", "[", 
         RowBox[{"_", ",", "y_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"s", "[", "y", "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"s", "[", 
         RowBox[{"v", ":", 
          RowBox[{"(", 
           RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_m"}], "}"}], 
      "\[Rule]", 
      RowBox[{"m", "[", "v", "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"s", "[", 
         RowBox[{"0", "|", "1"}], "]"}], ",", 
        RowBox[{"m", "[", 
         RowBox[{"v", ":", 
          RowBox[{"(", 
           RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_"}], "}"}], 
      "\[Rule]", 
      RowBox[{"s", "[", "v", "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"b", ",", 
        RowBox[{"m", "[", 
         RowBox[{"v", ":", 
          RowBox[{"(", 
           RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_"}], "}"}], 
      "\[Rule]", 
      RowBox[{"r", "[", "v", "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"r", "[", 
         RowBox[{"v", ":", 
          RowBox[{"(", 
           RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_"}], "}"}], 
      "\[RuleDelayed]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Replace", "[", 
         RowBox[{"v", ",", "rules"}], "]"}], "/.", "\[InvisibleSpace]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"{", "x_", "}"}], "\[Rule]", 
           RowBox[{"s", "[", "x", "]"}]}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x_", ",", "y_"}], "}"}], "\[Rule]", 
           RowBox[{"p", "[", 
            RowBox[{"x", ",", "y"}], "]"}]}]}], "}"}]}], ")"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_r", ",", 
        RowBox[{"s", "[", 
         RowBox[{"v", ":", 
          RowBox[{"(", 
           RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_"}], "}"}], 
      "\[Rule]", 
      RowBox[{"r", "[", "v", "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_r", ",", "b", ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"m", "[", "b", "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"s", "[", 
         RowBox[{"0", "|", "1"}], "]"}], ",", 
        RowBox[{"m", "[", "b", "]"}], ",", "_"}], "}"}], "\[Rule]", "b"}], 
     ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "v_", ",", "_"}], "}"}], "\[Rule]", "v"}]}], "}"}]}],
   "\[IndentingNewLine]"}], "\n", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"b", "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{"s", "[", "0", "]"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"m", "[", "0", "]"}], "\[Rule]", "2"}], ",", 
   RowBox[{
    RowBox[{"p", "[", 
     RowBox[{"0", ",", "0"}], "]"}], "\[Rule]", "3"}], ",", 
   RowBox[{
    RowBox[{"r", "[", "0", "]"}], "\[Rule]", "4"}], ",", 
   RowBox[{
    RowBox[{"p", "[", 
     RowBox[{"0", ",", "1"}], "]"}], "\[Rule]", "5"}], ",", 
   RowBox[{
    RowBox[{"p", "[", 
     RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", "6"}], ",", 
   RowBox[{
    RowBox[{"r", "[", "1", "]"}], "\[Rule]", "7"}], ",", 
   RowBox[{
    RowBox[{"p", "[", 
     RowBox[{"1", ",", "1"}], "]"}], "\[Rule]", "8"}], ",", 
   RowBox[{
    RowBox[{"m", "[", "1", "]"}], "\[Rule]", "9"}], ",", 
   RowBox[{
    RowBox[{"m", "[", "b", "]"}], "\[Rule]", "10"}], ",", 
   RowBox[{
    RowBox[{"s", "[", "1", "]"}], "\[Rule]", "11"}]}], 
  "}"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}], "\n", 
 RowBox[{
  RowBox[{"SSToCA", "[", "rules_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"b", ",", "b", ",", 
       RowBox[{"p", "[", 
        RowBox[{"x_", ",", "_"}], "]"}]}], "}"}], "\[Rule]", 
     RowBox[{"s", "[", "x", "]"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"s", "[", 
        RowBox[{"v", ":", 
         RowBox[{"(", 
          RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", 
       RowBox[{"p", "[", 
        RowBox[{"x_", ",", "_"}], "]"}]}], "}"}], "\[Rule]", 
     RowBox[{"p", "[", 
      RowBox[{"v", ",", "x"}], "]"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"p", "[", 
        RowBox[{"_", ",", "y_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"s", "[", "y", "]"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"s", "[", 
        RowBox[{"v", ":", 
         RowBox[{"(", 
          RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_m"}], "}"}], 
     "\[Rule]", 
     RowBox[{"m", "[", "v", "]"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"s", "[", 
        RowBox[{"0", "|", "1"}], "]"}], ",", 
       RowBox[{"m", "[", 
        RowBox[{"v", ":", 
         RowBox[{"(", 
          RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_"}], "}"}], 
     "\[Rule]", 
     RowBox[{"s", "[", "v", "]"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"b", ",", 
       RowBox[{"m", "[", 
        RowBox[{"v", ":", 
         RowBox[{"(", 
          RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_"}], "}"}], 
     "\[Rule]", 
     RowBox[{"r", "[", "v", "]"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"r", "[", 
        RowBox[{"v", ":", 
         RowBox[{"(", 
          RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_"}], "}"}], 
     "\[RuleDelayed]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Replace", "[", 
        RowBox[{"v", ",", "rules"}], "]"}], "/.", "\[InvisibleSpace]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "x_", "}"}], "\[Rule]", 
          RowBox[{"s", "[", "x", "]"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x_", ",", "y_"}], "}"}], "\[Rule]", 
          RowBox[{"p", "[", 
           RowBox[{"x", ",", "y"}], "]"}]}]}], "}"}]}], ")"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_r", ",", 
       RowBox[{"s", "[", 
        RowBox[{"v", ":", 
         RowBox[{"(", 
          RowBox[{"0", "|", "1"}], ")"}]}], "]"}], ",", "_"}], "}"}], 
     "\[Rule]", 
     RowBox[{"r", "[", "v", "]"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_r", ",", "b", ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"m", "[", "b", "]"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"s", "[", 
        RowBox[{"0", "|", "1"}], "]"}], ",", 
       RowBox[{"m", "[", "b", "]"}], ",", "_"}], "}"}], "\[Rule]", "b"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "v_", ",", "_"}], "}"}], "\[Rule]", "v"}]}], 
   "}"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CAEvolveList", "[", 
    RowBox[{
     RowBox[{"GeneralCARule", "[", 
      RowBox[{"SSToCA", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "\[Rule]", 
          RowBox[{"{", "0", "}"}]}], ",", " ", 
         RowBox[{"0", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}]}], "}"}], "]"}], "]"}], ",", " ", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{"b", ",", 
         RowBox[{"{", "8", "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", "[", "0", "]"}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{"b", ",", 
         RowBox[{"{", "3", "}"}]}], "]"}]}], "]"}], ",", " ", "20"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"b", "\[Rule]", "0"}], ",", 
     RowBox[{
      RowBox[{"s", "[", "0", "]"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"m", "[", "0", "]"}], "\[Rule]", "2"}], ",", 
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"0", ",", "0"}], "]"}], "\[Rule]", "3"}], ",", 
     RowBox[{
      RowBox[{"r", "[", "0", "]"}], "\[Rule]", "4"}], ",", 
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"0", ",", "1"}], "]"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"r", "[", "1", "]"}], "\[Rule]", "7"}], ",", 
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"1", ",", "1"}], "]"}], "\[Rule]", "8"}], ",", 
     RowBox[{
      RowBox[{"m", "[", "1", "]"}], "\[Rule]", "9"}], ",", 
     RowBox[{
      RowBox[{"m", "[", "b", "]"}], "\[Rule]", "10"}], ",", 
     RowBox[{
      RowBox[{"s", "[", "1", "]"}], "\[Rule]", "11"}]}], "}"}]}], "//", 
  "Grid"}]], "Input",
 CellChangeTimes->{{3.513087260770039*^9, 3.513087263164817*^9}, {
  3.5202620479305964`*^9, 3.52026204845498*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "0", "0", "0", "2", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "4", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "5", "10", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "1", "11", "10", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "1", "9", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "2", "11", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "4", "11", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "5", "7", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "1", "11", "1", "10", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "1", "11", "2", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "1", "9", "1", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "2", "11", "1", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "4", "11", "1", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "5", "7", "1", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "1", "11", "1", "4", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "1", "11", "1", "5", "10", "0", "0"},
    {"0", "0", "0", "0", "0", "1", "11", "3", "11", "10", "0", "0"},
    {"0", "0", "0", "0", "0", "1", "6", "1", "9", "0", "0", "0"},
    {"0", "0", "0", "0", "0", "5", "1", "2", "11", "0", "0", "0"},
    {"0", "0", "0", "0", "1", "11", "2", "1", "11", "0", "0", "0"},
    {"0", "0", "0", "0", "1", "9", "1", "1", "11", "0", "0", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.413734328200466*^9, 3.413734423188786*^9, {3.428254330025104*^9, 
   3.428254358797163*^9}, 3.432324953848124*^9, 3.432325567348846*^9, 
   3.432325786439142*^9, 3.432325828579568*^9, 3.432326457151932*^9, 
   3.500211544651129*^9, 3.513087265962976*^9, 3.520262050724141*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 660 \[CenterDot] Sequential substitution systems\
\>", "Subsection"], Cell[" (page 1111)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SSSToCA", "[", "rules_", "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"v", "[", 
         RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "u", ",", "_"}], 
       "}"}], "\[Rule]", "u"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"v", "[", 
         RowBox[{"rn_", ",", "x_", ",", "_"}], "]"}], ",", "u"}], "}"}], 
      "\[Rule]", 
      RowBox[{"r", "[", 
       RowBox[{
        RowBox[{"rn", "+", "1"}], ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"v", "[", 
         RowBox[{"_", ",", "x_", ",", "_"}], "]"}], ",", "_"}], "}"}], 
      "\[Rule]", "x"}], ",", 
     RowBox[{"MapIndexed", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"rn", "=", 
             RowBox[{
             "#2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
            ",", 
            RowBox[{"rs", "=", 
             RowBox[{
             "#1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
            ",", 
            RowBox[{"rr", "=", 
             RowBox[{
             "#1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}]}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", "rs", "]"}], "==", "1"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"u", ",", 
                 RowBox[{"r", "[", 
                  RowBox[{"rn", ",", 
                   RowBox[{"First", "[", "rs", "]"}]}], "]"}], ",", "_"}], 
                "}"}], "\[Rule]", 
               RowBox[{"q", "[", 
                RowBox[{"0", ",", "rr"}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"u", ",", 
                 RowBox[{"r", "[", 
                  RowBox[{"rn", ",", 
                   RowBox[{"First", "[", "rs", "]"}]}], "]"}], ",", "_"}], 
                "}"}], "\[Rule]", 
               RowBox[{"v", "[", 
                RowBox[{"rn", ",", 
                 RowBox[{"First", "[", "rs", "]"}], ",", 
                 RowBox[{"Take", "[", 
                  RowBox[{"rs", ",", "1"}], "]"}]}], "]"}]}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"u", ",", 
               RowBox[{"r", "[", 
                RowBox[{"rn", ",", "x_"}], "]"}], ",", "_"}], "}"}], 
             "\[Rule]", 
             RowBox[{"v", "[", 
              RowBox[{"rn", ",", "x", ",", 
               RowBox[{"{", "}"}]}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"v", "[", 
                RowBox[{"rn", ",", "_", ",", 
                 RowBox[{"Drop", "[", 
                  RowBox[{"rs", ",", 
                   RowBox[{"-", "1"}]}], "]"}]}], "]"}], ",", 
               RowBox[{"Last", "[", "rs", "]"}], ",", "_"}], "}"}], "\[Rule]", 
             RowBox[{"q", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "[", "rs", "]"}], "-", "1"}], ",", "rr"}], 
              "]"}]}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"v", "[", 
                  RowBox[{"rn", ",", "_", ",", 
                   RowBox[{"Flatten", "[", 
                    RowBox[{"{", 
                    RowBox[{"___", ",", 
                    RowBox[{"Take", "[", 
                    RowBox[{"rs", ",", 
                    RowBox[{"i", "-", "1"}]}], "]"}]}], "}"}], "]"}]}], "]"}],
                  ",", 
                 RowBox[{
                 "rs", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}],
                  ",", "_"}], "}"}], "\[Rule]", 
               RowBox[{"v", "[", 
                RowBox[{"rn", ",", 
                 RowBox[{
                 "rs", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}],
                  ",", 
                 RowBox[{"Take", "[", 
                  RowBox[{"rs", ",", "i"}], "]"}]}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "rs", "]"}], "-", "1"}], ",", "1", 
                ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"v", "[", 
                RowBox[{"rn", ",", "_", ",", "_"}], "]"}], ",", "y_", ",", 
               "_"}], "}"}], "\[Rule]", 
             RowBox[{"v", "[", 
              RowBox[{"rn", ",", "y", ",", 
               RowBox[{"{", "}"}]}], "]"}]}]}], "}"}]}], "]"}], "&"}], ",", 
       RowBox[{"rules", "/.", "\[InvisibleSpace]", 
        RowBox[{"s", "\[Rule]", "List"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"x__", ",", "_"}], "}"}]}], "]"}], ",", "_"}], "}"}], 
      "\[Rule]", 
      RowBox[{"q", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "x", "}"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", "x_", "}"}]}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"r", "[", 
       RowBox[{"1", ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", "}"}]}], "]"}], ",", "x_"}], "}"}], "\[Rule]", 
      RowBox[{"r", "[", 
       RowBox[{"1", ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", 
           RowBox[{"___", ",", "x_"}], "}"}]}], "]"}], ",", "_"}], "}"}], 
      "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", "}"}]}], "]"}], ",", "x_"}], "}"}], "\[Rule]", "x"}], 
     ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "x_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"0", ",", "_"}], "]"}]}], "}"}], "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"n_", ",", 
          RowBox[{"{", "}"}]}], "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"q", "[", 
       RowBox[{
        RowBox[{"n", "-", "1"}], ",", 
        RowBox[{"{", "}"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"n_", ",", 
          RowBox[{"{", 
           RowBox[{"x___", ",", "_"}], "}"}]}], "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"q", "[", 
       RowBox[{
        RowBox[{"n", "-", "1"}], ",", 
        RowBox[{"{", "x", "}"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"q", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", "}"}]}], "]"}], ",", "_", ",", "_"}], "}"}], "\[Rule]",
       "w"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"__", ",", "x_"}], "}"}]}], "]"}], ",", 
        RowBox[{"p", "[", 
         RowBox[{"y_", ",", "_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"p", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"__", ",", "x_"}], "}"}]}], "]"}], ",", "y_", ",", "_"}], 
       "}"}], "\[Rule]", 
      RowBox[{"p", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{"_", ",", "x_"}], "]"}], ",", 
        RowBox[{"p", "[", 
         RowBox[{"y_", ",", "_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"p", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{"_", ",", "x_"}], "]"}], ",", "u", ",", "_"}], "}"}], 
      "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{"_", ",", "x_"}], "]"}], ",", "y_", ",", "_"}], "}"}], 
      "\[Rule]", 
      RowBox[{"p", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"p", "[", 
         RowBox[{"x_", ",", "_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", "x"}],
      ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", ",", "u", ",", "_"}], "}"}], "\[Rule]", "u"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "w"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "w", ",", "x_"}], "}"}], "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"r", "[", 
         RowBox[{"rn_", ",", "x_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
      "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "u", ",", 
        RowBox[{"r", "[", 
         RowBox[{"_", ",", "_"}], "]"}]}], "}"}], "\[Rule]", "u"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "x_", ",", 
        RowBox[{"r", "[", 
         RowBox[{"rn_", ",", "_"}], "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"r", "[", 
       RowBox[{"rn", ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], "}"}], 
   "]"}]}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}], "\n", 
 RowBox[{
  RowBox[{"SSSToCA", "[", "rules_", "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"v", "[", 
         RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "u", ",", "_"}], 
       "}"}], "\[Rule]", "u"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"v", "[", 
         RowBox[{"rn_", ",", "x_", ",", "_"}], "]"}], ",", "u"}], "}"}], 
      "\[Rule]", 
      RowBox[{"r", "[", 
       RowBox[{
        RowBox[{"rn", "+", "1"}], ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"v", "[", 
         RowBox[{"_", ",", "x_", ",", "_"}], "]"}], ",", "_"}], "}"}], 
      "\[Rule]", "x"}], ",", 
     RowBox[{"MapIndexed", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"rn", "=", 
             RowBox[{
             "#2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
            ",", 
            RowBox[{"rs", "=", 
             RowBox[{
             "#1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
            ",", 
            RowBox[{"rr", "=", 
             RowBox[{
             "#1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}]}],
            "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", "rs", "]"}], "==", "1"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"u", ",", 
                 RowBox[{"r", "[", 
                  RowBox[{"rn", ",", 
                   RowBox[{"First", "[", "rs", "]"}]}], "]"}], ",", "_"}], 
                "}"}], "\[Rule]", 
               RowBox[{"q", "[", 
                RowBox[{"0", ",", "rr"}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"u", ",", 
                 RowBox[{"r", "[", 
                  RowBox[{"rn", ",", 
                   RowBox[{"First", "[", "rs", "]"}]}], "]"}], ",", "_"}], 
                "}"}], "\[Rule]", 
               RowBox[{"v", "[", 
                RowBox[{"rn", ",", 
                 RowBox[{"First", "[", "rs", "]"}], ",", 
                 RowBox[{"Take", "[", 
                  RowBox[{"rs", ",", "1"}], "]"}]}], "]"}]}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"u", ",", 
               RowBox[{"r", "[", 
                RowBox[{"rn", ",", "x_"}], "]"}], ",", "_"}], "}"}], 
             "\[Rule]", 
             RowBox[{"v", "[", 
              RowBox[{"rn", ",", "x", ",", 
               RowBox[{"{", "}"}]}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"v", "[", 
                RowBox[{"rn", ",", "_", ",", 
                 RowBox[{"Drop", "[", 
                  RowBox[{"rs", ",", 
                   RowBox[{"-", "1"}]}], "]"}]}], "]"}], ",", 
               RowBox[{"Last", "[", "rs", "]"}], ",", "_"}], "}"}], "\[Rule]", 
             RowBox[{"q", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "[", "rs", "]"}], "-", "1"}], ",", "rr"}], 
              "]"}]}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"v", "[", 
                  RowBox[{"rn", ",", "_", ",", 
                   RowBox[{"Flatten", "[", 
                    RowBox[{"{", 
                    RowBox[{"___", ",", 
                    RowBox[{"Take", "[", 
                    RowBox[{"rs", ",", 
                    RowBox[{"i", "-", "1"}]}], "]"}]}], "}"}], "]"}]}], "]"}],
                  ",", 
                 RowBox[{
                 "rs", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}],
                  ",", "_"}], "}"}], "\[Rule]", 
               RowBox[{"v", "[", 
                RowBox[{"rn", ",", 
                 RowBox[{
                 "rs", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}],
                  ",", 
                 RowBox[{"Take", "[", 
                  RowBox[{"rs", ",", "i"}], "]"}]}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "rs", "]"}], "-", "1"}], ",", "1", 
                ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"v", "[", 
                RowBox[{"rn", ",", "_", ",", "_"}], "]"}], ",", "y_", ",", 
               "_"}], "}"}], "\[Rule]", 
             RowBox[{"v", "[", 
              RowBox[{"rn", ",", "y", ",", 
               RowBox[{"{", "}"}]}], "]"}]}]}], "}"}]}], "]"}], "&"}], ",", 
       RowBox[{"rules", "/.", "\[InvisibleSpace]", 
        RowBox[{"s", "\[Rule]", "List"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"x__", ",", "_"}], "}"}]}], "]"}], ",", "_"}], "}"}], 
      "\[Rule]", 
      RowBox[{"q", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "x", "}"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", "x_", "}"}]}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"r", "[", 
       RowBox[{"1", ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", "}"}]}], "]"}], ",", "x_"}], "}"}], "\[Rule]", 
      RowBox[{"r", "[", 
       RowBox[{"1", ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", 
           RowBox[{"___", ",", "x_"}], "}"}]}], "]"}], ",", "_"}], "}"}], 
      "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", "}"}]}], "]"}], ",", "x_"}], "}"}], "\[Rule]", "x"}], 
     ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "x_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"0", ",", "_"}], "]"}]}], "}"}], "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"n_", ",", 
          RowBox[{"{", "}"}]}], "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"q", "[", 
       RowBox[{
        RowBox[{"n", "-", "1"}], ",", 
        RowBox[{"{", "}"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", 
        RowBox[{"q", "[", 
         RowBox[{"n_", ",", 
          RowBox[{"{", 
           RowBox[{"x___", ",", "_"}], "}"}]}], "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"q", "[", 
       RowBox[{
        RowBox[{"n", "-", "1"}], ",", 
        RowBox[{"{", "x", "}"}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"q", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", "}"}]}], "]"}], ",", "_", ",", "_"}], "}"}], "\[Rule]",
       "w"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"__", ",", "x_"}], "}"}]}], "]"}], ",", 
        RowBox[{"p", "[", 
         RowBox[{"y_", ",", "_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"p", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"q", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"__", ",", "x_"}], "}"}]}], "]"}], ",", "y_", ",", "_"}], 
       "}"}], "\[Rule]", 
      RowBox[{"p", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{"_", ",", "x_"}], "]"}], ",", 
        RowBox[{"p", "[", 
         RowBox[{"y_", ",", "_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"p", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{"_", ",", "x_"}], "]"}], ",", "u", ",", "_"}], "}"}], 
      "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{"_", ",", "x_"}], "]"}], ",", "y_", ",", "_"}], "}"}], 
      "\[Rule]", 
      RowBox[{"p", "[", 
       RowBox[{"x", ",", "y"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"p", "[", 
         RowBox[{"x_", ",", "_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", "x"}],
      ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", ",", "u", ",", "_"}], "}"}], "\[Rule]", "u"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "w"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "w", ",", "x_"}], "}"}], "\[Rule]", "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"r", "[", 
         RowBox[{"rn_", ",", "x_"}], "]"}], ",", "_"}], "}"}], "\[Rule]", 
      "x"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "u", ",", 
        RowBox[{"r", "[", 
         RowBox[{"_", ",", "_"}], "]"}]}], "}"}], "\[Rule]", "u"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "x_", ",", 
        RowBox[{"r", "[", 
         RowBox[{"rn_", ",", "_"}], "]"}]}], "}"}], "\[Rule]", 
      RowBox[{"r", "[", 
       RowBox[{"rn", ",", "x"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], "}"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.520262794844214*^9, 3.5202627957538*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"s", "[", 
   RowBox[{"1", ",", "0", ",", "0"}], "]"}], "/.", 
  RowBox[{
   RowBox[{"s", "[", 
    RowBox[{"x_", ",", "y__"}], "]"}], "\[Rule]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"r", "[", 
      RowBox[{"1", ",", "x"}], "]"}], ",", "y"}], "}"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"r", "[", 
    RowBox[{"1", ",", "1"}], "]"}], ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.413734328354679*^9, 3.413734423245187*^9, 
  3.428254418955339*^9, 3.432324953931189*^9, 3.4323255674462757`*^9, 
  3.432325786523432*^9, 3.432325828677661*^9, 3.432326457253858*^9, 
  3.500211551629478*^9, 3.5202628014059067`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CAEvolveList", "[", 
  RowBox[{
   RowBox[{"GeneralCARule", "[", 
    RowBox[{
     RowBox[{"SSSToCA", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"1", ",", "1", ",", "0"}], "]"}], "\[Rule]", 
         RowBox[{"s", "[", 
          RowBox[{"1", ",", "1"}], "]"}]}], ",", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
         RowBox[{"s", "[", 
          RowBox[{"0", ",", "1", ",", "1"}], "]"}]}]}], "}"}], "]"}], ",", 
     "1"}], "]"}], ",", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", ",", "u"}], "}"}], ",", 
     RowBox[{
      RowBox[{"s", "[", 
       RowBox[{"1", ",", "0", ",", "0"}], "]"}], "/.", 
      RowBox[{
       RowBox[{"s", "[", 
        RowBox[{"x_", ",", "y__"}], "]"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r", "[", 
          RowBox[{"1", ",", "x"}], "]"}], ",", "y"}], "}"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", "u", ",", "u"}], "}"}]}], "]"}], ",", "12"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", 
     RowBox[{"r", "[", 
      RowBox[{"1", ",", "1"}], "]"}], ",", "0", ",", "0", ",", "u", ",", "u", 
     ",", "u"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", 
     RowBox[{"v", "[", 
      RowBox[{"1", ",", "1", ",", 
       RowBox[{"{", "1", "}"}]}], "]"}], ",", "0", ",", "0", ",", "u", ",", 
     "u", ",", "u"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", "1", ",", 
     RowBox[{"v", "[", 
      RowBox[{"1", ",", "0", ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", "0", ",", "u", ",", "u", ",", "u"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", "1", ",", "0", ",", 
     RowBox[{"v", "[", 
      RowBox[{"1", ",", "0", ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", "u", ",", "u", ",", "u"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", "1", ",", "0", ",", 
     RowBox[{"r", "[", 
      RowBox[{"2", ",", "0"}], "]"}], ",", "u", ",", "u", ",", "u"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", "1", ",", 
     RowBox[{"r", "[", 
      RowBox[{"2", ",", "0"}], "]"}], ",", "0", ",", "u", ",", "u", ",", 
     "u"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", 
     RowBox[{"r", "[", 
      RowBox[{"2", ",", "1"}], "]"}], ",", "0", ",", "0", ",", "u", ",", "u", 
     ",", "u"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", 
     RowBox[{"v", "[", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"{", "1", "}"}]}], "]"}], ",", "0", ",", "0", ",", "u", ",", 
     "u", ",", "u"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", "1", ",", 
     RowBox[{"q", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "]"}], ",", "0", ",", "u",
      ",", "u", ",", "u"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", 
     RowBox[{"q", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "]"}], ",", "1", ",", "0", ",", "u",
      ",", "u", ",", "u"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", 
     RowBox[{"q", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", "0", "}"}]}], "]"}], ",", 
     RowBox[{"p", "[", 
      RowBox[{"1", ",", "1"}], "]"}], ",", "0", ",", "u", ",", "u", ",", 
     "u"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", 
     RowBox[{"r", "[", 
      RowBox[{"1", ",", "0"}], "]"}], ",", "1", ",", 
     RowBox[{"p", "[", 
      RowBox[{"1", ",", "0"}], "]"}], ",", "u", ",", "u", ",", "u"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "u", ",", 
     RowBox[{"v", "[", 
      RowBox[{"1", ",", "0", ",", 
       RowBox[{"{", "}"}]}], "]"}], ",", "1", ",", "1", ",", "0", ",", "u", 
     ",", "u"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413734328428483*^9, 3.413734423317999*^9, 
  3.428254420265883*^9, 3.432324953972845*^9, 3.432325567525133*^9, 
  3.432325786584902*^9, 3.432325828740355*^9, 3.432326457330862*^9, 
  3.500211553734563*^9, 3.520262802256509*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 661 \[CenterDot] Register machines", "Subsection"], Cell[
     " (page 1112)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"i", "[", "1", "]"}], ",", "p_", ",", "m_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "p", ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"p", "+", "1"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "0", ",", "p"}], "}"}], "\[Rule]", 
      RowBox[{"m", "+", "2"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "p"}], "}"}], "\[Rule]", 
      RowBox[{"m", "+", "3"}]}]}], "}"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"i", "[", "2", "]"}], ",", "p_", ",", "m_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "p", ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"p", "+", "1"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p", ",", "0", ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"m", "+", "5"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p", ",", "_", ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"m", "+", "6"}]}]}], "}"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"d", "[", 
      RowBox[{"1", ",", "q_"}], "]"}], ",", "p_", ",", "m_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"m", "+", "2"}], "|", 
         RowBox[{"m", "+", "3"}]}], ",", "p", ",", "_"}], "}"}], "\[Rule]", 
      "q"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"m", "+", "1"}], ",", "p", ",", "_"}], "}"}], "\[Rule]", 
      "p"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "p", ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"p", "+", "1"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{
         RowBox[{"m", "+", "2"}], "|", 
         RowBox[{"m", "+", "3"}]}], ",", "p"}], "}"}], "\[Rule]", 
      RowBox[{"m", "+", "1"}]}]}], "}"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{
     RowBox[{"d", "[", 
      RowBox[{"2", ",", "q_"}], "]"}], ",", "p_", ",", "m_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "p", ",", 
        RowBox[{
         RowBox[{"m", "+", "5"}], "|", 
         RowBox[{"m", "+", "6"}]}]}], "}"}], "\[Rule]", "q"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "p", ",", 
        RowBox[{"m", "+", "4"}]}], "}"}], "\[Rule]", "p"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "p", ",", "0"}], "}"}], "\[Rule]", 
      RowBox[{"p", "+", "1"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"p", ",", 
        RowBox[{
         RowBox[{"m", "+", "5"}], "|", 
         RowBox[{"m", "+", "6"}]}], ",", "_"}], "}"}], "\[Rule]", 
      RowBox[{"m", "+", "4"}]}]}], "}"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"RMToCA", "[", "prog_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", "=", 
      RowBox[{"Length", "[", "prog", "]"}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"MapIndexed", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"#1", ",", 
            RowBox[{"First", "[", "#2", "]"}], ",", "m"}], "]"}], "&"}], ",", 
         "prog"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"0", "|", 
             RowBox[{"m", "+", "1"}]}], ",", 
            RowBox[{"m", "+", "3"}]}], "}"}], "\[Rule]", 
          RowBox[{"m", "+", "2"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"m", "+", "1"}], ",", "_"}], "}"}], "\[Rule]", "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", 
            RowBox[{"m", "+", "1"}]}], "}"}], "\[Rule]", "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", 
            RowBox[{"x", ":", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"m", "+", "1"}], "|", 
               RowBox[{"m", "+", "3"}]}], ")"}]}]}], "}"}], "\[Rule]", "x"}], 
         ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{
             RowBox[{"m", "+", "1"}], "|", 
             RowBox[{"m", "+", "3"}]}], ",", "_"}], "}"}], "\[Rule]", 
          RowBox[{"m", "+", "2"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"m", "+", "6"}], ",", 
            RowBox[{"0", "|", 
             RowBox[{"m", "+", "4"}]}], ",", "0"}], "}"}], "\[Rule]", 
          RowBox[{"m", "+", "5"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"m", "+", "4"}], ",", "0"}], "}"}], "\[Rule]", "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"m", "+", "4"}], ",", "0", ",", "0"}], "}"}], "\[Rule]", 
          "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x", ":", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"m", "+", "4"}], "|", 
               RowBox[{"m", "+", "6"}]}], ")"}]}], ",", "_", ",", "_"}], 
           "}"}], "\[Rule]", "x"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{
             RowBox[{"m", "+", "4"}], "|", 
             RowBox[{"m", "+", "6"}]}], ",", "_"}], "}"}], "\[Rule]", 
          RowBox[{"m", "+", "5"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], 
        "}"}]}], "}"}], "]"}]}], "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}], "\n", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{"i", "[", "1", "]"}], ",", "p_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "p", ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"p", "+", "1"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "0", ",", "p"}], "}"}], "\[Rule]", 
     RowBox[{"m", "+", "2"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "p"}], "}"}], "\[Rule]", 
     RowBox[{"m", "+", "3"}]}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{"i", "[", "2", "]"}], ",", "p_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "p", ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"p", "+", "1"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p", ",", "0", ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"m", "+", "5"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p", ",", "_", ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"m", "+", "6"}]}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"1", ",", "q_"}], "]"}], ",", "p_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"m", "+", "2"}], "|", 
        RowBox[{"m", "+", "3"}]}], ",", "p", ",", "_"}], "}"}], "\[Rule]", 
     "q"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"m", "+", "1"}], ",", "p", ",", "_"}], "}"}], "\[Rule]", "p"}],
     ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "p", ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"p", "+", "1"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{
        RowBox[{"m", "+", "2"}], "|", 
        RowBox[{"m", "+", "3"}]}], ",", "p"}], "}"}], "\[Rule]", 
     RowBox[{"m", "+", "1"}]}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"2", ",", "q_"}], "]"}], ",", "p_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "p", ",", 
       RowBox[{
        RowBox[{"m", "+", "5"}], "|", 
        RowBox[{"m", "+", "6"}]}]}], "}"}], "\[Rule]", "q"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "p", ",", 
       RowBox[{"m", "+", "4"}]}], "}"}], "\[Rule]", "p"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "p", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"p", "+", "1"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p", ",", 
       RowBox[{
        RowBox[{"m", "+", "5"}], "|", 
        RowBox[{"m", "+", "6"}]}], ",", "_"}], "}"}], "\[Rule]", 
     RowBox[{"m", "+", "4"}]}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"RMToCA", "[", "prog_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", "=", 
      RowBox[{"Length", "[", "prog", "]"}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"MapIndexed", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"#1", ",", 
            RowBox[{"First", "[", "#2", "]"}], ",", "m"}], "]"}], "&"}], ",", 
         "prog"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"0", "|", 
             RowBox[{"m", "+", "1"}]}], ",", 
            RowBox[{"m", "+", "3"}]}], "}"}], "\[Rule]", 
          RowBox[{"m", "+", "2"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"m", "+", "1"}], ",", "_"}], "}"}], "\[Rule]", "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", 
            RowBox[{"m", "+", "1"}]}], "}"}], "\[Rule]", "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", 
            RowBox[{"x", ":", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"m", "+", "1"}], "|", 
               RowBox[{"m", "+", "3"}]}], ")"}]}]}], "}"}], "\[Rule]", "x"}], 
         ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{
             RowBox[{"m", "+", "1"}], "|", 
             RowBox[{"m", "+", "3"}]}], ",", "_"}], "}"}], "\[Rule]", 
          RowBox[{"m", "+", "2"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"m", "+", "6"}], ",", 
            RowBox[{"0", "|", 
             RowBox[{"m", "+", "4"}]}], ",", "0"}], "}"}], "\[Rule]", 
          RowBox[{"m", "+", "5"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"m", "+", "4"}], ",", "0"}], "}"}], "\[Rule]", "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"m", "+", "4"}], ",", "0", ",", "0"}], "}"}], "\[Rule]", 
          "0"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x", ":", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"m", "+", "4"}], "|", 
               RowBox[{"m", "+", "6"}]}], ")"}]}], ",", "_", ",", "_"}], 
           "}"}], "\[Rule]", "x"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{
             RowBox[{"m", "+", "4"}], "|", 
             RowBox[{"m", "+", "6"}]}], ",", "_"}], "}"}], "\[Rule]", 
          RowBox[{"m", "+", "5"}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], 
        "}"}]}], "}"}], "]"}]}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"RMToCA", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"i", "[", "1", "]"}], ",", " ", 
        RowBox[{"d", "[", 
         RowBox[{"2", ",", "1"}], "]"}], ",", " ", 
        RowBox[{"i", "[", "2", "]"}], ",", " ", 
        RowBox[{"d", "[", 
         RowBox[{"1", ",", "3"}], "]"}], ",", " ", 
        RowBox[{"d", "[", 
         RowBox[{"2", ",", "1"}], "]"}]}], "}"}], "]"}], "]"}], ",", " ", 
    RowBox[{"ReplacePart", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", "15", "}"}]}], "]"}], ",", "1", ",", "8"}], "]"}], ",", 
    " ", "30"}], "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.513087272825995*^9, 3.5130872761760178`*^9}, {
  3.5202620628796177`*^9, 3.520262063338855*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "7", "2", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "7", "3", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "7", "4", "10", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "6", "3", "10", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "0", "4", "11", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "0", "5", "10", "10", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "0", "1", "9", "10", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "7", "2", "10", "9", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "7", "1", "9", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "8", "2", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "7", "7", "3", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "7", "7", "4", "10", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "7", "6", "3", "10", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "6", "7", "4", "11", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "6", "3", "10", "10", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "0", "4", "11", "10", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "0", "5", "10", "11", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "0", "1", "9", "10", "10", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "7", "2", "10", "9", "10", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "7", "1", "9", "10", "9", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "8", "2", "10", "9", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "7", "7", "1", "9", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "7", "8", "2", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "8", "7", "3", "0", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "7", "7", "7", "4", "10", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "7", "7", "6", "3", "10", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "7", "6", "7", "4", "11", "0", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "6", "7", "6", "3", "10", "10", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "6", "7", "4", "11", "10", "0", "0", "0", "0", 
     "0"},
    {"0", "0", "0", "0", "0", "0", "6", "3", "10", "11", "0", "0", "0", "0", 
     "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{
  3.413734330139801*^9, 3.4137344234076357`*^9, {3.4282544753320417`*^9, 
   3.428254518719549*^9}, 3.428254558201057*^9, 3.428254632369885*^9, 
   3.432324954053575*^9, 3.432325567634274*^9, 3.4323257866782207`*^9, 
   3.432325828832747*^9, 3.432326457527185*^9, 3.500211562997684*^9, 
   3.513087279018038*^9, 3.520262065567268*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 661 \[CenterDot] Multiplication systems\
\>", "Subsection"], Cell[" (page 1112)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "0", ",", 
      RowBox[{"3", "|", "8"}]}], "}"}], "\[Rule]", "5"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "0", ",", 
      RowBox[{"2", "|", "7"}]}], "}"}], "\[Rule]", "8"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "1", ",", 
      RowBox[{"4", "|", "9"}]}], "}"}], "\[Rule]", "9"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "1", ",", 
      RowBox[{"3", "|", "8"}]}], "}"}], "\[Rule]", "4"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "1", ",", 
      RowBox[{"2", "|", "7"}]}], "}"}], "\[Rule]", "8"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "10", ",", 
      RowBox[{"4", "|", "9"}]}], "}"}], "\[Rule]", "3"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "10", ",", 
      RowBox[{"3", "|", "8"}]}], "}"}], "\[Rule]", "7"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "10", ",", 
      RowBox[{"2", "|", "7"}]}], "}"}], "\[Rule]", "2"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"5", "|", "6"}], ",", "1", ",", "0"}], "}"}], "\[Rule]", "9"}], 
   ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"5", "|", "6"}], ",", "10", ",", "0"}], "}"}], "\[Rule]", "3"}],
    ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"5", "|", "6"}], ",", "1", ",", "_"}], "}"}], "\[Rule]", "6"}], 
   ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"5", "|", "6"}], ",", "10", ",", "_"}], "}"}], "\[Rule]", "5"}],
    ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"2", "|", "3", "|", "4", "|", "5"}], ",", "_"}], "}"}], 
    "\[Rule]", "10"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"6", "|", "7", "|", "8", "|", "9"}], ",", "_"}], "}"}], 
    "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], 
  "}"}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "0", ",", 
          RowBox[{"3", "|", "8"}]}], "}"}], "\[Rule]", "5"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "0", ",", 
          RowBox[{"2", "|", "7"}]}], "}"}], "\[Rule]", "8"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "1", ",", 
          RowBox[{"4", "|", "9"}]}], "}"}], "\[Rule]", "9"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "1", ",", 
          RowBox[{"3", "|", "8"}]}], "}"}], "\[Rule]", "4"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "1", ",", 
          RowBox[{"2", "|", "7"}]}], "}"}], "\[Rule]", "8"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "10", ",", 
          RowBox[{"4", "|", "9"}]}], "}"}], "\[Rule]", "3"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "10", ",", 
          RowBox[{"3", "|", "8"}]}], "}"}], "\[Rule]", "7"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "10", ",", 
          RowBox[{"2", "|", "7"}]}], "}"}], "\[Rule]", "2"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"5", "|", "6"}], ",", "1", ",", "0"}], "}"}], "\[Rule]", 
        "9"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"5", "|", "6"}], ",", "10", ",", "0"}], "}"}], "\[Rule]", 
        "3"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"5", "|", "6"}], ",", "1", ",", "_"}], "}"}], "\[Rule]", 
        "6"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"5", "|", "6"}], ",", "10", ",", "_"}], "}"}], "\[Rule]", 
        "5"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", 
          RowBox[{"2", "|", "3", "|", "4", "|", "5"}], ",", "_"}], "}"}], 
        "\[Rule]", "10"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", 
          RowBox[{"6", "|", "7", "|", "8", "|", "9"}], ",", "_"}], "}"}], 
        "\[Rule]", "1"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "x_", ",", "_"}], "}"}], "\[Rule]", "x"}]}], "}"}],
      "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PadLeft", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "0"}], "}"}], ",", "10"}], "]"}], ",", " ", "20"}], 
   "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.513088396267845*^9, 3.513088398574731*^9}, {
  3.520262093457333*^9, 3.5202620939601717`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "0", "0", "0", "0", "0", "2", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "8", "10", "0"},
    {"0", "0", "0", "0", "0", "0", "5", "1", "10", "0"},
    {"0", "0", "0", "0", "0", "0", "10", "6", "10", "0"},
    {"0", "0", "0", "0", "0", "0", "10", "1", "3", "0"},
    {"0", "0", "0", "0", "0", "0", "10", "4", "10", "0"},
    {"0", "0", "0", "0", "0", "0", "3", "10", "10", "0"},
    {"0", "0", "0", "0", "0", "5", "10", "10", "10", "0"},
    {"0", "0", "0", "0", "0", "10", "5", "10", "10", "0"},
    {"0", "0", "0", "0", "0", "10", "10", "5", "10", "0"},
    {"0", "0", "0", "0", "0", "10", "10", "10", "3", "0"},
    {"0", "0", "0", "0", "0", "10", "10", "7", "10", "0"},
    {"0", "0", "0", "0", "0", "10", "2", "1", "10", "0"},
    {"0", "0", "0", "0", "0", "2", "10", "1", "10", "0"},
    {"0", "0", "0", "0", "8", "10", "10", "1", "10", "0"},
    {"0", "0", "0", "5", "1", "10", "10", "1", "10", "0"},
    {"0", "0", "0", "10", "6", "10", "10", "1", "10", "0"},
    {"0", "0", "0", "10", "1", "5", "10", "1", "10", "0"},
    {"0", "0", "0", "10", "1", "10", "5", "1", "10", "0"},
    {"0", "0", "0", "10", "1", "10", "10", "6", "10", "0"},
    {"0", "0", "0", "10", "1", "10", "10", "1", "3", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.413734330418133*^9, 3.413734423450292*^9, 
  3.428254652840108*^9, 3.432324954134797*^9, 3.432325567835108*^9, 
  3.432325786746196*^9, 3.4323258289155397`*^9, 3.432326457640615*^9, 
  3.500211570715909*^9, 3.513088402031534*^9, 3.5202620963303328`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 662 \[CenterDot] Logic circuits", "Subsection"], Cell[
     " (page 1112)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", 
       RowBox[{"1", "|", "3"}]}], "}"}], "\[Rule]", "1"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "3"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", 
       RowBox[{"0", "|", "1", "|", "3"}]}], "}"}], "\[Rule]", "1"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "3"}], "}"}], "\[Rule]", "2"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "0"}], "}"}], "\[Rule]", "2"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "_"}], "}"}], "\[Rule]", "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "3", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", 
       RowBox[{"0", "|", "1", "|", "2", "|", "4"}]}], "}"}], "\[Rule]", "2"}],
     ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "3", ",", "3"}], "}"}], "\[Rule]", "3"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "1", ",", "3"}], "}"}], "\[Rule]", "1"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "3", ",", "0"}], "}"}], "\[Rule]", "4"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], "}"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Flatten", "[", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"And", ",", "Or"}], "}"}], ",", 
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{"#", "+", "1"}], ")"}]}]}], "}"}], "&"}], ",", "expr", 
       ",", 
       RowBox[{"{", 
        RowBox[{"-", "1"}], "}"}]}], "]"}], "//.", "\[InvisibleSpace]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"!", "x_"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "x", ",", "0"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"And", "[", "x__", "]"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{
         "0", ",", "0", ",", "1", ",", "0", ",", "x", ",", "1", ",", "3", ",",
           "0", ",", "0"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"Or", "[", "x__", "]"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{
         "0", ",", "0", ",", "1", ",", "0", ",", "x", ",", "0", ",", "1", ",",
           "3", ",", "0"}], "}"}]}]}], "}"}]}]}], "]"}], 
  "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"expr", " ", "=", " ", 
      RowBox[{"And", "[", 
       RowBox[{"1", ",", "0"}], "]"}]}], "}"}], ",", 
    RowBox[{"CAEvolveList", "[", 
     RowBox[{
      RowBox[{"GeneralCARule", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1", ",", 
            RowBox[{"1", "|", "3"}]}], "}"}], "\[Rule]", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "3", ",", "3"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", 
            RowBox[{"0", "|", "1", "|", "3"}]}], "}"}], "\[Rule]", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1", ",", "3"}], "}"}], "\[Rule]", "4"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "3", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "3", ",", "3"}], "}"}], "\[Rule]", "2"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "3"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "0"}], "}"}], "\[Rule]", "2"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "0", ",", "_"}], "}"}], "\[Rule]", "4"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"3", ",", "3", ",", "0"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"4", ",", "0", ",", 
            RowBox[{"0", "|", "1", "|", "2", "|", "4"}]}], "}"}], "\[Rule]", 
          "2"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"4", ",", "3", ",", "3"}], "}"}], "\[Rule]", "3"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"4", ",", "1", ",", "3"}], "}"}], "\[Rule]", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"4", ",", "3", ",", "0"}], "}"}], "\[Rule]", "4"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", "0"}]}], 
        "}"}], "]"}], ",", " ", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Block", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"And", ",", "Or"}], "}"}], ",", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"2", "\[ThinSpace]", 
                RowBox[{"(", 
                 RowBox[{"#", "+", "1"}], ")"}]}]}], "}"}], "&"}], ",", 
            "expr", ",", 
            RowBox[{"{", 
             RowBox[{"-", "1"}], "}"}]}], "]"}], "//.", "\[InvisibleSpace]", 
          RowBox[{"{", "\[InvisibleSpace]", 
           RowBox[{
            RowBox[{
             RowBox[{"!", "x_"}], "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{"0", ",", "x", ",", "0"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"And", "[", "x__", "]"}], "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "0", ",", "1", ",", "0", ",", "x", ",", "1", ",", "3",
                ",", "0", ",", "0"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"Or", "[", "x__", "]"}], "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{
              "0", ",", "0", ",", "1", ",", "0", ",", "x", ",", "0", ",", "1",
                ",", "3", ",", "0"}], "}"}]}]}], "}"}]}]}], "]"}], "]"}], ",",
       " ", "9"}], "]"}]}], "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.513088408587212*^9, 3.5130884107213306`*^9}, {
  3.513089222287221*^9, 3.5130892256418962`*^9}, {3.52026210274929*^9, 
  3.520262103236277*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "1", "0", "0", "4", "0", "2", "1", "3", "0", "0"},
    {"0", "0", "0", "1", "0", "0", "2", "0", "3", "3", "0", "0"},
    {"0", "0", "0", "0", "1", "0", "0", "4", "3", "3", "0", "0"},
    {"0", "0", "0", "0", "0", "1", "0", "0", "3", "3", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "1", "0", "3", "3", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "1", "3", "3", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "1", "2", "3", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "2", "0", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "4", "0"},
    {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "2"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.413734330489349*^9, 3.4137344235380096`*^9, 
  3.428254661320266*^9, 3.4323249542012377`*^9, 3.4323255679338207`*^9, 
  3.432325786970749*^9, 3.432325829001072*^9, 3.4323264577237253`*^9, 
  3.500211576924151*^9, 3.5130884134669523`*^9, 3.513089230505691*^9, 
  3.520262105083359*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 663 \[CenterDot] RAM", "Subsection"], Cell[
     " (page 1112)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", 
      RowBox[{"4", "|", "8"}], ",", 
      RowBox[{"2", "|", "11"}], ",", "_", ",", "_"}], "}"}], "\[Rule]", "2"}],
    ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"11", "|", "10"}], ",", 
      RowBox[{"4", "|", "8"}], ",", 
      RowBox[{"2", "|", "11"}], ",", "_", ",", "_"}], "}"}], "\[Rule]", 
    "11"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", 
      RowBox[{"4", "|", "8"}], ",", "_", ",", "_", ",", "_"}], "}"}], 
    "\[Rule]", "10"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"11", "|", "10"}], ",", 
      RowBox[{"4", "|", "8"}], ",", "_", ",", "_", ",", "_"}], "}"}], 
    "\[Rule]", "2"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "0", ",", "_", ",", "_", ",", "_"}], "}"}], "\[Rule]", 
    "2"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"11", ",", "0", ",", "_", ",", "_", ",", "_"}], "}"}], "\[Rule]",
     "11"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"3", "|", "7", "|", "6"}], ",", "_", ",", "10", ",", "_", ",", 
      "_"}], "}"}], "\[Rule]", "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{"3", "|", "7", "|", "6"}], ")"}]}], ",", "_", ",", "_", ",", 
      "_", ",", "_"}], "}"}], "\[Rule]", "x"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "6", ",", "4", ",", "10"}], "}"}], "\[Rule]",
     "5"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "6", ",", "8", ",", "10"}], "}"}], "\[Rule]",
     "9"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "3", ",", "_", ",", "10", ",", "_"}], "}"}], "\[Rule]",
     "4"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "7", ",", "_", ",", "10", ",", "_"}], "}"}], "\[Rule]",
     "8"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "1", ",", "_", ",", 
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{"5", "|", "9"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "_", ",", "_", ",", "_", ",", "_"}], "}"}], "\[Rule]", 
    "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "1", ",", "_", ",", "_"}], "}"}], "\[Rule]", 
    "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", "1"}], "}"}], "\[Rule]", 
    "1"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"_", ",", "_", ",", 
      RowBox[{"x", ":", 
       RowBox[{"(", 
        RowBox[{"4", "|", "8", "|", "0"}], ")"}]}], ",", "_", ",", "_"}], 
     "}"}], "\[Rule]", "x"}]}], "}"}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CAStep", "[", 
   RowBox[{
    RowBox[{"GeneralCARule", "[", 
     RowBox[{"rule_", ",", 
      RowBox[{"r_Integer", ":", "1"}]}], "]"}], ",", "a_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{"a", ",", 
     RowBox[{
      RowBox[{"2", " ", "r"}], "+", "1"}], ",", "1", ",", 
     RowBox[{"r", "+", "1"}]}], "]"}], "/.", "\[InvisibleSpace]", 
   "rule"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"i", "=", "7"}], ",", 
      RowBox[{"n", "=", "4"}], ",", 
      RowBox[{"data", "=", 
       RowBox[{"{", 
        RowBox[{
        "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
        "}"}]}]}], "}"}], ",", 
    RowBox[{"CAEvolveList", "[", 
     RowBox[{
      RowBox[{"GeneralCARule", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", 
             RowBox[{"4", "|", "8"}], ",", 
             RowBox[{"2", "|", "11"}], ",", "_", ",", "_"}], "}"}], "\[Rule]",
            "2"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"11", "|", "10"}], ",", 
             RowBox[{"4", "|", "8"}], ",", 
             RowBox[{"2", "|", "11"}], ",", "_", ",", "_"}], "}"}], "\[Rule]",
            "11"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", 
             RowBox[{"4", "|", "8"}], ",", "_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "10"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"11", "|", "10"}], ",", 
             RowBox[{"4", "|", "8"}], ",", "_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "2"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "0", ",", "_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "2"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"11", ",", "0", ",", "_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "11"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"3", "|", "7", "|", "6"}], ",", "_", ",", "10", ",", "_",
              ",", "_"}], "}"}], "\[Rule]", "1"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"3", "|", "7", "|", "6"}], ")"}]}], ",", "_", ",", "_",
              ",", "_", ",", "_"}], "}"}], "\[Rule]", "x"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "6", ",", "4", ",", "10"}], "}"}], 
           "\[Rule]", "5"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "6", ",", "8", ",", "10"}], "}"}], 
           "\[Rule]", "9"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "3", ",", "_", ",", "10", ",", "_"}], "}"}], 
           "\[Rule]", "4"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "7", ",", "_", ",", "10", ",", "_"}], "}"}], 
           "\[Rule]", "8"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "1", ",", "_", ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"5", "|", "9"}], ")"}]}]}], "}"}], "\[Rule]", "x"}], 
          ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "_", ",", "_", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "1"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "1", ",", "_", ",", "_"}], "}"}], 
           "\[Rule]", "1"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", "1"}], "}"}], 
           "\[Rule]", "1"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", 
             RowBox[{"x", ":", 
              RowBox[{"(", 
               RowBox[{"4", "|", "8", "|", "0"}], ")"}]}], ",", "_", ",", 
             "_"}], "}"}], "\[Rule]", "x"}]}], "}"}], ",", "2"}], "]"}], ",", 
      " ", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], ",", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "i", ",", " ", 
           RowBox[{
            RowBox[{"IntegerDigits", "[", 
             RowBox[{"n", ",", "2"}], "]"}], "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"0", ",", "11"}], "}"}]}], ",", 
              RowBox[{"0", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"0", ",", "2"}], "}"}]}]}], "}"}]}]}], "}"}], "]"}], 
        ",", " ", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], ",", 
        RowBox[{"Flatten", "[", 
         RowBox[{"data", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"8", ",", "1"}], "}"}]}], ",", " ", 
            RowBox[{"0", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"4", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], "]"}], 
      ",", " ", "15"}], "]"}]}], "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.513088419515994*^9, 3.5130884249993753`*^9}, {
  3.52026211115346*^9, 3.520262111662003*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "1", "0", "7", "0", "11", "0", "2", "0", "2", "0", "1", "8", "1", 
     "4", "1", "8", "1", "4", "1", "4", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "7", "0", "11", "0", "2", "0", "2", "8", "1", 
     "4", "1", "8", "1", "4", "1", "4", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "1", "0", "7", "0", "11", "0", "2", "8", "10", 
     "4", "1", "8", "1", "4", "1", "4", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "1", "0", "1", "0", "7", "0", "11", "8", "10", 
     "4", "2", "8", "1", "4", "1", "4", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "0", "7", "8", "2", 
     "4", "11", "8", "10", "4", "1", "4", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "8", "7", 
     "4", "2", "8", "2", "4", "2", "4", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "8", "1", 
     "4", "7", "8", "2", "4", "2", "4", "10", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "8", "1", 
     "4", "1", "8", "7", "4", "2", "4", "10", "8", "2", "4", "1"},
    {"0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "8", "1", 
     "4", "1", "8", "1", "4", "7", "4", "10", "8", "11", "4", "10"},
    {"0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "8", "1", 
     "4", "1", "8", "1", "4", "1", "8", "1", "8", "11", "4", "2"},
    {"0", "2", "0", "1", "0", "1", "0", "1", "0", "1", "0", "1", "8", "1", 
     "4", "1", "8", "1", "4", "1", "8", "1", "8", "1", "4", "11"},
    {"0", "11", "0", "2", "0", "1", "0", "1", "0", "1", "0", "1", "8", "1", 
     "4", "1", "8", "1", "4", "1", "8", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "11", "0", "2", "0", "1", "0", "1", "0", "1", "8", "1", 
     "4", "1", "8", "1", "4", "1", "8", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "11", "0", "2", "0", "1", "0", "1", "8", "1", 
     "4", "1", "8", "1", "4", "1", "8", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "1", "0", "11", "0", "2", "0", "1", "8", "1", 
     "4", "1", "8", "1", "4", "1", "8", "1", "8", "1", "4", "1"},
    {"0", "1", "0", "1", "0", "1", "0", "1", "0", "11", "0", "2", "8", "1", 
     "4", "1", "8", "1", "4", "1", "8", "1", "8", "1", "4", "1"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.413734330572177*^9, 3.413734423620081*^9, 
  3.4282546677671347`*^9, 3.4323249542893543`*^9, 3.432325568052905*^9, 
  3.4323257871146317`*^9, 3.432325829084148*^9, 3.432326457824431*^9, 
  3.500211582616733*^9, 3.513088425387051*^9, 3.5202621150133123`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Emulating Cellular Automata with Other Systems", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 664 \[CenterDot] Mobile automata", "Subsection"], Cell[
     " (page 1112)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"vals", "=", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"p", "[", "0", "]"}], ",", 
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "1"}], "]"}], ",", 
     RowBox[{"q", "[", 
      RowBox[{"1", ",", "0"}], "]"}], ",", 
     RowBox[{"q", "[", 
      RowBox[{"1", ",", "1"}], "]"}], ",", 
     RowBox[{"p", "[", "1", "]"}]}], "}"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CAToMA", "[", "rules_", "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", "\[Rule]", 
         RowBox[{"Replace", "[", 
          RowBox[{"#", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"q", "[", 
                 RowBox[{"a_", ",", "b_"}], "]"}], ",", 
                RowBox[{"p", "[", "c_", "]"}], ",", 
                RowBox[{"p", "[", "d_", "]"}]}], "}"}], "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"q", "[", 
                 RowBox[{"c", ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"a", ",", "c", ",", "d"}], "}"}], "/.", 
                   "\[InvisibleSpace]", "rules"}]}], "]"}], ",", "1"}], 
               "}"}]}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"q", "[", 
                 RowBox[{"a_", ",", "b_"}], "]"}], ",", 
                RowBox[{"p", "[", "c_", "]"}], ",", "x"}], "}"}], 
              "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"q", "[", 
                 RowBox[{"c", ",", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"a", ",", "c", ",", "0"}], "}"}], "/.", 
                   "\[InvisibleSpace]", "rules"}]}], "]"}], ",", "1"}], 
               "}"}]}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"q", "[", 
                 RowBox[{"_", ",", "_"}], "]"}], ",", "x", ",", "x"}], "}"}], 
              "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"p", "[", "0", "]"}], ",", 
                RowBox[{"-", "1"}]}], "}"}]}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"q", "[", 
                 RowBox[{"_", ",", "_"}], "]"}], ",", 
                RowBox[{"q", "[", 
                 RowBox[{"_", ",", "a_"}], "]"}], ",", 
                RowBox[{"p", "[", "_", "]"}]}], "}"}], "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"p", "[", "a", "]"}], ",", 
                RowBox[{"-", "1"}]}], "}"}]}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"q", "[", 
                 RowBox[{"_", ",", "a_"}], "]"}], ",", 
                RowBox[{"p", "[", "_", "]"}]}], "}"}], "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"p", "[", "a", "]"}], ",", 
                RowBox[{"-", "1"}]}], "}"}]}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"x", ",", "x", ",", 
                RowBox[{"p", "[", "_", "]"}]}], "}"}], "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"q", "[", 
                 RowBox[{"0", ",", "0"}], "]"}], ",", "1"}], "}"}]}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"x", ",", "0"}], "}"}]}]}], "}"}]}], "]"}]}], "&"}], 
       ")"}], "[", 
      RowBox[{"vals", "\[LeftDoubleBracket]", 
       RowBox[{
        RowBox[{"IntegerDigits", "[", 
         RowBox[{"i", ",", "7", ",", "3"}], "]"}], "+", "1"}], 
       "\[RightDoubleBracket]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", 
       RowBox[{
        SuperscriptBox["7", 
         RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "3"}]], "-", "1"}]}], 
      "}"}]}], "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Flatten", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"p", "[", "0", "]"}], ",", " ", 
    RowBox[{"Map", "[", 
     RowBox[{"p", ",", "list"}], "]"}], ",", " ", 
    RowBox[{"p", "[", "0", "]"}]}], "}"}], "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MAStep", "[", 
    RowBox[{"rule_", ",", 
     RowBox[{"{", 
      RowBox[{"list_List", ",", "n_Integer"}], "}"}]}], "]"}], "/;", 
   RowBox[{"1", "<", "n", "<", 
    RowBox[{"Length", "[", "list", "]"}]}]}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ReplacePart", "[", 
        RowBox[{"list", ",", 
         TagBox["#1",
          #& ,
          SyntaxForm->"a"], ",", "n"}], "]"}], ",", 
       RowBox[{"n", "+", 
        TagBox["#2",
         #& ,
         SyntaxForm->"a"]}]}], "}"}], "&"}], ",", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"Take", "[", 
       RowBox[{"list", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"n", "-", "1"}], ",", 
          RowBox[{"n", "+", "1"}]}], "}"}]}], "]"}], ",", "rule"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"MAEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"MAStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"vals", "=", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"p", "[", "0", "]"}], ",", 
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "1"}], "]"}], ",", 
     RowBox[{"q", "[", 
      RowBox[{"1", ",", "0"}], "]"}], ",", 
     RowBox[{"q", "[", 
      RowBox[{"1", ",", "1"}], "]"}], ",", 
     RowBox[{"p", "[", "1", "]"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"CAToMA", "[", "rules_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#", "\[Rule]", 
        RowBox[{"Replace", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"q", "[", 
                RowBox[{"a_", ",", "b_"}], "]"}], ",", 
               RowBox[{"p", "[", "c_", "]"}], ",", 
               RowBox[{"p", "[", "d_", "]"}]}], "}"}], "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"q", "[", 
                RowBox[{"c", ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"a", ",", "c", ",", "d"}], "}"}], "/.", 
                  "\[InvisibleSpace]", "rules"}]}], "]"}], ",", "1"}], 
              "}"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"q", "[", 
                RowBox[{"a_", ",", "b_"}], "]"}], ",", 
               RowBox[{"p", "[", "c_", "]"}], ",", "x"}], "}"}], 
             "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"q", "[", 
                RowBox[{"c", ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"a", ",", "c", ",", "0"}], "}"}], "/.", 
                  "\[InvisibleSpace]", "rules"}]}], "]"}], ",", "1"}], 
              "}"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"q", "[", 
                RowBox[{"_", ",", "_"}], "]"}], ",", "x", ",", "x"}], "}"}], 
             "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"p", "[", "0", "]"}], ",", 
               RowBox[{"-", "1"}]}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"q", "[", 
                RowBox[{"_", ",", "_"}], "]"}], ",", 
               RowBox[{"q", "[", 
                RowBox[{"_", ",", "a_"}], "]"}], ",", 
               RowBox[{"p", "[", "_", "]"}]}], "}"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"p", "[", "a", "]"}], ",", 
               RowBox[{"-", "1"}]}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"x", ",", 
               RowBox[{"q", "[", 
                RowBox[{"_", ",", "a_"}], "]"}], ",", 
               RowBox[{"p", "[", "_", "]"}]}], "}"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"p", "[", "a", "]"}], ",", 
               RowBox[{"-", "1"}]}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"x", ",", "x", ",", 
               RowBox[{"p", "[", "_", "]"}]}], "}"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"q", "[", 
                RowBox[{"0", ",", "0"}], "]"}], ",", "1"}], "}"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"_", ",", "_", ",", "_"}], "}"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"x", ",", "0"}], "}"}]}]}], "}"}]}], "]"}]}], "&"}], 
      ")"}], "[", 
     RowBox[{"vals", "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"i", ",", "7", ",", "3"}], "]"}], "+", "1"}], 
      "\[RightDoubleBracket]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", 
      RowBox[{
       SuperscriptBox["7", 
        RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "3"}]], "-", "1"}]}], 
     "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"ElementaryCARule", "[", "n_", "]"}], ":=", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"i", ",", "2", ",", "3"}], "]"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "7"}], "}"}]}], "]"}], "]"}], "->", 
    RowBox[{"IntegerDigits", "[", 
     RowBox[{"n", ",", "2", ",", "8"}], "]"}]}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MAEvolveList", "[", 
  RowBox[{
   RowBox[{"CAToMA", "[", 
    RowBox[{"ElementaryCARule", "[", "90", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"list", "=", " ", 
         RowBox[{"{", 
          RowBox[{
          "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
          "}"}]}], "}"}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{"x", ",", 
           RowBox[{"{", "5", "}"}]}], "]"}], ",", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"p", "[", "0", "]"}], ",", " ", 
            RowBox[{"Map", "[", 
             RowBox[{"p", ",", "list"}], "]"}], ",", " ", 
            RowBox[{"p", "[", "0", "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{"x", ",", 
           RowBox[{"{", "5", "}"}]}], "]"}]}], "]"}]}], "]"}], ",", "5"}], 
    "}"}], ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "x", ",", "x", ",", "x", ",", "x", ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "1", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", "x", ",", "x", ",", "x", ",", "x", 
       ",", "x"}], "}"}], ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "x", ",", "x", ",", "x", ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "1", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", "x", ",", "x", ",", "x", ",", "x", 
       ",", "x"}], "}"}], ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "x", ",", "x", ",", "x", ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "1", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", "x", ",", "x", ",", "x", ",", "x", 
       ",", "x"}], "}"}], ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "x", ",", "x", ",", "x", ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "1", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", "x", ",", "x", ",", "x", ",", "x", 
       ",", "x"}], "}"}], ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "x", ",", "x", ",", "x", ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "1", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", "x", ",", "x", ",", "x", ",", "x", 
       ",", "x"}], "}"}], ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "x", ",", "x", ",", "x", ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "1"}], "]"}], ",", 
       RowBox[{"p", "[", "1", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", 
       RowBox[{"p", "[", "0", "]"}], ",", "x", ",", "x", ",", "x", ",", "x", 
       ",", "x"}], "}"}], ",", "10"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413734330712472*^9, 3.413734423756633*^9, 
  3.4282546797421417`*^9, 3.432324954512459*^9, 3.432325568213793*^9, 
  3.432325787255464*^9, 3.432325829327222*^9, 3.432326458000581*^9, 
  3.500211590560566*^9, 3.520262126268512*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 665 \[CenterDot]  Turing machines", "Subsection"], Cell[
     " (page 1113)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CAToTM", "[", "rules_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "[", 
        RowBox[{"a_", ",", "b_"}], "]"}], ",", 
       RowBox[{"c", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "1"}], ")"}]}]}], "}"}], "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "[", 
        RowBox[{"b", ",", "c"}], "]"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "c"}], "}"}], "/.", "\[InvisibleSpace]", 
        "rules"}], ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "[", 
        RowBox[{"_", ",", "_"}], "]"}], ",", "x"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "[", "0", "]"}], ",", "0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "[", "a_", "]"}], ",", 
       RowBox[{"b", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "1"}], ")"}]}]}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "[", "b", "]"}], ",", "a", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "[", "_", "]"}], ",", "x"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", "0", ",", "1"}], "}"}]}]}], 
   "}"}]}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAToTM", "[", "rules_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "[", 
        RowBox[{"a_", ",", "b_"}], "]"}], ",", 
       RowBox[{"c", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "1"}], ")"}]}]}], "}"}], "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "[", 
        RowBox[{"b", ",", "c"}], "]"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "c"}], "}"}], "/.", "\[InvisibleSpace]", 
        "rules"}], ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "[", 
        RowBox[{"_", ",", "_"}], "]"}], ",", "x"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "[", "0", "]"}], ",", "0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "[", "a_", "]"}], ",", 
       RowBox[{"b", ":", 
        RowBox[{"(", 
         RowBox[{"0", "|", "1"}], ")"}]}]}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "[", "b", "]"}], ",", "a", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "[", "_", "]"}], ",", "x"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", "0", ",", "1"}], "}"}]}]}], 
   "}"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TMStep", "[", 
    RowBox[{"rule_List", ",", 
     RowBox[{"{", 
      RowBox[{"s_", ",", "a_List", ",", "n_"}], "}"}]}], "]"}], "/;", 
   RowBox[{"1", "\[LessEqual]", "n", "\[LessEqual]", 
    RowBox[{"Length", "[", "a", "]"}]}]}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       TagBox["#1",
        #& ,
        SyntaxForm->"a"], ",", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{"a", ",", 
         TagBox["#2",
          #& ,
          SyntaxForm->"a"], ",", "n"}], "]"}], ",", 
       RowBox[{"n", "+", 
        TagBox["#3",
         #& ,
         SyntaxForm->"a"]}]}], "}"}], "&"}], ",", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", 
        RowBox[{"a", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}]}],
        "}"}], ",", "rule"}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"TMEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TMStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"ElementaryCARule", "[", "n_", "]"}], ":=", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"i", ",", "2", ",", "3"}], "]"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "7"}], "}"}]}], "]"}], "]"}], "->", 
    RowBox[{"IntegerDigits", "[", 
     RowBox[{"n", ",", "2", ",", "8"}], "]"}]}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"list", "=", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"TMEvolveList", "[", 
    RowBox[{
     RowBox[{"CAToTM", "[", 
      RowBox[{"ElementaryCARule", "[", "90", "]"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "[", 
        RowBox[{"0", ",", "0"}], "]"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "x", ",", "x"}], "}"}], ",", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}], ",", "list", ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "x", ",", "x"}], "}"}]}], "}"}], "]"}], ",", 
       "4"}], "}"}], ",", "10"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "1"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"1", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"q", "[", 
      RowBox[{"0", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "x", ",", "x", ",", 
       "x"}], "}"}], ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"p", "[", "0", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "x", ",", "x", ",", "x", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "x", ",", 
       "x"}], "}"}], ",", "12"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413734330791984*^9, 3.413734424022236*^9, 
  3.428254688653973*^9, 3.432324954588509*^9, 3.43232556832232*^9, 
  3.4323257873465633`*^9, 3.432325829451836*^9, 3.432326458110092*^9, 
  3.500211597673463*^9, 3.5202621351622477`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 667 \[CenterDot] Sequential substitution systems\
\>", "Subsection"], Cell[" (page 1113)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CAToSSS", "[", "rules_", "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"rules", "/.", "\[InvisibleSpace]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a_", ",", "b_", ",", "c_"}], "}"}], "\[Rule]", "d_"}], 
       ")"}], "\[Rule]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"2", " ", "a"}], ",", 
         RowBox[{"2", " ", "b"}], ",", 
         RowBox[{"2", " ", "c"}]}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", " ", "d"}], ",", "1", ",", 
         RowBox[{"2", " ", "b"}], ",", 
         RowBox[{"2", " ", "c"}]}], "}"}]}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", "0", "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}]}], "}"}]}], 
   "]"}]}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAToSSS", "[", "rules_", "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"rules", "/.", "\[InvisibleSpace]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a_", ",", "b_", ",", "c_"}], "}"}], "\[Rule]", "d_"}], 
       ")"}], "\[Rule]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"2", " ", "a"}], ",", 
         RowBox[{"2", " ", "b"}], ",", 
         RowBox[{"2", " ", "c"}]}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", " ", "d"}], ",", "1", ",", 
         RowBox[{"2", " ", "b"}], ",", 
         RowBox[{"2", " ", "c"}]}], "}"}]}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", "0", "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}]}], "}"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"ElementaryCARule", "[", "n_", "]"}], ":=", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"i", ",", "2", ",", "3"}], "]"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "7"}], "}"}]}], "]"}], "]"}], "->", 
    RowBox[{"IntegerDigits", "[", 
     RowBox[{"n", ",", "2", ",", "8"}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"s", ",", "Flat"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SSSRules", "[", "list_List", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], ",", 
    RowBox[{"Apply", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", "x___", "}"}], ",", "#1", ",", 
          RowBox[{"{", "y___", "}"}]}], "]"}], "\[Rule]", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", "x", "}"}], ",", "#2", ",", 
          RowBox[{"{", "y", "}"}]}], "]"}]}], "&"}], ",", "list", ",", 
      RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"SSSEvolveList3", "[", 
   RowBox[{"rules_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"r", "=", 
      RowBox[{"SSSRules", "[", "rules", "]"}]}], "}"}], ",", 
    RowBox[{"NestList", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#1", "/.", "r"}], "&"}], ",", "init", ",", "t"}], "]"}]}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SSSEvolveList3", "[", 
   RowBox[{
    RowBox[{"CAToSSS", "[", 
     RowBox[{"ElementaryCARule", "[", "90", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "2", ",", "0", ",", "0"}], "}"}], ",", 
    "30"}], "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.513088486909895*^9, 3.513088489040266*^9}, {
  3.513089355664296*^9, 3.5130893562196217`*^9}, {3.5202621411562443`*^9, 
  3.520262141662731*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "2", "0", "0", "", "", "", "", "", "", "", "", ""},
    {"1", "0", "0", "0", "0", "2", "0", "0", "", "", "", "", "", ""},
    {"0", "1", "0", "0", "0", "2", "0", "0", "", "", "", "", "", ""},
    {"0", "0", "1", "0", "0", "2", "0", "0", "", "", "", "", "", ""},
    {"0", "0", "2", "1", "0", "2", "0", "0", "", "", "", "", "", ""},
    {"0", "0", "2", "0", "1", "2", "0", "0", "", "", "", "", "", ""},
    {"0", "0", "2", "0", "2", "1", "0", "0", "", "", "", "", "", ""},
    {"0", "0", "2", "0", "2", "0", "0", "", "", "", "", "", "", ""},
    {"1", "0", "0", "0", "0", "2", "0", "2", "0", "0", "", "", "", ""},
    {"0", "1", "0", "0", "0", "2", "0", "2", "0", "0", "", "", "", ""},
    {"0", "0", "1", "0", "0", "2", "0", "2", "0", "0", "", "", "", ""},
    {"0", "0", "2", "1", "0", "2", "0", "2", "0", "0", "", "", "", ""},
    {"0", "0", "2", "0", "1", "2", "0", "2", "0", "0", "", "", "", ""},
    {"0", "0", "2", "0", "0", "1", "0", "2", "0", "0", "", "", "", ""},
    {"0", "0", "2", "0", "0", "0", "1", "2", "0", "0", "", "", "", ""},
    {"0", "0", "2", "0", "0", "0", "2", "1", "0", "0", "", "", "", ""},
    {"0", "0", "2", "0", "0", "0", "2", "0", "0", "", "", "", "", ""},
    {"1", "0", "0", "0", "0", "2", "0", "0", "0", "2", "0", "0", "", ""},
    {"0", "1", "0", "0", "0", "2", "0", "0", "0", "2", "0", "0", "", ""},
    {"0", "0", "1", "0", "0", "2", "0", "0", "0", "2", "0", "0", "", ""},
    {"0", "0", "2", "1", "0", "2", "0", "0", "0", "2", "0", "0", "", ""},
    {"0", "0", "2", "0", "1", "2", "0", "0", "0", "2", "0", "0", "", ""},
    {"0", "0", "2", "0", "2", "1", "0", "0", "0", "2", "0", "0", "", ""},
    {"0", "0", "2", "0", "2", "0", "1", "0", "0", "2", "0", "0", "", ""},
    {"0", "0", "2", "0", "2", "0", "2", "1", "0", "2", "0", "0", "", ""},
    {"0", "0", "2", "0", "2", "0", "2", "0", "1", "2", "0", "0", "", ""},
    {"0", "0", "2", "0", "2", "0", "2", "0", "2", "1", "0", "0", "", ""},
    {"0", "0", "2", "0", "2", "0", "2", "0", "2", "0", "0", "", "", ""},
    {"1", "0", "0", "0", "0", "2", "0", "2", "0", "2", "0", "2", "0", "0"},
    {"0", "1", "0", "0", "0", "2", "0", "2", "0", "2", "0", "2", "0", "0"},
    {"0", "0", "1", "0", "0", "2", "0", "2", "0", "2", "0", "2", "0", "0"}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.413734330880782*^9, 3.413734424107409*^9, 
  3.428254694696116*^9, 3.432324954672614*^9, 3.432325568405122*^9, 
  3.432325787419948*^9, 3.432325829538282*^9, 3.432326458226853*^9, 
  3.500211603330503*^9, 3.513088492077867*^9, 3.5130893618694067`*^9, 
  3.520262144808445*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 667 \[CenterDot] Tag systems", "Subsection"], Cell[
     " (page 1113)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CAToTS", "[", "rules_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "x_", "]"}], ",", 
         RowBox[{"s", "[", "y_", "]"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"d", "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"x", ",", "y"}], "]"}]}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"d", "[", 
          RowBox[{"w_", ",", "x_"}], "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"y_", ",", "z_"}], "]"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"w", ",", "x", ",", "y"}], "}"}], "/.", 
           "\[InvisibleSpace]", "rules"}], "]"}], ",", 
         RowBox[{"s", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "y", ",", "z"}], "}"}], "/.", 
           "\[InvisibleSpace]", "rules"}], "]"}]}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "x_", "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"y_", ",", "z_"}], "]"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "0", "]"}], ",", 
         RowBox[{"s", "[", "0", "]"}], ",", 
         RowBox[{"s", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "y", ",", "z"}], "}"}], "/.", 
           "\[InvisibleSpace]", "rules"}], "]"}]}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"d", "[", 
          RowBox[{"x_", ",", "y_"}], "]"}], ",", 
         RowBox[{"s", "[", "z_", "]"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "y", ",", "0"}], "}"}], "/.", 
           "\[InvisibleSpace]", "rules"}], "]"}], ",", 
         RowBox[{"s", "[", "0", "]"}], ",", 
         RowBox[{"s", "[", "0", "]"}]}], "}"}]}]}], "}"}]}], 
   "}"}]}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CAToTS", "[", "rules_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "x_", "]"}], ",", 
         RowBox[{"s", "[", "y_", "]"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"d", "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"x", ",", "y"}], "]"}]}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"d", "[", 
          RowBox[{"w_", ",", "x_"}], "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"y_", ",", "z_"}], "]"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"w", ",", "x", ",", "y"}], "}"}], "/.", 
           "\[InvisibleSpace]", "rules"}], "]"}], ",", 
         RowBox[{"s", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "y", ",", "z"}], "}"}], "/.", 
           "\[InvisibleSpace]", "rules"}], "]"}]}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "x_", "]"}], ",", 
         RowBox[{"d", "[", 
          RowBox[{"y_", ",", "z_"}], "]"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", "0", "]"}], ",", 
         RowBox[{"s", "[", "0", "]"}], ",", 
         RowBox[{"s", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "y", ",", "z"}], "}"}], "/.", 
           "\[InvisibleSpace]", "rules"}], "]"}]}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"d", "[", 
          RowBox[{"x_", ",", "y_"}], "]"}], ",", 
         RowBox[{"s", "[", "z_", "]"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "y", ",", "0"}], "}"}], "/.", 
           "\[InvisibleSpace]", "rules"}], "]"}], ",", 
         RowBox[{"s", "[", "0", "]"}], ",", 
         RowBox[{"s", "[", "0", "]"}]}], "}"}]}]}], "}"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"ElementaryCARule", "[", "n_", "]"}], ":=", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"i", ",", "2", ",", "3"}], "]"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "7"}], "}"}]}], "]"}], "]"}], "->", 
    RowBox[{"IntegerDigits", "[", 
     RowBox[{"n", ",", "2", ",", "8"}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"TSEvolveList", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n_", ",", "rule_"}], "}"}], ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "#", "]"}], "<", "n"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{"#", ",", "n"}], "]"}], ",", 
         RowBox[{
          RowBox[{"Take", "[", 
           RowBox[{"#", ",", "n"}], "]"}], "/.", "\[InvisibleSpace]", 
          "rule"}]}], "]"}]}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Cases", "[", 
   RowBox[{
    RowBox[{"TSEvolveList", "[", 
     RowBox[{
      RowBox[{"CAToTS", "[", 
       RowBox[{"ElementaryCARule", "[", "90", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"s", "[", "0", "]"}], ",", 
        RowBox[{"s", "[", "0", "]"}], ",", 
        RowBox[{"s", "[", "1", "]"}], ",", 
        RowBox[{"s", "[", "0", "]"}], ",", 
        RowBox[{"s", "[", "0", "]"}]}], "}"}], ",", "50"}], "]"}], ",", 
    RowBox[{"{", "__s", "}"}]}], "]"}], "//", "Grid"}]], "Input",
 CellChangeTimes->{{3.513088498024098*^9, 3.5130885004838037`*^9}, {
  3.5202621522212563`*^9, 3.520262152729196*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], "", "", "", "", "", "", "", "", "", ""},
    {
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], "", "", "", "", "", "", "", ""},
    {
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], "", "", "", "", "", ""},
    {
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], "", "", "", ""},
    {
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], "", ""},
    {
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "1", "]"}], 
     RowBox[{"s", "[", "0", "]"}], 
     RowBox[{"s", "[", "0", "]"}]}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.413734330958654*^9, 3.413734424191331*^9, 
  3.428254701972494*^9, 3.432324954755888*^9, 3.4323255684904137`*^9, 
  3.432325787529702*^9, 3.432325829619693*^9, 3.432326458311805*^9, 
  3.500211609257658*^9, 3.513088503468213*^9, 3.520262154959052*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 668 \[CenterDot] Symbolic systems", "Subsection"], Cell[
     " (page 1113)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Array", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"p", "[", "x_", "]"}], "[", "#1", "]"}], "[", "#2", 
            "]"}], "[", "#3", "]"}], "\[Rule]", 
          RowBox[{
           RowBox[{
            RowBox[{"p", "[", 
             RowBox[{"x", "[", 
              RowBox[{
               RowBox[{"{", "##", "}"}], "/.", "\[InvisibleSpace]", "rules"}],
               "]"}], "]"}], "[", "#2", "]"}], "[", "#3", "]"}]}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", "0"}], "]"}], "/.", 
      "\[InvisibleSpace]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"0", "\[Rule]", "p"}], ",", 
        RowBox[{"1", "\[Rule]", "q"}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"r", "[", "x_", "]"}], "\[Rule]", 
        RowBox[{
         RowBox[{"p", "[", 
          RowBox[{
           RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "]"}], "[", "x", 
         "]"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"p", "[", "x_", "]"}], "[", "p", "]"}], "[", "p", "]"}], 
         "[", "r", "]"}], "\[Rule]", 
        RowBox[{
         RowBox[{
          RowBox[{"x", "[", "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]}]}], 
      "}"}]}], "}"}], "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Fold", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#1", "[", "#2", "]"}], "&"}], ",", 
      RowBox[{
       RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], ",", 
      RowBox[{"init", "/.", "\[InvisibleSpace]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"0", "\[Rule]", "p"}], ",", 
         RowBox[{"1", "\[Rule]", "q"}]}], "}"}]}]}], "]"}], "[", "p", "]"}], 
   "[", "p", "]"}], "[", "r", "]"}]}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ElementaryCARule", "[", "n_", "]"}], ":=", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"i", ",", "2", ",", "3"}], "]"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "7"}], "}"}]}], "]"}], "]"}], "->", 
    RowBox[{"IntegerDigits", "[", 
     RowBox[{"n", ",", "2", ",", "8"}], "]"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"init", "=", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Fold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          TagBox["#1",
           #& ,
           SyntaxForm->"a"], "[", 
          TagBox["#2",
           #& ,
           SyntaxForm->"a"], "]"}], "&"}], ",", 
        RowBox[{
         RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], ",", 
        RowBox[{"init", "/.", "\[InvisibleSpace]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0", "\[Rule]", "p"}], ",", 
           RowBox[{"1", "\[Rule]", "q"}]}], "}"}]}]}], "]"}], "[", "p", "]"}],
      "[", "p", "]"}], "[", "r", "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[",
         "p", "]"}], "[", "q", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", 
    "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]], "Output",
 CellChangeTimes->{3.413734331030106*^9, 3.413734424273501*^9, 
  3.428254708556067*^9, 3.4323249548378983`*^9, 3.432325568559401*^9, 
  3.432325787614234*^9, 3.432325829718481*^9, 3.432326458393425*^9, 
  3.500211616115664*^9, 3.5130885158994713`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"rules", "=", 
     RowBox[{"ElementaryCARule", "[", "90", "]"}]}], "}"}], ",", 
   StyleBox[
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"p", "[", "x_", "]"}], "[", 
               TagBox["#1",
                #& ,
                SyntaxForm->"a"], "]"}], "[", 
              TagBox["#2",
               #& ,
               SyntaxForm->"a"], "]"}], "[", 
             TagBox["#3",
              #& ,
              SyntaxForm->"a"], "]"}], "\[Rule]", 
            RowBox[{
             RowBox[{
              RowBox[{"p", "[", 
               RowBox[{"x", "[", 
                RowBox[{
                 RowBox[{"{", "##", "}"}], "/.", "\[InvisibleSpace]", 
                 "rules"}], "]"}], "]"}], "[", 
              TagBox["#2",
               #& ,
               SyntaxForm->"a"], "]"}], "[", 
             TagBox["#3",
              #& ,
              SyntaxForm->"a"], "]"}]}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", "0"}], "]"}], "/.", 
        "\[InvisibleSpace]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"0", "\[Rule]", "p"}], ",", 
          RowBox[{"1", "\[Rule]", "q"}]}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"r", "[", "x_", "]"}], "\[Rule]", 
          RowBox[{
           RowBox[{"p", "[", 
            RowBox[{
             RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "]"}], "[", "x", 
           "]"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"p", "[", "x_", "]"}], "[", "p", "]"}], "[", "p", "]"}], 
           "[", "r", "]"}], "\[Rule]", 
          RowBox[{
           RowBox[{
            RowBox[{"x", "[", "p", "]"}], "[", "p", "]"}], "[", "r", 
           "]"}]}]}], "}"}]}], "}"}], "]"}],
    LineIndent->0.2]}], 
  StyleBox["]",
   LineIndent->0.2]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "x$_", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", 
     "p", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"x$", "[", "p", "]"}], "]"}], "[", "p", "]"}], "[", "p", 
     "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "x$_", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", 
     "q", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"x$", "[", "q", "]"}], "]"}], "[", "p", "]"}], "[", "q", 
     "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "x$_", "]"}], "[", "p", "]"}], "[", "q", "]"}], "[", 
     "p", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"x$", "[", "p", "]"}], "]"}], "[", "q", "]"}], "[", "p", 
     "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "x$_", "]"}], "[", "p", "]"}], "[", "q", "]"}], "[", 
     "q", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"x$", "[", "q", "]"}], "]"}], "[", "q", "]"}], "[", "q", 
     "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "x$_", "]"}], "[", "q", "]"}], "[", "p", "]"}], "[", 
     "p", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"x$", "[", "q", "]"}], "]"}], "[", "p", "]"}], "[", "p", 
     "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "x$_", "]"}], "[", "q", "]"}], "[", "p", "]"}], "[", 
     "q", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"x$", "[", "p", "]"}], "]"}], "[", "p", "]"}], "[", "q", 
     "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "x$_", "]"}], "[", "q", "]"}], "[", "q", "]"}], "[", 
     "p", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"x$", "[", "q", "]"}], "]"}], "[", "q", "]"}], "[", "p", 
     "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "x$_", "]"}], "[", "q", "]"}], "[", "q", "]"}], "[", 
     "q", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"x$", "[", "p", "]"}], "]"}], "[", "q", "]"}], "[", "q", 
     "]"}]}], ",", 
   RowBox[{
    RowBox[{"r", "[", "x_", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"p", "[", 
      RowBox[{
       RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "]"}], "[", "x", 
     "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", "x_", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", 
     "r", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "[", "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.413734331074257*^9, 3.4137344243419*^9, 
  3.42825471008539*^9, 3.432324954896188*^9, 3.4323255686121693`*^9, 
  3.4323257876740522`*^9, 3.432325829779129*^9, 3.4323264584525967`*^9, 
  3.5002116173029003`*^9, 3.513088517022496*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "/.", 
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"rules", "=", 
          RowBox[{"ElementaryCARule", "[", "90", "]"}]}], "}"}], ",", 
        StyleBox[
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"Array", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"p", "[", "x_", "]"}], "[", 
                    TagBox["#1",
                    #& ,
                    SyntaxForm->"a"], "]"}], "[", 
                   TagBox["#2",
                    #& ,
                    SyntaxForm->"a"], "]"}], "[", 
                  TagBox["#3",
                   #& ,
                   SyntaxForm->"a"], "]"}], "\[Rule]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"p", "[", 
                    RowBox[{"x", "[", 
                    RowBox[{
                    RowBox[{"{", "##", "}"}], "/.", "\[InvisibleSpace]", 
                    "rules"}], "]"}], "]"}], "[", 
                   TagBox["#2",
                    #& ,
                    SyntaxForm->"a"], "]"}], "[", 
                  TagBox["#3",
                   #& ,
                   SyntaxForm->"a"], "]"}]}], "&"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", "0"}], "]"}], "/.",
              "\[InvisibleSpace]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0", "\[Rule]", "p"}], ",", 
               RowBox[{"1", "\[Rule]", "q"}]}], "}"}]}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"r", "[", "x_", "]"}], "\[Rule]", 
               RowBox[{
                RowBox[{"p", "[", 
                 RowBox[{
                  RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "]"}], "[", 
                "x", "]"}]}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"p", "[", "x_", "]"}], "[", "p", "]"}], "[", "p", 
                 "]"}], "[", "r", "]"}], "\[Rule]", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "[", "p", "]"}], "[", "p", "]"}], "[", "r", 
                "]"}]}]}], "}"}]}], "}"}], "]"}],
         LineIndent->0.2]}], 
       StyleBox["]",
        LineIndent->0.2]}]}], "&"}], ",", " ", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"init", "=", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], 
       "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Fold", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             TagBox["#1",
              #& ,
              SyntaxForm->"a"], "[", 
             TagBox["#2",
              #& ,
              SyntaxForm->"a"], "]"}], "&"}], ",", 
           RowBox[{
            RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], ",", 
           RowBox[{"init", "/.", "\[InvisibleSpace]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"0", "\[Rule]", "p"}], ",", 
              RowBox[{"1", "\[Rule]", "q"}]}], "}"}]}]}], "]"}], "[", "p", 
         "]"}], "[", "p", "]"}], "[", "r", "]"}]}], "]"}], ",", " ", "10"}], 
   "]"}], "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.513088509272244*^9, 3.513088525113923*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", "]"}],
              "[", "p", "]"}], "[", "q", "]"}], "[", "p", "]"}], "[", "p", 
          "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"p", "[", 
                 RowBox[{
                  RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "]"}], "[", 
                "p", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", "p", "]"}],
             "[", "q", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
         "]"}], "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"p", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
                 "]"}], "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
             "]"}], "[", "q", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", 
         "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"p", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
                 "]"}], "[", "p", "]"}], "]"}], "[", "p", "]"}], "[", "p", 
             "]"}], "[", "q", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", 
         "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"p", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
                 "]"}], "[", "p", "]"}], "[", "q", "]"}], "]"}], "[", "p", 
             "]"}], "[", "q", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", 
         "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"p", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
                 "]"}], "[", "p", "]"}], "[", "q", "]"}], "[", "p", "]"}], 
             "]"}], "[", "q", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", 
         "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"p", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
                 "]"}], "[", "p", "]"}], "[", "q", "]"}], "[", "p", "]"}], 
             "[", "q", "]"}], "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", 
         "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"p", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
                 "]"}], "[", "p", "]"}], "[", "q", "]"}], "[", "p", "]"}], 
             "[", "q", "]"}], "[", "p", "]"}], "]"}], "[", "p", "]"}], "[", 
         "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"p", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
                 "]"}], "[", "p", "]"}], "[", "q", "]"}], "[", "p", "]"}], 
             "[", "q", "]"}], "[", "p", "]"}], "[", "p", "]"}], "]"}], "[", 
         "p", "]"}], "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
                "]"}], "[", "p", "]"}], "[", "q", "]"}], "[", "p", "]"}], "[",
             "q", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", "p", "]"}], 
        "[", "p", "]"}], "[", "r", "]"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"p", "[", 
                   RowBox[{
                    RowBox[{"r", "[", "p", "]"}], "[", "p", "]"}], "]"}], "[",
                   "p", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", "p", 
               "]"}], "[", "q", "]"}], "[", "p", "]"}], "[", "q", "]"}], "[", 
           "p", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[", "p", "]"}], "[",
        "r", "]"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.413734331127038*^9, 3.4137344244097*^9, 3.428254711678471*^9, 
   3.432324954946638*^9, 3.432325568667102*^9, 3.43232578772692*^9, 
   3.432325829844689*^9, 3.432326458581829*^9, 3.500211618817464*^9, {
   3.513088518237062*^9, 3.513088526821267*^9}}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 669 \[CenterDot] Cyclic tag systems", "Subsection"], Cell[
     " (page 1113)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TS1ToCT", "[", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "subs_"}], "}"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"k", "=", 
       RowBox[{"Length", "[", "subs", "]"}]}], "}"}], ",", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"v", "[", 
           RowBox[{
            RowBox[{"Last", "[", "#", "]"}], ",", "k"}], "]"}], "&"}], ",", 
         "subs"}], "]"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", " ", 
           RowBox[{"(", 
            RowBox[{"n", "-", "1"}], ")"}]}], "}"}]}], "]"}]}], "]"}]}], 
    "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"i_", ",", "k_"}], "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"j", "==", 
        RowBox[{"i", "+", "1"}]}], ",", "1", ",", "0"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"v", "[", 
    RowBox[{"list_", ",", "k_"}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", 
        RowBox[{"#", ",", "k"}], "]"}], "&"}], ",", "list"}], "]"}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Map", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{"#", ",", "1"}], "]"}], "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "-", "1"}], 
       "&"}], ",", 
      RowBox[{"Partition", "[", 
       RowBox[{"#", ",", "k"}], "]"}]}], "]"}], "&"}], ",", 
   RowBox[{"Take", "[", 
    RowBox[{"history", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", 
       RowBox[{"n", " ", "k"}]}], "}"}]}], "]"}]}], "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"TS1ToCT", "[", 
   RowBox[{"{", 
    RowBox[{"n_", ",", "subs_"}], "}"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"k", "=", 
      RowBox[{"Length", "[", "subs", "]"}]}], "}"}], ",", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"v", "[", 
          RowBox[{
           RowBox[{"Last", "[", "#", "]"}], ",", "k"}], "]"}], "&"}], ",", 
        "subs"}], "]"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"k", " ", 
          RowBox[{"(", 
           RowBox[{"n", "-", "1"}], ")"}]}], "}"}]}], "]"}]}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"u", "[", 
   RowBox[{"i_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"j", "==", 
       RowBox[{"i", "+", "1"}]}], ",", "1", ",", "0"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "k"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"v", "[", 
   RowBox[{"list_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{"#", ",", "k"}], "]"}], "&"}], ",", "list"}], "]"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CTEvolveList", "[", 
   RowBox[{"rules_", ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Last", ",", 
    RowBox[{"NestList", "[", 
     RowBox[{"CTStep", ",", 
      RowBox[{"{", 
       RowBox[{"rules", ",", "init"}], "}"}], ",", "t"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CTStep", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "s___"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "a___"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", "r"}], "}"}], ",", 
    RowBox[{"{", "a", "}"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"CTStep", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "s___"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "a___"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", "r"}], "}"}], ",", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "a", "}"}], ",", "r"}], "]"}]}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"CTStep", "[", 
   RowBox[{"{", 
    RowBox[{"u_", ",", 
     RowBox[{"{", "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"u", ",", 
    RowBox[{"{", "}"}]}], "}"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TS1ToCT", "[", 
  RowBox[{"{", 
   RowBox[{"3", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"0", "->", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"1", "->", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}]}]}], "}"}]}], 
   "}"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413734331212173*^9, 3.413734424539999*^9, 
  3.428254718917757*^9, 3.4323249550204277`*^9, 3.432325568870175*^9, 
  3.4323257877982483`*^9, 3.432325829920041*^9, 3.432326458679166*^9, 
  3.5002116243944683`*^9}]
}, Open  ]],

Cell["\<\
Note that substitutions must be given in the order 0->{..}, 1->{...}, ... \
\>", "Text",
 CellChangeTimes->{{3.5348774915609703`*^9, 3.5348775184219704`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", "2"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.4137343312738953`*^9, 3.4137344246243067`*^9, 
  3.428254720408396*^9, 3.432324955078899*^9, 3.4323255689292383`*^9, 
  3.4323257878578777`*^9, 3.4323258299808617`*^9, 3.432326458731419*^9, 
  3.500211626031107*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CTEvolveList", "[", 
  RowBox[{
   RowBox[{"TS1ToCT", "[", 
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"0", "->", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"1", "->", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}]}]}], "}"}]}], 
     "}"}], "]"}], ",", 
   RowBox[{"v", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     "2"}], "]"}], ",", "30"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1",
      ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0",
      ",", "1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1",
      ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0",
      ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1",
      ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1",
      ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0",
      ",", "1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1",
      ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0",
      ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0",
      ",", "1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1",
      ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1",
      ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0",
      ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1",
      ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0",
      ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.41373433141006*^9, 3.413734424729762*^9, 
  3.428254721986662*^9, 3.432324955131529*^9, 3.432325568984249*^9, 
  3.432325787911099*^9, 3.43232583003263*^9, 3.432326458781892*^9, 
  3.500211627419396*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"n", "=", "3"}], ",", 
     RowBox[{"k", "=", "2"}]}], "}"}], ",", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{"#", ",", "1"}], "]"}], "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "-", "1"}], 
         "&"}], ",", 
        RowBox[{"Partition", "[", 
         RowBox[{"#", ",", "k"}], "]"}]}], "]"}], "&"}], ",", 
     RowBox[{"Take", "[", 
      RowBox[{"%", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}], ",", 
         RowBox[{"n", " ", "k"}]}], "}"}]}], "]"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413734331458487*^9, 3.413734424820182*^9, 
  3.43232495517852*^9, 3.432325569029419*^9, 3.432325787959794*^9, 
  3.432325830077365*^9, 3.432326458833105*^9, 3.5002116291530848`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 669 \[CenterDot] Multicolor Turing machines\
\>", "Subsection"], Cell[" (page 1113)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TMToTM2", "[", 
    RowBox[{"rule_", ",", "s_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"#", "/.", "\[InvisibleSpace]", 
       RowBox[{"MapIndexed", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "\[Rule]", 
           RowBox[{"First", "[", "#2", "]"}]}], "&"}], ",", 
         RowBox[{"Union", "[", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "&"}], ",", 
            "#"}], "]"}], "]"}]}], "]"}]}], "&"}], ")"}], "[", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"b", "=", 
        RowBox[{
         RowBox[{"Ceiling", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"2", ",", "k"}], "]"}], "]"}], "-", "1"}]}], "}"}], ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", ",", "i", ",", "n", ",", "d"}], "}"}], ",", 
                    "c"}], "}"}], "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Mod", "[", 
                    RowBox[{"i", ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
                    RowBox[{"n", "-", "1"}]}]]}], "]"}], ",", 
                    RowBox[{"n", "-", "1"}], ",", "d"}], "}"}], ",", 
                    RowBox[{"Quotient", "[", 
                    RowBox[{"i", ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
                    RowBox[{"n", "-", "1"}]}]]}], "]"}], ",", "1"}], "}"}]}], 
                 ",", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", "2", ",", "b"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "0", ",", 
                   RowBox[{
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]], "-", 
                    "1"}]}], "}"}]}], "]"}], ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", ",", "i", ",", "1", ",", "d"}], "}"}], ",", 
                    "c"}], "}"}], "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"-", "1"}], ",", "1", ",", "d"}], "}"}], ",", "i",
                     ",", "d"}], "}"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "0", ",", "1"}], "}"}]}], "]"}], ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"-", "1"}], ",", "n", ",", "d"}], "}"}], ",", 
                    "c"}], "}"}], "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"n", "+", "1"}], ",", "d"}], "}"}], ",", "c", ",",
                     "d"}], "}"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"n", ",", 
                   RowBox[{"b", "-", "1"}]}], "}"}]}], "]"}], ",", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"m", ",", 
                    RowBox[{"-", "1"}], ",", "b", ",", "d"}], "}"}], ",", 
                  "c"}], "}"}], "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0", ",", "m"}], "}"}], ",", "c", ",", 
                  "d"}], "}"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"d", ",", 
               RowBox[{"-", "1"}], ",", "1", ",", "2"}], "}"}]}], "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"i", ",", "n", ",", "m"}], "}"}], ",", "c"}], "}"}], 
              "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"i", "+", 
                   RowBox[{
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]], " ", 
                    "c"}]}], ",", 
                  RowBox[{"n", "+", "1"}], ",", "m"}], "}"}], ",", "c", ",", 
                RowBox[{"-", "1"}]}], "}"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "0", ",", 
               RowBox[{"b", "-", "1"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{
                SuperscriptBox["2", 
                 RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]], "-", 
                "1"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"With", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"r", "=", 
               SuperscriptBox["2", 
                RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "b"}]]}], "}"}], 
             ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"i", "+", 
                   RowBox[{"r", " ", "c"}]}], "\[GreaterEqual]", "k"}], ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{"Cases", "[", 
                  RowBox[{"rule", ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"i", "+", 
                    RowBox[{"r", " ", "c"}]}]}], "}"}], "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}]}], ")"}], 
                    "\[Rule]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "b", ",", "m"}], "}"}], ",", "c"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"x", ",", 
                    RowBox[{"Mod", "[", 
                    RowBox[{"y", ",", "r"}], "]"}], ",", "b", ",", "z"}], 
                    "}"}], ",", 
                    RowBox[{"Quotient", "[", 
                    RowBox[{"y", ",", "r"}], "]"}], ",", "1"}], "}"}]}]}]}], 
                  "]"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "0", ",", 
                 RowBox[{"r", "-", "1"}]}], "}"}]}], "]"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", "s"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"c", ",", "0", ",", "1"}], "}"}]}], "]"}], "]"}]}], "]"}], 
    "]"}]}], "\n"}], "\n", 
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"b", "=", 
     RowBox[{"Ceiling", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"2", ",", "k"}], "]"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"IntegerDigits", "[", 
       RowBox[{"list", ",", "2", ",", "b"}], "]"}], "]"}], ",", 
     RowBox[{"b", " ", "n"}]}], "}"}]}], "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"TMToTM2", "[", 
   RowBox[{"rule_", ",", "s_", ",", "k_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"#", "/.", "\[InvisibleSpace]", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "\[Rule]", 
          RowBox[{"First", "[", "#2", "]"}]}], "&"}], ",", 
        RowBox[{"Union", "[", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "&"}], ",", 
           "#"}], "]"}], "]"}]}], "]"}]}], "&"}], ")"}], "[", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"b", "=", 
       RowBox[{
        RowBox[{"Ceiling", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"2", ",", "k"}], "]"}], "]"}], "-", "1"}]}], "}"}], ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", ",", "i", ",", "n", ",", "d"}], "}"}], ",", 
                   "c"}], "}"}], "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"Mod", "[", 
                    RowBox[{"i", ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
                    RowBox[{"n", "-", "1"}]}]]}], "]"}], ",", 
                    RowBox[{"n", "-", "1"}], ",", "d"}], "}"}], ",", 
                   RowBox[{"Quotient", "[", 
                    RowBox[{"i", ",", 
                    SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", 
                    RowBox[{"n", "-", "1"}]}]]}], "]"}], ",", "1"}], "}"}]}], 
                ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", "2", ",", "b"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "0", ",", 
                  RowBox[{
                   SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]], "-", 
                   "1"}]}], "}"}]}], "]"}], ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", ",", "i", ",", "1", ",", "d"}], "}"}], ",", 
                   "c"}], "}"}], "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"-", "1"}], ",", "1", ",", "d"}], "}"}], ",", "i",
                    ",", "d"}], "}"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "0", ",", "1"}], "}"}]}], "]"}], ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"-", "1"}], ",", "n", ",", "d"}], "}"}], ",", 
                   "c"}], "}"}], "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"n", "+", "1"}], ",", "d"}], "}"}], ",", "c", ",",
                    "d"}], "}"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"n", ",", 
                  RowBox[{"b", "-", "1"}]}], "}"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"m", ",", 
                   RowBox[{"-", "1"}], ",", "b", ",", "d"}], "}"}], ",", 
                 "c"}], "}"}], "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0", ",", "m"}], "}"}], ",", "c", ",", 
                 "d"}], "}"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"d", ",", 
              RowBox[{"-", "1"}], ",", "1", ",", "2"}], "}"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", "n", ",", "m"}], "}"}], ",", "c"}], "}"}], 
             "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"i", "+", 
                  RowBox[{
                   SuperscriptBox["2", 
                    RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]], " ", 
                   "c"}]}], ",", 
                 RowBox[{"n", "+", "1"}], ",", "m"}], "}"}], ",", "c", ",", 
               RowBox[{"-", "1"}]}], "}"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "0", ",", 
              RowBox[{"b", "-", "1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", 
              RowBox[{
               SuperscriptBox["2", 
                RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]], "-", 
               "1"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"r", "=", 
              SuperscriptBox["2", 
               RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "b"}]]}], "}"}], 
            ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"i", "+", 
                  RowBox[{"r", " ", "c"}]}], "\[GreaterEqual]", "k"}], ",", 
                RowBox[{"{", "}"}], ",", 
                RowBox[{"Cases", "[", 
                 RowBox[{"rule", ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"m", ",", 
                    RowBox[{"i", "+", 
                    RowBox[{"r", " ", "c"}]}]}], "}"}], "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}]}], ")"}], 
                   "\[Rule]", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"i", ",", "b", ",", "m"}], "}"}], ",", "c"}], 
                    "}"}], "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"x", ",", 
                    RowBox[{"Mod", "[", 
                    RowBox[{"y", ",", "r"}], "]"}], ",", "b", ",", "z"}], 
                    "}"}], ",", 
                    RowBox[{"Quotient", "[", 
                    RowBox[{"y", ",", "r"}], "]"}], ",", "1"}], "}"}]}]}]}], 
                 "]"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "0", ",", 
                RowBox[{"r", "-", "1"}]}], "}"}]}], "]"}]}], "]"}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", "s"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"c", ",", "0", ",", "1"}], "}"}]}], "]"}], "]"}]}], "]"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"TMEvolveList", "[", 
   RowBox[{"rule_", ",", "init_List", ",", "t_Integer"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TMStep", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TMStep", "[", 
    RowBox[{"rule_List", ",", 
     RowBox[{"{", 
      RowBox[{"s_", ",", "a_List", ",", "n_"}], "}"}]}], "]"}], "/;", 
   RowBox[{"1", "\[LessEqual]", "n", "\[LessEqual]", 
    RowBox[{"Length", "[", "a", "]"}]}]}], ":=", 
  RowBox[{"Apply", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       TagBox["#1",
        #& ,
        SyntaxForm->"a"], ",", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{"a", ",", 
         TagBox["#2",
          #& ,
          SyntaxForm->"a"], ",", "n"}], "]"}], ",", 
       RowBox[{"n", "+", 
        TagBox["#3",
         #& ,
         SyntaxForm->"a"]}]}], "}"}], "&"}], ",", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", 
        RowBox[{"a", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}]}],
        "}"}], ",", "rule"}], "]"}]}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TMEvolveList", "[", 
  RowBox[{
   RowBox[{"TMToTM2", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", "1"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]}], "}"}], ",", "2", ",", 
     " ", "3"}], "]"}], ",", " ", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", " ", 
       RowBox[{"list", " ", "=", 
        RowBox[{"{", 
         RowBox[{
         "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",",
           "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", " ", 
       RowBox[{"n", " ", "=", "5"}], ",", " ", 
       RowBox[{"k", "=", "3"}]}], "}"}], ",", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"b", "=", 
         RowBox[{"Ceiling", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"2", ",", "k"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Flatten", "[", 
          RowBox[{"IntegerDigits", "[", 
           RowBox[{"list", ",", "2", ",", "b"}], "]"}], "]"}], ",", 
         RowBox[{"b", "\[ThinSpace]", "n"}]}], "}"}]}], "]"}]}], "]"}], ",", 
   " ", "10"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"16", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"18", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "14"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}], ",", "14"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413734331544422*^9, 3.413734425164456*^9, 
  3.428254732511636*^9, 3.432324955260572*^9, 3.432325569126444*^9, 
  3.432325788069181*^9, 3.432325830257173*^9, 3.432326458916053*^9, 
  3.5002116366508408`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 670 \[CenterDot] One-element-dependence tag systems\
\>", "Subsection"], Cell[" (page 1114)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TS1EvolveList", "[", 
    RowBox[{"rule_", ",", "init_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"NestList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"TS1Step", "[", 
       RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
    "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TS1Step", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n_", ",", "subs_"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], "=", 
   RowBox[{"{", "}"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TS1Step", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n_", ",", "subs_"}], "}"}], ",", "list_"}], "]"}], ":=", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{"Join", "[", 
      RowBox[{"list", ",", 
       RowBox[{
        RowBox[{"First", "[", "list", "]"}], "/.", "\[InvisibleSpace]", 
        "subs"}]}], "]"}], ",", "n"}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TMToTS1", "[", "rules_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"Union", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{"rules", "/.", "\[InvisibleSpace]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"i_", ",", "u_"}], "}"}], "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"j_", ",", "v_", ",", "r_"}], "}"}]}], ")"}], 
         "\[RuleDelayed]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", "i", "]"}], "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"i", ",", "1"}], "]"}], ",", 
                 RowBox[{"#", "[", 
                  RowBox[{"i", ",", "0"}], "]"}]}], "}"}]}], "&"}], ",", 
             RowBox[{"{", 
              RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "]"}], 
           ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"r", "==", "1"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"a", "[", 
                 RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"a", "[", "j", "]"}], ",", 
                  RowBox[{"a", "[", "j", "]"}]}], "}"}]}], ",", 
               RowBox[{
                RowBox[{"b", "[", 
                 RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"b", "[", "j", "]"}], ",", 
                  RowBox[{"{", "4", "}"}]}], "]"}]}], ",", 
               RowBox[{
                RowBox[{"c", "[", 
                 RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
                RowBox[{"Flatten", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"b", "[", "j", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2", " ", "v"}], "}"}]}], "]"}], ",", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"c", "[", "j", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2", "-", "u"}], "}"}]}], "]"}]}], "}"}], "]"}]}],
                ",", 
               RowBox[{
                RowBox[{"d", "[", 
                 RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"d", "[", "j", "]"}], "}"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"a", "[", 
                 RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"a", "[", "j", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"2", "-", "u"}], "}"}]}], "]"}]}], ",", 
               RowBox[{
                RowBox[{"b", "[", 
                 RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"b", "[", "j", "]"}], "}"}]}], ",", 
               RowBox[{
                RowBox[{"c", "[", 
                 RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
                RowBox[{"Flatten", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"c", "[", "j", "]"}], ",", 
                   RowBox[{"c", "[", "j", "]"}], ",", 
                   RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"d", "[", "j", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2", " ", "v"}], "}"}]}], "]"}]}], "}"}], "]"}]}],
                ",", 
               RowBox[{
                RowBox[{"d", "[", 
                 RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"d", "[", "j", "]"}], ",", 
                  RowBox[{"{", "4", "}"}]}], "]"}]}]}], "}"}]}], "]"}]}], 
          "}"}]}]}], "]"}], "]"}]}], "}"}]}], "\n"}], "\n", 
 RowBox[{"Cases", "[", 
  RowBox[{"history", ",", 
   RowBox[{
    RowBox[{"x", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", "[", "_", "]"}], ",", "___"}], "}"}]}], "\[RuleDelayed]", 
    RowBox[{"Apply", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#1", ",", 
         RowBox[{"Reverse", "[", "#2", "]"}]}], "}"}], "&"}], ",", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", 
            RowBox[{
             RowBox[{"Count", "[", 
              RowBox[{"x", ",", "#"}], "]"}], ",", "2"}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{"_b", ",", "_d"}], "}"}]}], "]"}]}], "]"}]}]}], 
  "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"TS1EvolveList", "[", 
   RowBox[{"rule_", ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TS1Step", "[", 
      RowBox[{"rule", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"TS1Step", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n_", ",", "subs_"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"TS1Step", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n_", ",", "subs_"}], "}"}], ",", "list_"}], "]"}], ":=", 
  RowBox[{"Drop", "[", 
   RowBox[{
    RowBox[{"Join", "[", 
     RowBox[{"list", ",", 
      RowBox[{
       RowBox[{"First", "[", "list", "]"}], "/.", "\[InvisibleSpace]", 
       "subs"}]}], "]"}], ",", "n"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"TMToTS1", "[", "rules_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"2", ",", 
    RowBox[{"Union", "[", "\[IndentingNewLine]", 
     RowBox[{"Flatten", "[", 
      RowBox[{"rules", "/.", "\[InvisibleSpace]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i_", ",", "u_"}], "}"}], "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"j_", ",", "v_", ",", "r_"}], "}"}]}], ")"}], 
        "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", "i", "]"}], "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"i", ",", "1"}], "]"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"i", ",", "0"}], "]"}]}], "}"}]}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "]"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"r", "==", "1"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "[", 
                RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"a", "[", "j", "]"}], ",", 
                 RowBox[{"a", "[", "j", "]"}]}], "}"}]}], ",", 
              RowBox[{
               RowBox[{"b", "[", 
                RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"b", "[", "j", "]"}], ",", 
                 RowBox[{"{", "4", "}"}]}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"c", "[", 
                RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
               RowBox[{"Flatten", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"b", "[", "j", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2", " ", "v"}], "}"}]}], "]"}], ",", 
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"c", "[", "j", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2", "-", "u"}], "}"}]}], "]"}]}], "}"}], "]"}]}],
               ",", 
              RowBox[{
               RowBox[{"d", "[", 
                RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"d", "[", "j", "]"}], "}"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"a", "[", 
                RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"a", "[", "j", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", "-", "u"}], "}"}]}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"b", "[", 
                RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"b", "[", "j", "]"}], "}"}]}], ",", 
              RowBox[{
               RowBox[{"c", "[", 
                RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
               RowBox[{"Flatten", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"c", "[", "j", "]"}], ",", 
                  RowBox[{"c", "[", "j", "]"}], ",", 
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"d", "[", "j", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2", " ", "v"}], "}"}]}], "]"}]}], "}"}], "]"}]}],
               ",", 
              RowBox[{
               RowBox[{"d", "[", 
                RowBox[{"i", ",", "u"}], "]"}], "\[Rule]", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"d", "[", "j", "]"}], ",", 
                 RowBox[{"{", "4", "}"}]}], "]"}]}]}], "}"}]}], "]"}]}], 
         "}"}]}]}], "]"}], "]"}]}], "}"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TMToTS1", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"2", ",", " ", "0", ",", " ", "1"}], "}"}]}], ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", " ", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]}], " ", "}"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"1", ",", "1"}], "]"}], ",", 
        RowBox[{"a", "[", 
         RowBox[{"1", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"2", ",", "1"}], "]"}], ",", 
        RowBox[{"a", "[", 
         RowBox[{"2", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", "3", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"3", ",", "1"}], "]"}], ",", 
        RowBox[{"a", "[", 
         RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", "3", "]"}], ",", 
        RowBox[{"a", "[", "3", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"1", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", "2", "]"}], ",", 
        RowBox[{"a", "[", "2", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", "1", "]"}], ",", 
        RowBox[{"a", "[", "1", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"2", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", "3", "]"}], ",", 
        RowBox[{"a", "[", "3", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"3", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "[", "2", "]"}], ",", 
        RowBox[{"a", "[", "2", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"3", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"a", "[", "1", "]"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", "1", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", 
         RowBox[{"1", ",", "1"}], "]"}], ",", 
        RowBox[{"b", "[", 
         RowBox[{"1", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", 
         RowBox[{"2", ",", "1"}], "]"}], ",", 
        RowBox[{"b", "[", 
         RowBox[{"2", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", "3", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", 
         RowBox[{"3", ",", "1"}], "]"}], ",", 
        RowBox[{"b", "[", 
         RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", 
       RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"b", "[", "3", "]"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", 
       RowBox[{"1", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", "2", "]"}], ",", 
        RowBox[{"b", "[", "2", "]"}], ",", 
        RowBox[{"b", "[", "2", "]"}], ",", 
        RowBox[{"b", "[", "2", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", 
       RowBox[{"2", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ",", 
        RowBox[{"b", "[", "1", "]"}], ",", 
        RowBox[{"b", "[", "1", "]"}], ",", 
        RowBox[{"b", "[", "1", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", 
       RowBox[{"2", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", "3", "]"}], ",", 
        RowBox[{"b", "[", "3", "]"}], ",", 
        RowBox[{"b", "[", "3", "]"}], ",", 
        RowBox[{"b", "[", "3", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", 
       RowBox[{"3", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", "2", "]"}], ",", 
        RowBox[{"b", "[", "2", "]"}], ",", 
        RowBox[{"b", "[", "2", "]"}], ",", 
        RowBox[{"b", "[", "2", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"b", "[", 
       RowBox[{"3", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"b", "[", "1", "]"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", "1", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"c", "[", 
         RowBox[{"1", ",", "1"}], "]"}], ",", 
        RowBox[{"c", "[", 
         RowBox[{"1", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"c", "[", 
         RowBox[{"2", ",", "1"}], "]"}], ",", 
        RowBox[{"c", "[", 
         RowBox[{"2", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", "3", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"c", "[", 
         RowBox[{"3", ",", "1"}], "]"}], ",", 
        RowBox[{"c", "[", 
         RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"c", "[", "3", "]"}], ",", 
        RowBox[{"c", "[", "3", "]"}], ",", 
        RowBox[{"d", "[", "3", "]"}], ",", 
        RowBox[{"d", "[", "3", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"1", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"c", "[", "2", "]"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"2", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", "1", "]"}], ",", 
        RowBox[{"b", "[", "1", "]"}], ",", 
        RowBox[{"c", "[", "1", "]"}], ",", 
        RowBox[{"c", "[", "1", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"2", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", "3", "]"}], ",", 
        RowBox[{"b", "[", "3", "]"}], ",", 
        RowBox[{"c", "[", "3", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"3", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"b", "[", "2", "]"}], ",", 
        RowBox[{"b", "[", "2", "]"}], ",", 
        RowBox[{"c", "[", "2", "]"}], ",", 
        RowBox[{"c", "[", "2", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"3", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"c", "[", "1", "]"}], ",", 
        RowBox[{"c", "[", "1", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"d", "[", "1", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"d", "[", 
         RowBox[{"1", ",", "1"}], "]"}], ",", 
        RowBox[{"d", "[", 
         RowBox[{"1", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"d", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"d", "[", 
         RowBox[{"2", ",", "1"}], "]"}], ",", 
        RowBox[{"d", "[", 
         RowBox[{"2", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"d", "[", "3", "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"d", "[", 
         RowBox[{"3", ",", "1"}], "]"}], ",", 
        RowBox[{"d", "[", 
         RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"d", "[", "3", "]"}], ",", 
        RowBox[{"d", "[", "3", "]"}], ",", 
        RowBox[{"d", "[", "3", "]"}], ",", 
        RowBox[{"d", "[", "3", "]"}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"1", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"d", "[", "2", "]"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"2", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"d", "[", "1", "]"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"2", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"d", "[", "3", "]"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"3", ",", "0"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"d", "[", "2", "]"}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"3", ",", "1"}], "]"}], "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"d", "[", "1", "]"}], ",", 
        RowBox[{"d", "[", "1", "]"}], ",", 
        RowBox[{"d", "[", "1", "]"}], ",", 
        RowBox[{"d", "[", "1", "]"}]}], "}"}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.41373433162241*^9, 3.413734425222822*^9, 
  3.428254752983233*^9, 3.432324955414975*^9, 3.4323255692876883`*^9, 
  3.432325788239706*^9, 3.432325830377254*^9, 3.432326459002234*^9, 
  3.5002116449360037`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"history", "=", 
     RowBox[{"TS1EvolveList", "[", 
      RowBox[{
       RowBox[{"TMToTS1", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", " ", 
           RowBox[{"{", 
            RowBox[{"2", ",", " ", "0", ",", " ", "1"}], "}"}]}], ",", " ", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", 
             RowBox[{"-", "1"}]}], "}"}]}], ",", " ", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", " ", "1"}], "}"}], "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}]}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", 
             RowBox[{"-", "1"}]}], "}"}]}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]}], " ", "}"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"a", "[", "1", "]"}], ",", 
         RowBox[{"a", "[", "1", "]"}], ",", 
         RowBox[{"c", "[", "1", "]"}]}], "}"}], ",", "200"}], "]"}]}], "}"}], 
   ",", 
   RowBox[{"Cases", "[", 
    RowBox[{"history", ",", 
     RowBox[{
      RowBox[{"x", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"a", "[", "_", "]"}], ",", "___"}], "}"}]}], 
      "\[RuleDelayed]", 
      RowBox[{"Apply", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"#1", ",", 
           RowBox[{"Reverse", "[", "#2", "]"}]}], "}"}], "&"}], ",", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"IntegerDigits", "[", 
              RowBox[{
               RowBox[{"Count", "[", 
                RowBox[{"x", ",", "#"}], "]"}], ",", "2"}], "]"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"_b", ",", "_d"}], "}"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "1", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "1", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", "1", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413734331677108*^9, 3.413734425276306*^9, 
  3.428254755007654*^9, 3.432324955465288*^9, 3.432325569352194*^9, 
  3.432325788291686*^9, 3.4323258304278297`*^9, 3.4323264590557117`*^9, 
  3.500211648283724*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 672 \[CenterDot] Register machines", "Subsection"], Cell[
     " (page 1114)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TMToRM", "[", "rules_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"segs", ",", "adrs"}], "}"}], ",", 
     RowBox[{
      RowBox[{"segs", "=", 
       RowBox[{"Map", "[", 
        RowBox[{"TMCompile", ",", "rules"}], "]"}]}], ";", 
      RowBox[{"adrs", "=", 
       RowBox[{"Thread", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"First", ",", "rules"}], "]"}], "\[Rule]", 
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{"Plus", ",", "1", ",", 
             RowBox[{"Map", "[", 
              RowBox[{"Length", ",", "segs"}], "]"}]}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}]}], "]"}]}], ";", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "/.", "\[InvisibleSpace]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"dr", "[", 
              RowBox[{"r_", ",", "n_"}], "]"}], "\[RuleDelayed]", 
             RowBox[{"d", "[", 
              RowBox[{"r", ",", 
               RowBox[{"n", "+", 
                RowBox[{"First", "[", "#2", "]"}]}]}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"dm", "[", 
              RowBox[{"r_", ",", "z_"}], "]"}], "\[RuleDelayed]", 
             RowBox[{"d", "[", 
              RowBox[{"r", ",", 
               RowBox[{"z", "/.", "\[InvisibleSpace]", "adrs"}]}], "]"}]}]}], 
           "}"}]}], "&"}], ",", 
        RowBox[{"Flatten", "[", "segs", "]"}]}], "]"}]}]}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TMCompile", "[", 
    RowBox[{"_", "\[Rule]", 
     RowBox[{"z", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "1"}], "}"}]}]}], "]"}], ":=", 
   RowBox[{"f", "[", 
    RowBox[{"z", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TMCompile", "[", 
    RowBox[{"_", "\[Rule]", 
     RowBox[{"z", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]}], "]"}], ":=", 
   RowBox[{"f", "[", 
    RowBox[{"z", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"s_", ",", "a_", ",", "_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ra_", ",", "rb_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"i", "[", "3", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"ra", ",", 
        RowBox[{"-", "1"}]}], "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"3", ",", "3"}], "]"}], ",", 
      RowBox[{"i", "[", "ra", "]"}], ",", 
      RowBox[{"i", "[", "ra", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", "2"}]}], "]"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"a", "==", "1"}], ",", 
        RowBox[{"i", "[", "ra", "]"}], ",", 
        RowBox[{"{", "}"}]}], "]"}], ",", 
      RowBox[{"i", "[", "3", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"rb", ",", "5"}], "]"}], ",", 
      RowBox[{"i", "[", "rb", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", "1"}]}], "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"rb", ",", "1"}], "]"}], ",", 
      RowBox[{"dm", "[", 
       RowBox[{"rb", ",", 
        RowBox[{"{", 
         RowBox[{"s", ",", "0"}], "}"}]}], "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"rb", ",", 
        RowBox[{"-", "6"}]}], "]"}], ",", 
      RowBox[{"i", "[", "rb", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", "1"}]}], "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"rb", ",", "1"}], "]"}], ",", 
      RowBox[{"dm", "[", 
       RowBox[{"rb", ",", 
        RowBox[{"{", 
         RowBox[{"s", ",", "1"}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"Complement", "[", 
        RowBox[{"#", ",", 
         RowBox[{"#", "-", "1"}]}], "]"}], ",", "1", ",", "2"}], "]"}], "]"}],
     "&"}], ")"}], "[", 
  RowBox[{"Position", "[", 
   RowBox[{"list", ",", 
    RowBox[{"{", 
     RowBox[{"_", ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "0"}], "}"}]}], "}"}]}], "]"}], 
  "]"}]}], "Subsubsection"],

Cell[BoxData[{
 StyleBox[
  RowBox[{
   RowBox[{"TMToRM", "[", "rules_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"segs", ",", "adrs"}], "}"}], ",", 
     RowBox[{
      RowBox[{"segs", "=", 
       RowBox[{"Map", "[", 
        RowBox[{"TMCompile", ",", "rules"}], "]"}]}], ";", 
      RowBox[{"adrs", "=", 
       RowBox[{"Thread", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"First", ",", "rules"}], "]"}], "\[Rule]", 
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{"Plus", ",", "1", ",", 
             RowBox[{"Map", "[", 
              RowBox[{"Length", ",", "segs"}], "]"}]}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}]}], "]"}]}], ";", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "/.", "\[InvisibleSpace]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"dr", "[", 
              RowBox[{"r_", ",", "n_"}], "]"}], "\[RuleDelayed]", 
             RowBox[{"d", "[", 
              RowBox[{"r", ",", 
               RowBox[{"n", "+", 
                RowBox[{"First", "[", "#2", "]"}]}]}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"dm", "[", 
              RowBox[{"r_", ",", "z_"}], "]"}], "\[RuleDelayed]", 
             RowBox[{"d", "[", 
              RowBox[{"r", ",", 
               RowBox[{"z", "/.", "\[InvisibleSpace]", "adrs"}]}], "]"}]}]}], 
           "}"}]}], "&"}], ",", 
        RowBox[{"Flatten", "[", "segs", "]"}]}], "]"}]}]}], "]"}]}],
  LineIndent->0.3], "\n", 
 StyleBox[
  RowBox[{
   RowBox[{"TMCompile", "[", 
    RowBox[{"_", "\[Rule]", 
     RowBox[{"z", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "1"}], "}"}]}]}], "]"}], ":=", 
   RowBox[{"f", "[", 
    RowBox[{"z", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "]"}]}],
  LineIndent->0.3], "\n", 
 StyleBox[
  RowBox[{
   RowBox[{"TMCompile", "[", 
    RowBox[{"_", "\[Rule]", 
     RowBox[{"z", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", 
        RowBox[{"-", "1"}]}], "}"}]}]}], "]"}], ":=", 
   RowBox[{"f", "[", 
    RowBox[{"z", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "]"}]}],
  LineIndent->0.3], "\n", 
 StyleBox[
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"s_", ",", "a_", ",", "_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ra_", ",", "rb_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"i", "[", "3", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"ra", ",", 
        RowBox[{"-", "1"}]}], "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"3", ",", "3"}], "]"}], ",", 
      RowBox[{"i", "[", "ra", "]"}], ",", 
      RowBox[{"i", "[", "ra", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", "2"}]}], "]"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"a", "==", "1"}], ",", 
        RowBox[{"i", "[", "ra", "]"}], ",", 
        RowBox[{"{", "}"}]}], "]"}], ",", 
      RowBox[{"i", "[", "3", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"rb", ",", "5"}], "]"}], ",", 
      RowBox[{"i", "[", "rb", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", "1"}]}], "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"rb", ",", "1"}], "]"}], ",", 
      RowBox[{"dm", "[", 
       RowBox[{"rb", ",", 
        RowBox[{"{", 
         RowBox[{"s", ",", "0"}], "}"}]}], "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"rb", ",", 
        RowBox[{"-", "6"}]}], "]"}], ",", 
      RowBox[{"i", "[", "rb", "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"3", ",", 
        RowBox[{"-", "1"}]}], "]"}], ",", 
      RowBox[{"dr", "[", 
       RowBox[{"rb", ",", "1"}], "]"}], ",", 
      RowBox[{"dm", "[", 
       RowBox[{"rb", ",", 
        RowBox[{"{", 
         RowBox[{"s", ",", "1"}], "}"}]}], "]"}]}], "}"}], "]"}]}],
  LineIndent->0.3], "\n", 
 RowBox[{
  RowBox[{"RMStep", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"{", 
     RowBox[{"n_Integer", ",", "list_List"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", ">", 
     RowBox[{"Length", "[", "prog", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "list"}], "}"}], ",", 
    RowBox[{"RMExecute", "[", 
     RowBox[{
      RowBox[{"prog", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"i", "[", "r_", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"n", "+", "1"}], ",", 
    RowBox[{"MapAt", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "+", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
   "}"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "m_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}], 
     ">", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"MapAt", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "-", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMEvolveList", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"init", ":", 
     RowBox[{"{", 
      RowBox[{"_Integer", ",", "_List"}], "}"}]}], ",", "t_Integer"}], "]"}], 
  ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"RMStep", "[", 
      RowBox[{"prog", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.413735171660013*^9, 3.413735176464686*^9}, {
  3.4323231998441143`*^9, 3.432323203172041*^9}, {3.432325622316104*^9, 
  3.432325638912532*^9}, {3.513089657657565*^9, 3.513089658261579*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TMToRM", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]}], "}"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"i", "[", "3", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "1"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "6"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "4"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"i", "[", "3", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "14"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "10"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "13"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "19"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "8"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "15"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "18"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "1"}], "]"}], ",", 
   RowBox[{"i", "[", "3", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "19"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "24"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "22"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"i", "[", "3", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "32"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "28"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "31"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "55"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "26"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "33"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "36"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "37"}], "]"}], ",", 
   RowBox[{"i", "[", "3", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "37"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "42"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "40"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"i", "[", "3", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "50"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "46"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "49"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "55"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "44"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "51"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "54"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "37"}], "]"}], ",", 
   RowBox[{"i", "[", "3", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "55"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "60"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "58"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"i", "[", "3", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "68"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "64"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "67"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "19"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "62"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "69"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "72"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "1"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.4282547713075743`*^9, 3.42825478017654*^9}, 
   3.432324955767963*^9, 3.432325569585832*^9, {3.4323256312267838`*^9, 
   3.432325643515431*^9}, 3.4323256759612217`*^9, 3.432325788588751*^9, 
   3.432325830634449*^9, 3.4323264591501093`*^9, 3.500211657066351*^9, 
   3.5130896620911303`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RMEvolveList", "[", 
  RowBox[{
   RowBox[{"TMToRM", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], ",", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], ",", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", "60"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"19", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"20", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"21", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"24", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"25", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"26", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"27", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"32", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"33", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"34", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"33", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"34", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"35", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"36", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"37", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"38", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"37", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"38", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"39", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"42", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"40", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"41", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"42", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"43", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"44", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"45", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"46", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"47", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"46", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"47", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"48", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"49", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"55", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"56", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"57", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"60", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"61", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"62", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"63", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"68", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"62", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"63", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"68", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"69", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"70", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"69", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"70", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"69", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "0"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.4137343329815063`*^9, 3.4137344268747807`*^9, 
  3.413735975926162*^9, 3.428254781806697*^9, 3.432324957286049*^9, 
  3.43232557093361*^9, 3.432325685450799*^9, 3.432325789966267*^9, 
  3.432325830714987*^9, 3.432326459207118*^9, 3.500211658500104*^9, 
  3.513089663993187*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"list", "=", "%"}], "}"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Complement", "[", 
          RowBox[{"#", ",", 
           RowBox[{"#", "-", "1"}]}], "]"}], ",", "1", ",", "2"}], "]"}], 
       "]"}], "&"}], ")"}], "[", 
    RowBox[{"Position", "[", 
     RowBox[{"list", ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "0"}], "}"}]}], "}"}]}], "]"}], "]"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "14", ",", "28", ",", "46", ",", "61"}], "}"}]], "Output",
 CellChangeTimes->{3.413734333202173*^9, 3.413734427153624*^9, 
  3.413736003707178*^9, 3.428254783710994*^9, 3.4323249575062037`*^9, 
  3.4323255711549273`*^9, 3.432325790187746*^9, 3.432325830816256*^9, 
  3.4323264592741423`*^9, 3.5002116606686*^9, 3.5130896675108147`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Register machines with many registers", "Subsection"], Cell[
     " (page 1114)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RMEncode", "[", "list_", "]"}], ":=", 
   RowBox[{"Product", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Prime", "[", "j", "]"}], "^", 
      RowBox[{
      "list", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", 
       RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RMToRM2", "[", "prog_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"segs", ",", "adrs"}], "}"}], ",", 
     RowBox[{
      RowBox[{"segs", "=", 
       RowBox[{"MapIndexed", "[", 
        RowBox[{"seg", ",", "prog"}], "]"}]}], ";", 
      RowBox[{"adrs", "=", 
       RowBox[{"FoldList", "[", 
        RowBox[{"Plus", ",", "1", ",", 
         RowBox[{"Map", "[", 
          RowBox[{"Length", ",", "segs"}], "]"}]}], "]"}]}], ";", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "/.", "\[InvisibleSpace]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"ds", "[", 
              RowBox[{"r_", ",", "s_"}], "]"}], "\[RuleDelayed]", 
             RowBox[{"d", "[", 
              RowBox[{"r", ",", 
               RowBox[{
               "adrs", "\[LeftDoubleBracket]", "s", 
                "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"dr", "[", 
              RowBox[{"r_", ",", "j_"}], "]"}], "\[RuleDelayed]", 
             RowBox[{"d", "[", 
              RowBox[{"r", ",", 
               RowBox[{"j", "+", 
                RowBox[{"First", "[", "#2", "]"}]}]}], "]"}]}]}], "}"}]}], 
         "&"}], ",", 
        RowBox[{"Flatten", "[", "segs", "]"}]}], "]"}]}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"seg", "[", 
    RowBox[{
     RowBox[{"i", "[", "r_", "]"}], ",", 
     RowBox[{"{", "a_", "}"}]}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p", "=", 
       RowBox[{"Prime", "[", "r", "]"}]}], "}"}], ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"i", "[", "2", "]"}], ",", 
          RowBox[{"{", "p", "}"}]}], "]"}], ",", 
        RowBox[{"dr", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "p"}]}], "]"}], ",", 
        RowBox[{"i", "[", "1", "]"}], ",", 
        RowBox[{"dr", "[", 
         RowBox[{"2", ",", 
          RowBox[{"-", "1"}]}], "]"}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"dr", "[", 
           RowBox[{"1", ",", "1"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"p", "+", "1"}], "}"}]}], "]"}]}], "}"}], "]"}]}], "]"}]}],
   "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"seg", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "n_"}], "]"}], ",", 
    RowBox[{"{", "a_", "}"}]}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", "=", 
      RowBox[{"Prime", "[", "r", "]"}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "[", "2", "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"1", ",", "5"}], "]"}], ",", 
       RowBox[{"i", "[", "1", "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"2", ",", 
         RowBox[{"-", "1"}]}], "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"1", ",", "1"}], "]"}], ",", 
       RowBox[{"ds", "[", 
        RowBox[{"1", ",", "n"}], "]"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"m", "==", 
              RowBox[{"p", "-", "1"}]}], ",", 
             RowBox[{"ds", "[", 
              RowBox[{"1", ",", "a"}], "]"}], ",", 
             RowBox[{"dr", "[", 
              RowBox[{"1", ",", 
               RowBox[{
                RowBox[{"3", " ", "p"}], "+", "2", "-", "m"}]}], "]"}]}], 
            "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"i", "[", "1", "]"}], ",", 
             RowBox[{"{", "p", "}"}]}], "]"}], ",", 
           RowBox[{"dr", "[", 
            RowBox[{"2", ",", 
             RowBox[{"-", "p"}]}], "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"dr", "[", 
              RowBox[{"1", ",", "1"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"2", " ", "p"}], "-", "m", "-", "1"}], "}"}]}], "]"}], 
           ",", 
           RowBox[{"ds", "[", 
            RowBox[{"1", ",", 
             RowBox[{"a", "+", "1"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", 
           RowBox[{"p", "-", "1"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
   "]"}]}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RMEncode", "[", "list_", "]"}], ":=", 
  RowBox[{"Product", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Prime", "[", "j", "]"}], "^", 
     RowBox[{"list", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]}],
     ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", 
      RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMToRM2", "[", "prog_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"segs", ",", "adrs"}], "}"}], ",", 
    RowBox[{
     RowBox[{"segs", "=", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{"seg", ",", "prog"}], "]"}]}], ";", 
     RowBox[{"adrs", "=", 
      RowBox[{"FoldList", "[", 
       RowBox[{"Plus", ",", "1", ",", 
        RowBox[{"Map", "[", 
         RowBox[{"Length", ",", "segs"}], "]"}]}], "]"}]}], ";", 
     RowBox[{"MapIndexed", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "/.", "\[InvisibleSpace]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"ds", "[", 
             RowBox[{"r_", ",", "s_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{"d", "[", 
             RowBox[{"r", ",", 
              RowBox[{
              "adrs", "\[LeftDoubleBracket]", "s", 
               "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
           RowBox[{
            RowBox[{"dr", "[", 
             RowBox[{"r_", ",", "j_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{"d", "[", 
             RowBox[{"r", ",", 
              RowBox[{"j", "+", 
               RowBox[{"First", "[", "#2", "]"}]}]}], "]"}]}]}], "}"}]}], 
        "&"}], ",", 
       RowBox[{"Flatten", "[", "segs", "]"}]}], "]"}]}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"seg", "[", 
   RowBox[{
    RowBox[{"i", "[", "r_", "]"}], ",", 
    RowBox[{"{", "a_", "}"}]}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", "=", 
      RowBox[{"Prime", "[", "r", "]"}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"i", "[", "2", "]"}], ",", 
         RowBox[{"{", "p", "}"}]}], "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "p"}]}], "]"}], ",", 
       RowBox[{"i", "[", "1", "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"2", ",", 
         RowBox[{"-", "1"}]}], "]"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"dr", "[", 
          RowBox[{"1", ",", "1"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"p", "+", "1"}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"seg", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "n_"}], "]"}], ",", 
    RowBox[{"{", "a_", "}"}]}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", "=", 
      RowBox[{"Prime", "[", "r", "]"}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "[", "2", "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"1", ",", "5"}], "]"}], ",", 
       RowBox[{"i", "[", "1", "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"2", ",", 
         RowBox[{"-", "1"}]}], "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"1", ",", "1"}], "]"}], ",", 
       RowBox[{"ds", "[", 
        RowBox[{"1", ",", "n"}], "]"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"m", "==", 
              RowBox[{"p", "-", "1"}]}], ",", 
             RowBox[{"ds", "[", 
              RowBox[{"1", ",", "a"}], "]"}], ",", 
             RowBox[{"dr", "[", 
              RowBox[{"1", ",", 
               RowBox[{
                RowBox[{"3", " ", "p"}], "+", "2", "-", "m"}]}], "]"}]}], 
            "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"i", "[", "1", "]"}], ",", 
             RowBox[{"{", "p", "}"}]}], "]"}], ",", 
           RowBox[{"dr", "[", 
            RowBox[{"2", ",", 
             RowBox[{"-", "p"}]}], "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"dr", "[", 
              RowBox[{"1", ",", "1"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"2", " ", "p"}], "-", "m", "-", "1"}], "}"}]}], "]"}], 
           ",", 
           RowBox[{"ds", "[", 
            RowBox[{"1", ",", 
             RowBox[{"a", "+", "1"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", 
           RowBox[{"p", "-", "1"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMEvolveList", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"init", ":", 
     RowBox[{"{", 
      RowBox[{"_Integer", ",", "_List"}], "}"}]}], ",", "t_Integer"}], "]"}], 
  ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"RMStep", "[", 
      RowBox[{"prog", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "m_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}], 
     ">", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"MapAt", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "-", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"i", "[", "r_", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"n", "+", "1"}], ",", 
    RowBox[{"MapAt", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "+", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
   "}"}]}], "\n", 
 RowBox[{
  RowBox[{"RMStep", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"{", 
     RowBox[{"n_Integer", ",", "list_List"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", ">", 
     RowBox[{"Length", "[", "prog", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "list"}], "}"}], ",", 
    RowBox[{"RMExecute", "[", 
     RowBox[{
      RowBox[{"prog", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RMEvolveList", "[", 
  RowBox[{
   RowBox[{"RMToRM2", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"1", ",", "4"}], "]"}], ",", 
      RowBox[{"i", "[", "1", "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"1", ",", "15"}], "]"}], ",", 
      RowBox[{"i", "[", "2", "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"1", ",", "6"}], "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"1", ",", "11"}], "]"}], ",", 
      RowBox[{"i", "[", "1", "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"2", ",", "7"}], "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"3", ",", "7"}], "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"1", ",", "15"}], "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"3", ",", "4"}], "]"}], ",", 
      RowBox[{"i", "[", "3", "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"2", ",", "12"}], "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"3", ",", "4"}], "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"RMEncode", "[", 
        RowBox[{"{", 
         RowBox[{"4", ",", "0", ",", "0"}], "}"}], "]"}], ",", "0"}], "}"}]}],
     "}"}], ",", " ", "20"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"16", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"16", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"15", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"14", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"14", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"13", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "7"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413734333727784*^9, 3.413734427245747*^9, 
  3.428254796112935*^9, 3.4323249575780363`*^9, 3.432325571323164*^9, 
  3.432325790348627*^9, 3.432325830943115*^9, 3.432326459366417*^9, 
  3.500211669134676*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Computations with register machines", "Subsection"], Cell[
     " (page 1114)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "4"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "15"}], "]"}], ",", 
   RowBox[{"i", "[", "2", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "6"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "11"}], "]"}], ",", 
   RowBox[{"i", "[", "1", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "7"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "7"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"1", ",", "15"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "4"}], "]"}], ",", 
   RowBox[{"i", "[", "3", "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"2", ",", "12"}], "]"}], ",", 
   RowBox[{"d", "[", 
    RowBox[{"3", ",", "4"}], "]"}]}], "}"}]], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RMEvolveList", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"init", ":", 
     RowBox[{"{", 
      RowBox[{"_Integer", ",", "_List"}], "}"}]}], ",", "t_Integer"}], "]"}], 
  ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"RMStep", "[", 
      RowBox[{"prog", ",", "#"}], "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "m_"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"list", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}], 
     ">", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"MapAt", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "-", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "+", "1"}], ",", "list"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMExecute", "[", 
   RowBox[{
    RowBox[{"i", "[", "r_", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "list_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"n", "+", "1"}], ",", 
    RowBox[{"MapAt", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "+", "1"}], "&"}], ",", "list", ",", "r"}], "]"}]}], 
   "}"}]}], "\n", 
 RowBox[{
  RowBox[{"RMStep", "[", 
   RowBox[{"prog_", ",", 
    RowBox[{"{", 
     RowBox[{"n_Integer", ",", "list_List"}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", ">", 
     RowBox[{"Length", "[", "prog", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "list"}], "}"}], ",", 
    RowBox[{"RMExecute", "[", 
     RowBox[{
      RowBox[{"prog", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "list"}], "}"}]}], "]"}]}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RMEvolveList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"d", "[", 
      RowBox[{"1", ",", "4"}], "]"}], ",", 
     RowBox[{"i", "[", "1", "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"1", ",", "15"}], "]"}], ",", 
     RowBox[{"i", "[", "2", "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"1", ",", "6"}], "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"1", ",", "11"}], "]"}], ",", 
     RowBox[{"i", "[", "1", "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"2", ",", "7"}], "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"3", ",", "7"}], "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"1", ",", "15"}], "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"3", ",", "4"}], "]"}], ",", 
     RowBox[{"i", "[", "3", "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"2", ",", "12"}], "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"3", ",", "4"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", "25"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"15", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "0"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.4137343339240026`*^9, 3.413734427320861*^9, 
  3.4282548017241507`*^9, 3.432324957641039*^9, 3.432325571428409*^9, 
  3.432325790453882*^9, 3.432325831029471*^9, 3.432326459467682*^9, 
  3.50021167647484*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 673 \[CenterDot] Arithmetic systems", "Subsection"], Cell[
     " (page 1114)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RMToAS", "[", 
    RowBox[{"prog_", ",", "nr_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "=", 
        RowBox[{"Length", "[", "prog", "]"}]}], ",", 
       RowBox[{"g", "=", 
        RowBox[{"Product", "[", 
         RowBox[{
          RowBox[{"Prime", "[", "j", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "nr"}], "}"}]}], "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", " ", "g"}], ",", 
       RowBox[{"Sort", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"MapIndexed", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"With", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"n", "=", 
                RowBox[{
                 RowBox[{"First", "[", "#2", "]"}], "-", "1"}]}], "}"}], ",", 
              RowBox[{"#1", "/.", "\[InvisibleSpace]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"i", "[", "r_", "]"}], "\[RuleDelayed]", 
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"n", "+", 
                    RowBox[{"j", " ", "p"}]}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"1", "+", "n", "+", 
                    RowBox[{
                    RowBox[{"Prime", "[", "r", "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "n"}], "+", "#"}], ")"}]}]}], "&"}], ")"}]}],
                     ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "0", ",", 
                    RowBox[{"g", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
                 RowBox[{
                  RowBox[{"d", "[", 
                   RowBox[{"r_", ",", "k_"}], "]"}], "\[RuleDelayed]", 
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"n", "+", 
                    RowBox[{"j", " ", "p"}]}], "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mod", "[", 
                    RowBox[{"j", ",", 
                    RowBox[{"Prime", "[", "r", "]"}]}], "]"}], "==", "0"}], 
                    ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "1"}], "+", "k", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "n"}], "+", "#"}], ")"}], "/", 
                    RowBox[{"Prime", "[", "r", "]"}]}]}], "&"}], ",", 
                    RowBox[{
                    RowBox[{"#", "+", "1"}], "&"}]}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "0", ",", 
                    RowBox[{"g", "-", "1"}]}], "}"}]}], "]"}]}]}], "}"}]}]}], 
             "]"}], "&"}], ",", "prog"}], "]"}], "]"}], "]"}]}], "}"}]}], 
    "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ASEvolveList", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n_", ",", "rules_"}], "}"}], ",", "init_", ",", "t_"}], "]"}], 
   ":=", 
   RowBox[{"NestList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{"#", ",", "n"}], "]"}], "/.", "\[InvisibleSpace]", 
         "rules"}], ")"}], "[", "#", "]"}], "&"}], ",", "init", ",", "t"}], 
    "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Mod", "[", 
     RowBox[{"m", ",", "p"}], "]"}], "+", "1"}], ",", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{"Last", ",", 
      RowBox[{"FactorInteger", "[", 
       RowBox[{
        RowBox[{"Product", "[", 
         RowBox[{
          RowBox[{"Prime", "[", "i", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nr"}], "}"}]}], "]"}], " ", 
        RowBox[{"Quotient", "[", 
         RowBox[{"m", ",", "p"}], "]"}]}], "]"}]}], "]"}], "-", "1"}]}], 
  "}"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RMToAS", "[", 
   RowBox[{"prog_", ",", "nr_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p", "=", 
       RowBox[{"Length", "[", "prog", "]"}]}], ",", 
      RowBox[{"g", "=", 
       RowBox[{"Product", "[", 
        RowBox[{
         RowBox[{"Prime", "[", "j", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "nr"}], "}"}]}], "]"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p", " ", "g"}], ",", 
      RowBox[{"Sort", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{"MapIndexed", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"With", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"n", "=", 
               RowBox[{
                RowBox[{"First", "[", "#2", "]"}], "-", "1"}]}], "}"}], ",", 
             RowBox[{"#1", "/.", "\[InvisibleSpace]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"i", "[", "r_", "]"}], "\[RuleDelayed]", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"n", "+", 
                    RowBox[{"j", " ", "p"}]}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"1", "+", "n", "+", 
                    RowBox[{
                    RowBox[{"Prime", "[", "r", "]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "n"}], "+", "#"}], ")"}]}]}], "&"}], ")"}]}],
                    ",", 
                   RowBox[{"{", 
                    RowBox[{"j", ",", "0", ",", 
                    RowBox[{"g", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"d", "[", 
                  RowBox[{"r_", ",", "k_"}], "]"}], "\[RuleDelayed]", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"n", "+", 
                    RowBox[{"j", " ", "p"}]}], "\[Rule]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mod", "[", 
                    RowBox[{"j", ",", 
                    RowBox[{"Prime", "[", "r", "]"}]}], "]"}], "==", "0"}], 
                    ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "1"}], "+", "k", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "n"}], "+", "#"}], ")"}], "/", 
                    RowBox[{"Prime", "[", "r", "]"}]}]}], "&"}], ",", 
                    RowBox[{
                    RowBox[{"#", "+", "1"}], "&"}]}], "]"}]}], ",", 
                   RowBox[{"{", 
                    RowBox[{"j", ",", "0", ",", 
                    RowBox[{"g", "-", "1"}]}], "}"}]}], "]"}]}]}], "}"}]}]}], 
            "]"}], "&"}], ",", "prog"}], "]"}], "]"}], "]"}]}], "}"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"ASEvolveList", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n_", ",", "rules_"}], "}"}], ",", "init_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"NestList", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Mod", "[", 
         RowBox[{"#", ",", "n"}], "]"}], "/.", "\[InvisibleSpace]", "rules"}],
        ")"}], "[", "#", "]"}], "&"}], ",", "init", ",", "t"}], 
   "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ASEvolveList", "[", 
  RowBox[{
   RowBox[{"RMToAS", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "[", "1", "]"}], ",", " ", 
       RowBox[{"d", "[", 
        RowBox[{"2", ",", "1"}], "]"}], ",", " ", 
       RowBox[{"i", "[", "2", "]"}], ",", " ", 
       RowBox[{"d", "[", 
        RowBox[{"1", ",", "3"}], "]"}], ",", " ", 
       RowBox[{"d", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "}"}], ",", "2"}], "]"}], ",", "5", 
   ",", "5"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"5", ",", "11", ",", "12", ",", "33", ",", "17", ",", "48"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.4137343343144493`*^9, 3.413734427426219*^9, 
  3.428254813321699*^9, 3.432324957685926*^9, 3.432325571541741*^9, 
  3.4323257905639668`*^9, 3.4323258311448603`*^9, 3.4323264596519403`*^9, 
  3.5002116837557487`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"nr", "=", "2"}], ",", 
     RowBox[{"prog", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"i", "[", "1", "]"}], ",", " ", 
        RowBox[{"d", "[", 
         RowBox[{"2", ",", "1"}], "]"}], ",", " ", 
        RowBox[{"i", "[", "2", "]"}], ",", " ", 
        RowBox[{"d", "[", 
         RowBox[{"1", ",", "3"}], "]"}], ",", " ", 
        RowBox[{"d", "[", 
         RowBox[{"2", ",", "1"}], "]"}]}], "}"}]}], ",", "p"}], "}"}], ",", 
   RowBox[{
    RowBox[{"p", "=", 
     RowBox[{"Length", "[", "prog", "]"}]}], ";", 
    RowBox[{
     RowBox[{"Function", "[", 
      RowBox[{"m", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"m", ",", "p"}], "]"}], "+", "1"}], ",", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{"Last", ",", 
            RowBox[{"FactorInteger", "[", 
             RowBox[{
              RowBox[{"Product", "[", 
               RowBox[{
                RowBox[{"Prime", "[", "i", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "nr"}], "}"}]}], "]"}], " ", 
              RowBox[{"Quotient", "[", 
               RowBox[{"m", ",", "p"}], "]"}]}], "]"}]}], "]"}], "-", "1"}]}],
         "}"}]}], "]"}], "/@", 
     RowBox[{"ASEvolveList", "[", 
      RowBox[{
       RowBox[{"RMToAS", "[", 
        RowBox[{"prog", ",", "nr"}], "]"}], ",", "5", ",", "5"}], "]"}]}]}]}],
   "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.413734334911747*^9, 3.413734427458946*^9, 
  3.428254815032789*^9, 3.432324957740653*^9, 3.432325571615079*^9, 
  3.432325790641819*^9, 3.4323258313645353`*^9, 3.4323264597097073`*^9, 
  3.5002116849422827`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["History", "Subsection"], Cell[" (page 1115)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FSEvolveList", "[", 
    RowBox[{"fracs_", ",", "init_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"NestList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"First", "[", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"fracs", " ", "#"}], ",", "IntegerQ", ",", "1"}], "]"}], 
       "]"}], "&"}], ",", "init", ",", "t"}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fracs", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"17", "/", "91"}], ",", 
     RowBox[{"78", "/", "85"}], ",", 
     RowBox[{"19", "/", "51"}], ",", 
     RowBox[{"23", "/", "38"}], ",", 
     RowBox[{"29", "/", "33"}], ",", 
     RowBox[{"77", "/", "29"}], ",", 
     RowBox[{"95", "/", "23"}], ",", 
     RowBox[{"77", "/", "19"}], ",", 
     RowBox[{"1", "/", "17"}], ",", 
     RowBox[{"11", "/", "13"}], ",", 
     RowBox[{"13", "/", "11"}], ",", 
     RowBox[{"15", "/", "14"}], ",", 
     RowBox[{"15", "/", "2"}], ",", 
     RowBox[{"55", "/", "1"}]}], "}"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Rest", "[", 
  RowBox[{"Log", "[", 
   RowBox[{"2", ",", 
    RowBox[{"Select", "[", 
     RowBox[{"list", ",", 
      RowBox[{
       RowBox[{"IntegerQ", "[", 
        RowBox[{"Log", "[", 
         RowBox[{"2", ",", "#"}], "]"}], "]"}], "&"}]}], "]"}]}], "]"}], 
  "]"}]}], "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FSEvolveList", "[", 
    RowBox[{"fracs_", ",", "init_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"NestList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"First", "[", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"fracs", " ", "#"}], ",", "IntegerQ", ",", "1"}], "]"}], 
       "]"}], "&"}], ",", "init", ",", "t"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fracs", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"17", "/", "91"}], ",", 
     RowBox[{"78", "/", "85"}], ",", 
     RowBox[{"19", "/", "51"}], ",", 
     RowBox[{"23", "/", "38"}], ",", 
     RowBox[{"29", "/", "33"}], ",", 
     RowBox[{"77", "/", "29"}], ",", 
     RowBox[{"95", "/", "23"}], ",", 
     RowBox[{"77", "/", "19"}], ",", 
     RowBox[{"1", "/", "17"}], ",", 
     RowBox[{"11", "/", "13"}], ",", 
     RowBox[{"13", "/", "11"}], ",", 
     RowBox[{"15", "/", "14"}], ",", 
     RowBox[{"15", "/", "2"}], ",", 
     RowBox[{"55", "/", "1"}]}], "}"}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FSEvolveList", "[", 
  RowBox[{"fracs", ",", "2", ",", "100"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "15", ",", "825", ",", "725", ",", "1925", ",", "2275", ",", 
   "425", ",", "390", ",", "330", ",", "290", ",", "770", ",", "910", ",", 
   "170", ",", "156", ",", "132", ",", "116", ",", "308", ",", "364", ",", 
   "68", ",", "4", ",", "30", ",", "225", ",", "12375", ",", "10875", ",", 
   "28875", ",", "25375", ",", "67375", ",", "79625", ",", "14875", ",", 
   "13650", ",", "2550", ",", "2340", ",", "1980", ",", "1740", ",", "4620", 
   ",", "4060", ",", "10780", ",", "12740", ",", "2380", ",", "2184", ",", 
   "408", ",", "152", ",", "92", ",", "380", ",", "230", ",", "950", ",", 
   "575", ",", "2375", ",", "9625", ",", "11375", ",", "2125", ",", "1950", 
   ",", "1650", ",", "1450", ",", "3850", ",", "4550", ",", "850", ",", "780",
    ",", "660", ",", "580", ",", "1540", ",", "1820", ",", "340", ",", "312", 
   ",", "264", ",", "232", ",", "616", ",", "728", ",", "136", ",", "8", ",", 
   "60", ",", "450", ",", "3375", ",", "185625", ",", "163125", ",", "433125",
    ",", "380625", ",", "1010625", ",", "888125", ",", "2358125", ",", 
   "2786875", ",", "520625", ",", "477750", ",", "89250", ",", "81900", ",", 
   "15300", ",", "14040", ",", "11880", ",", "10440", ",", "27720", ",", 
   "24360", ",", "64680", ",", "56840", ",", "150920", ",", "178360", ",", 
   "33320", ",", "30576", ",", "5712", ",", "2128", ",", "1288", ",", 
   "5320"}], "}"}]], "Output",
 CellChangeTimes->{3.413734335012061*^9, 3.4137344275073*^9, 
  3.428254825480153*^9, 3.432324957822576*^9, 3.432325571725884*^9, 
  3.4323257907521477`*^9, 3.432325831485507*^9, 3.432326459782151*^9, 
  3.5002116913195257`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Rest", "[", 
  RowBox[{"Log", "[", 
   RowBox[{"2", ",", 
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"FSEvolveList", "[", 
       RowBox[{"fracs", ",", "2", ",", "10000"}], "]"}], ",", 
      RowBox[{
       RowBox[{"IntegerQ", "[", 
        RowBox[{"Log", "[", 
         RowBox[{"2", ",", "#"}], "]"}], "]"}], "&"}]}], "]"}]}], "]"}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "3", ",", "5", ",", "7", ",", "11", ",", "13", ",", "17"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.4137343353322144`*^9, 3.4137344277652683`*^9, 
  3.4282548272535467`*^9, 3.432324958049183*^9, 3.4323255719522038`*^9, 
  3.432325790986444*^9, 3.432325831715221*^9, 3.432326460041106*^9, 
  3.500211693374838*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Rule 110 Cellular Automaton", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 683 \[CenterDot] Initial conditions", "Subsection"], Cell[
     " (page 1116)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CTToR110", "[", 
    RowBox[{
     RowBox[{"rules_", "/;", 
      RowBox[{
       RowBox[{"Select", "[", 
        RowBox[{"rules", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{
             RowBox[{"Length", "[", "#", "]"}], ",", "6"}], "]"}], 
           "\[NotEqual]", "0"}], "&"}]}], "]"}], "==", 
       RowBox[{"{", "}"}]}]}], ",", "init_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g1", ",", "g2", ",", "g3", ",", 
       RowBox[{"nr", "=", "0"}], ",", "x1", ",", "y1", ",", "sp"}], "}"}], 
     ",", 
     RowBox[{
      RowBox[{"g1", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"#", "===", 
                RowBox[{"{", "}"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"{", "2", "}"}], "}"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "3", ",", 
                    RowBox[{"5", "-", 
                    RowBox[{"First", "[", "#", "]"}]}]}], "}"}], "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"4", ",", 
                    RowBox[{"5", "-", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "n", 
                    "\[RightDoubleBracket]"}]}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"n", ",", "2", ",", 
                    RowBox[{"Length", "[", "#", "]"}]}], "}"}]}], "]"}]}], 
                "}"}]}], "]"}], "&"}], ",", "rules"}], "]"}], "/.", 
          "\[InvisibleSpace]", 
          RowBox[{"a_Integer", "\[RuleDelayed]", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"d", "[", 
                 RowBox[{
                  RowBox[{
                  "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
                   ",", 
                  RowBox[{
                  "#", "\[LeftDoubleBracket]", "2", 
                   "\[RightDoubleBracket]"}]}], "]"}], ",", 
                RowBox[{"s", "[", 
                 RowBox[{
                 "#", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
                 "]"}]}], "}"}], "&"}], ",", 
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"c", "[", "a", "]"}], ",", "3"}], "]"}]}], "]"}]}]}], 
         ",", "4"}], "]"}]}], ";", 
      RowBox[{"g2", "=", 
       RowBox[{"g1", "=", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"#1", "===", "#2", "===", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"d", "[", 
                 RowBox[{"22", ",", "11"}], "]"}], ",", "s3"}], "}"}]}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"d", "[", 
                RowBox[{"20", ",", "8"}], "]"}], ",", "s3"}], "}"}], ",", 
             "#1"}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"g1", ",", 
            RowBox[{"RotateRight", "[", 
             RowBox[{"g1", ",", "6"}], "]"}]}], "}"}]}], "]"}]}]}], ";", 
      RowBox[{"While", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"Apply", "[", 
            RowBox[{"Plus", ",", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"#", "\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], "&"}], 
               ",", "g2"}], "]"}]}], "]"}], ",", "30"}], "]"}], "\[NotEqual]",
          "0"}], ",", 
        RowBox[{
         RowBox[{"nr", "++"}], ";", 
         RowBox[{"g2", "=", 
          RowBox[{"Join", "[", 
           RowBox[{"g2", ",", "g1"}], "]"}]}]}]}], "]"}], ";", 
      RowBox[{"y1", "=", 
       RowBox[{
        RowBox[{"g2", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "2"}], "\[RightDoubleBracket]"}], "-", 
        "11"}]}], ";", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"y1", "<", "0"}], ",", 
        RowBox[{"y1", "+=", "30"}]}], "]"}], ";", 
      RowBox[{"Cases", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Last", "[", "g2", "]"}], "\[LeftDoubleBracket]", "2", 
         "\[RightDoubleBracket]"}], ",", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{
           RowBox[{"d", "[", 
            RowBox[{"x_", ",", "y1"}], "]"}], ",", "_", ",", "_", ",", "a_"}],
           "]"}], "\[RuleDelayed]", 
         RowBox[{"(", 
          RowBox[{"x1", "=", 
           RowBox[{"x", "+", 
            RowBox[{"Length", "[", "a", "]"}]}]}], ")"}]}]}], "]"}], ";", 
      RowBox[{"g3", "=", 
       RowBox[{"Fold", "[", 
        RowBox[{"sadd", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"d", "[", 
            RowBox[{"x1", ",", "y1"}], "]"}], ",", 
           RowBox[{"{", "}"}]}], "}"}], ",", "g2"}], "]"}]}], ";", 
      RowBox[{"sp", "=", 
       RowBox[{"Ceiling", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"5", " ", 
           RowBox[{"Length", "[", 
            RowBox[{
            "g3", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
            "]"}]}], "/", 
          RowBox[{"(", 
           RowBox[{"28", " ", "nr"}], ")"}]}], "+", "2"}], "]"}]}], ";", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Fold", "[", 
            RowBox[{"sadd", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"d", "[", 
                RowBox[{"17", ",", "1"}], "]"}], ",", 
               RowBox[{"{", "}"}]}], "}"}], ",", 
             RowBox[{"Flatten", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"d", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"sp", " ", "28"}], "+", "6"}], ",", "1"}], "]"}], 
                    ",", 
                    RowBox[{"s", "[", "5", "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"d", "[", 
                    RowBox[{"398", ",", "1"}], "]"}], ",", 
                    RowBox[{"s", "[", "5", "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"d", "[", 
                    RowBox[{"342", ",", "1"}], "]"}], ",", 
                    RowBox[{"s", "[", "5", "]"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"d", "[", 
                    RowBox[{"370", ",", "1"}], "]"}], ",", 
                    RowBox[{"s", "[", "5", "]"}]}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", "3", "}"}]}], "]"}], ",", "1"}], "]"}]}], "]"}],
            "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
          RowBox[{"bg", "[", 
           RowBox[{"4", ",", "11"}], "]"}]}], "]"}], ",", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{"bgi", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"sp", " ", "2"}], "+", "1", "+", 
               RowBox[{"24", " ", 
                RowBox[{"Length", "[", "init", "]"}]}]}], "}"}]}], "]"}], ",", 
           RowBox[{"init", "/.", "\[InvisibleSpace]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"0", "\[Rule]", "init0"}], ",", 
              RowBox[{"1", "\[Rule]", "init1"}]}], "}"}]}], ",", 
           RowBox[{"bg", "[", 
            RowBox[{"1", ",", "9"}], "]"}], ",", 
           RowBox[{"bg", "[", 
            RowBox[{"6", ",", 
             RowBox[{"60", "-", 
              RowBox[{"g2", "\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
              "+", 
              RowBox[{"g3", "\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"g2", "\[LeftDoubleBracket]", 
                  RowBox[{"1", ",", "1", ",", "2"}], 
                  "\[RightDoubleBracket]"}], "<", 
                 RowBox[{"g3", "\[LeftDoubleBracket]", 
                  RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", 
                "8", ",", "0"}], "]"}]}]}], "]"}]}], "]"}], "]"}], ",", 
        RowBox[{
        "g3", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
       "}"}]}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "1", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "1", ",", "10", ",", "4", ",", "8"}], "}"}],
      ",", "2"}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "2", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "1", ",", "1", ",", "619", ",", "15"}], 
      "}"}], ",", "2"}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "3", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "1", ",", "10", ",", "4956", ",", "18"}], 
      "}"}], ",", "2"}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "4", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "9", ",", "10", ",", "4", ",", "8"}], "}"}], 
    "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "5", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{"{", 
     RowBox[{"5", ",", "0", ",", "9", ",", "14", ",", "1", ",", "1"}], "}"}], 
    "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"c", "[", "1", "]"}], ",", 
     RowBox[{"c", "[", "2", "]"}]}], "}"}], "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"22", ",", "11", ",", "3", ",", "39", ",", "3", ",", "1"}], 
         "}"}], ",", "#"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "63", ",", "12", ",", "2", ",", "48", ",", "5", ",", "4", ",", "29", 
         ",", "26", ",", "4", ",", "43", ",", "26", ",", "4", ",", "23", ",", 
         "3", ",", "4", ",", "47", ",", "4", ",", "4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "87", ",", "6", ",", "2", ",", "32", ",", "2", ",", "4", ",", "13", 
         ",", "23", ",", "4", ",", "27", ",", "16", ",", "4"}], "}"}]}], 
      "}"}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"c", "[", "3", "]"}], ",", 
     RowBox[{"c", "[", "4", "]"}], ",", 
     RowBox[{"c", "[", "5", "]"}]}], "}"}], "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{"#", ",", 
        RowBox[{"{", 
         RowBox[{
         "4", ",", "17", ",", "22", ",", "4", ",", "39", ",", "27", ",", "4", 
          ",", "47", ",", "4", ",", "4"}], "}"}]}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "17", ",", "22", ",", "4", ",", "23", ",", "24", ",", "4", ",", "31", 
         ",", "29"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "17", ",", "22", ",", "4", ",", "47", ",", "18", ",", "4", ",", "15", 
         ",", "19"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "41", ",", "16", ",", "4", ",", "47", ",", "18", ",", "4", ",", "15", 
         ",", "19"}], "}"}]}], "}"}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"init0", ",", "init1"}], "}"}], "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IntegerDigits", "[", 
       RowBox[{
        RowBox[{"216", " ", 
         RowBox[{"(", 
          RowBox[{"#", "+", 
           RowBox[{"432", " ", 
            SuperscriptBox["10", 
             RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "49"}]]}]}], ")"}]}],
         ",", "2"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "246005560154658471735510051750569922628065067661", ",", 
       "1043746165489466852897089830441756550889834709645"}], "}"}]}], 
    "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"bgi", "=", 
   RowBox[{"IntegerDigits", "[", 
    RowBox[{"9976", ",", "2"}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"bg", "[", 
    RowBox[{"s_", ",", "n_"}], "]"}], ":=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"bgi", "\[LeftDoubleBracket]", 
       RowBox[{"1", "+", 
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"#", "-", "1"}], ",", "14"}], "]"}]}], 
       "\[RightDoubleBracket]"}], "&"}], ",", "n", ",", "s"}], "]"}]}], "\n"}]
  , "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ev", "[", 
    RowBox[{"s", "[", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], ",", "pl_", ",", "pr_", ",", "b_"}], 
     "]"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", "pl1", ",", "pr1"}], "}"}], ",", 
     RowBox[{
      RowBox[{"r", "=", 
       RowBox[{"Sign", "[", 
        RowBox[{"BitAnd", "[", 
         RowBox[{
          RowBox[{"2", "^", 
           RowBox[{"ListConvolve", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"bg", "[", 
                RowBox[{
                 RowBox[{"pl", "-", "2"}], ",", "2"}], "]"}], ",", "b", ",", 
               RowBox[{"bg", "[", 
                RowBox[{"pr", ",", "2"}], "]"}]}], "]"}]}], "]"}]}], ",", 
          "110"}], "]"}], "]"}]}], ";", 
      RowBox[{"pl1", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"r", "-", 
             RowBox[{"bg", "[", 
              RowBox[{
               RowBox[{"pl", "+", "3"}], ",", 
               RowBox[{"Length", "[", "r", "]"}]}], "]"}]}], ",", 
            RowBox[{"1", "|", 
             RowBox[{"-", "1"}]}]}], "]"}], "/.", "\[InvisibleSpace]", 
          RowBox[{
           RowBox[{"{", "}"}], "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"Length", "[", "r", "]"}], "}"}], "}"}]}]}], ")"}], 
        "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
      RowBox[{"pr1", "=", 
       RowBox[{"Max", "[", 
        RowBox[{"pl1", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Position", "[", 
             RowBox[{
              RowBox[{"r", "-", 
               RowBox[{"bg", "[", 
                RowBox[{
                 RowBox[{"pr", "+", "5", "-", 
                  RowBox[{"Length", "[", "r", "]"}]}], ",", 
                 RowBox[{"Length", "[", "r", "]"}]}], "]"}]}], ",", 
              RowBox[{"1", "|", 
               RowBox[{"-", "1"}]}]}], "]"}], "/.", "\[InvisibleSpace]", 
            RowBox[{
             RowBox[{"{", "}"}], "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"{", "1", "}"}], "}"}]}]}], ")"}], 
          "\[LeftDoubleBracket]", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "\[RightDoubleBracket]"}]}], 
        "]"}]}], ";", 
      RowBox[{"s", "[", 
       RowBox[{
        RowBox[{"d", "[", 
         RowBox[{
          RowBox[{"x", "+", "pl1", "-", "2"}], ",", 
          RowBox[{"y", "+", "1"}]}], "]"}], ",", 
        RowBox[{"pl1", "+", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"pl", "+", "2"}], ",", "14"}], "]"}]}], ",", 
        RowBox[{"1", "+", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"pr", "+", "4"}], ",", "14"}], "]"}], "+", "pr1", "-", 
         RowBox[{"Length", "[", "r", "]"}]}], ",", 
        RowBox[{"Take", "[", 
         RowBox[{"r", ",", 
          RowBox[{"{", 
           RowBox[{"pl1", ",", "pr1"}], "}"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"struct", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "x_", ",", "y_", ",", "pl_", ",", "pr_", ",", "b_", ",", "bl_"}], "}"}],
      ",", 
     RowBox[{"p_Integer", ":", "1"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"gr", "=", 
        RowBox[{"s", "[", 
         RowBox[{
          RowBox[{"d", "[", 
           RowBox[{"x", ",", "y"}], "]"}], ",", "pl", ",", "pr", ",", 
          RowBox[{"IntegerDigits", "[", 
           RowBox[{"b", ",", "2", ",", "bl"}], "]"}]}], "]"}]}], ",", 
       RowBox[{"p2", "=", 
        RowBox[{"p", "+", "1"}]}]}], "}"}], ",", 
     RowBox[{"Drop", "[", 
      RowBox[{
       RowBox[{"NestWhile", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Append", "[", 
           RowBox[{"#", ",", 
            RowBox[{"ev", "[", 
             RowBox[{"Last", "[", "#", "]"}], "]"}]}], "]"}], "&"}], ",", 
         RowBox[{"{", "gr", "}"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Rest", "[", 
               RowBox[{"Last", "[", "#", "]"}], "]"}], "===", 
              RowBox[{"Rest", "[", "gr", "]"}]}], ",", 
             RowBox[{"p2", "--"}]}], "]"}], ";", 
           RowBox[{"p2", ">", "0"}]}], "&"}]}], "]"}], ",", 
       RowBox[{"-", "1"}]}], "]"}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"sadd", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], ",", "b_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"dx_", ",", "dy_"}], "]"}], ",", "st_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x1", "=", 
       RowBox[{"dx", "-", "x"}]}], ",", 
      RowBox[{"y1", "=", 
       RowBox[{"dy", "-", "y"}]}], ",", "b2", ",", "x2", ",", "y2"}], "}"}], 
    ",", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{"y1", ">", "0"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x1", ",", "y1"}], "}"}], "+=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "st", "]"}], "==", "30"}], ",", 
          RowBox[{"{", 
           RowBox[{"8", ",", 
            RowBox[{"-", "30"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "3"}]}], "}"}]}], "]"}]}]}], "]"}], ";", 
     RowBox[{"b2", "=", 
      RowBox[{"First", "[", 
       RowBox[{"Cases", "[", 
        RowBox[{"st", ",", 
         RowBox[{
          RowBox[{"s", "[", 
           RowBox[{
            RowBox[{"d", "[", 
             RowBox[{"x3_", ",", 
              RowBox[{"-", "y1"}]}], "]"}], ",", "pl_", ",", "_", ",", 
            "sb_"}], "]"}], "\[RuleDelayed]", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"bg", "[", 
             RowBox[{
              RowBox[{"pl", "-", "x1", "-", "x3"}], ",", 
              RowBox[{"x1", "+", "x3"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"x2", "=", 
              RowBox[{"x3", "+", 
               RowBox[{"Length", "[", "sb", "]"}]}]}], ";", 
             RowBox[{"y2", "=", 
              RowBox[{"-", "y1"}]}], ";", "sb"}]}], "]"}]}]}], "]"}], "]"}]}],
      ";", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"d", "[", 
        RowBox[{"x2", ",", "y2"}], "]"}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{"b", ",", "b2"}], "]"}]}], "}"}]}]}], 
   "]"}]}]}], "Subsubsection",
 CellChangeTimes->{{3.513089832293315*^9, 3.513089851000504*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CTToR110", "[", 
   RowBox[{
    RowBox[{"rules_", "/;", 
     RowBox[{
      RowBox[{"Select", "[", 
       RowBox[{"rules", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"Length", "[", "#", "]"}], ",", "6"}], "]"}], 
          "\[NotEqual]", "0"}], "&"}]}], "]"}], "==", 
      RowBox[{"{", "}"}]}]}], ",", "init_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g1", ",", "g2", ",", "g3", ",", 
      RowBox[{"nr", "=", "0"}], ",", "x1", ",", "y1", ",", "sp"}], "}"}], ",", 
    RowBox[{
     RowBox[{"g1", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"#", "===", 
               RowBox[{"{", "}"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"{", "2", "}"}], "}"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "3", ",", 
                   RowBox[{"5", "-", 
                    RowBox[{"First", "[", "#", "]"}]}]}], "}"}], "}"}], ",", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"4", ",", 
                    RowBox[{"5", "-", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "n", 
                    "\[RightDoubleBracket]"}]}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", "2", ",", 
                    RowBox[{"Length", "[", "#", "]"}]}], "}"}]}], "]"}]}], 
               "}"}]}], "]"}], "&"}], ",", "rules"}], "]"}], "/.", 
         "\[InvisibleSpace]", 
         RowBox[{"a_Integer", "\[RuleDelayed]", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"d", "[", 
                RowBox[{
                 RowBox[{
                 "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
                 ",", 
                 RowBox[{
                 "#", "\[LeftDoubleBracket]", "2", 
                  "\[RightDoubleBracket]"}]}], "]"}], ",", 
               RowBox[{"s", "[", 
                RowBox[{
                "#", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
                "]"}]}], "}"}], "&"}], ",", 
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"c", "[", "a", "]"}], ",", "3"}], "]"}]}], "]"}]}]}], 
        ",", "4"}], "]"}]}], ";", 
     RowBox[{"g2", "=", 
      RowBox[{"g1", "=", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"#1", "===", "#2", "===", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"d", "[", 
                RowBox[{"22", ",", "11"}], "]"}], ",", "s3"}], "}"}]}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"d", "[", 
               RowBox[{"20", ",", "8"}], "]"}], ",", "s3"}], "}"}], ",", 
            "#1"}], "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"g1", ",", 
           RowBox[{"RotateRight", "[", 
            RowBox[{"g1", ",", "6"}], "]"}]}], "}"}]}], "]"}]}]}], ";", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"Apply", "[", 
           RowBox[{"Plus", ",", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], "&"}], 
              ",", "g2"}], "]"}]}], "]"}], ",", "30"}], "]"}], "\[NotEqual]", 
        "0"}], ",", 
       RowBox[{
        RowBox[{"nr", "++"}], ";", 
        RowBox[{"g2", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"g2", ",", "g1"}], "]"}]}]}]}], "]"}], ";", 
     RowBox[{"y1", "=", 
      RowBox[{
       RowBox[{"g2", "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1", ",", "2"}], "\[RightDoubleBracket]"}], "-", 
       "11"}]}], ";", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"y1", "<", "0"}], ",", 
       RowBox[{"y1", "+=", "30"}]}], "]"}], ";", 
     RowBox[{"Cases", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Last", "[", "g2", "]"}], "\[LeftDoubleBracket]", "2", 
        "\[RightDoubleBracket]"}], ",", 
       RowBox[{
        RowBox[{"s", "[", 
         RowBox[{
          RowBox[{"d", "[", 
           RowBox[{"x_", ",", "y1"}], "]"}], ",", "_", ",", "_", ",", "a_"}], 
         "]"}], "\[RuleDelayed]", 
        RowBox[{"(", 
         RowBox[{"x1", "=", 
          RowBox[{"x", "+", 
           RowBox[{"Length", "[", "a", "]"}]}]}], ")"}]}]}], "]"}], ";", 
     RowBox[{"g3", "=", 
      RowBox[{"Fold", "[", 
       RowBox[{"sadd", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"d", "[", 
           RowBox[{"x1", ",", "y1"}], "]"}], ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", "g2"}], "]"}]}], ";", 
     RowBox[{"sp", "=", 
      RowBox[{"Ceiling", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"5", " ", 
          RowBox[{"Length", "[", 
           RowBox[{
           "g3", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
           "]"}]}], "/", 
         RowBox[{"(", 
          RowBox[{"28", " ", "nr"}], ")"}]}], "+", "2"}], "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Fold", "[", 
           RowBox[{"sadd", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"d", "[", 
               RowBox[{"17", ",", "1"}], "]"}], ",", 
              RowBox[{"{", "}"}]}], "}"}], ",", 
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"d", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"sp", " ", "28"}], "+", "6"}], ",", "1"}], "]"}], 
                    ",", 
                    RowBox[{"s", "[", "5", "]"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"d", "[", 
                    RowBox[{"398", ",", "1"}], "]"}], ",", 
                    RowBox[{"s", "[", "5", "]"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"d", "[", 
                    RowBox[{"342", ",", "1"}], "]"}], ",", 
                    RowBox[{"s", "[", "5", "]"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"d", "[", 
                    RowBox[{"370", ",", "1"}], "]"}], ",", 
                    RowBox[{"s", "[", "5", "]"}]}], "}"}]}], "}"}], ",", 
                RowBox[{"{", "3", "}"}]}], "]"}], ",", "1"}], "]"}]}], "]"}], 
          "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
         RowBox[{"bg", "[", 
          RowBox[{"4", ",", "11"}], "]"}]}], "]"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"bgi", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"sp", " ", "2"}], "+", "1", "+", 
              RowBox[{"24", " ", 
               RowBox[{"Length", "[", "init", "]"}]}]}], "}"}]}], "]"}], ",", 
          RowBox[{"init", "/.", "\[InvisibleSpace]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0", "\[Rule]", "init0"}], ",", 
             RowBox[{"1", "\[Rule]", "init1"}]}], "}"}]}], ",", 
          RowBox[{"bg", "[", 
           RowBox[{"1", ",", "9"}], "]"}], ",", 
          RowBox[{"bg", "[", 
           RowBox[{"6", ",", 
            RowBox[{"60", "-", 
             RowBox[{"g2", "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
             "+", 
             RowBox[{"g3", "\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"g2", "\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1", ",", "2"}], "\[RightDoubleBracket]"}],
                 "<", 
                RowBox[{"g3", "\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", 
               "8", ",", "0"}], "]"}]}]}], "]"}]}], "]"}], "]"}], ",", 
       RowBox[{"g3", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}],
       "}"}]}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "1", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "1", ",", "10", ",", "4", ",", "8"}], "}"}],
      ",", "2"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "2", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "1", ",", "1", ",", "619", ",", "15"}], 
      "}"}], ",", "2"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "3", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "0", ",", "1", ",", "10", ",", "4956", ",", "18"}], 
      "}"}], ",", "2"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "4", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "9", ",", "10", ",", "4", ",", "8"}], "}"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "[", "5", "]"}], "=", 
   RowBox[{"struct", "[", 
    RowBox[{"{", 
     RowBox[{"5", ",", "0", ",", "9", ",", "14", ",", "1", ",", "1"}], "}"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"c", "[", "1", "]"}], ",", 
     RowBox[{"c", "[", "2", "]"}]}], "}"}], "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"22", ",", "11", ",", "3", ",", "39", ",", "3", ",", "1"}], 
         "}"}], ",", "#"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "63", ",", "12", ",", "2", ",", "48", ",", "5", ",", "4", ",", "29", 
         ",", "26", ",", "4", ",", "43", ",", "26", ",", "4", ",", "23", ",", 
         "3", ",", "4", ",", "47", ",", "4", ",", "4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "87", ",", "6", ",", "2", ",", "32", ",", "2", ",", "4", ",", "13", 
         ",", "23", ",", "4", ",", "27", ",", "16", ",", "4"}], "}"}]}], 
      "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"c", "[", "3", "]"}], ",", 
     RowBox[{"c", "[", "4", "]"}], ",", 
     RowBox[{"c", "[", "5", "]"}]}], "}"}], "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{"#", ",", 
        RowBox[{"{", 
         RowBox[{
         "4", ",", "17", ",", "22", ",", "4", ",", "39", ",", "27", ",", "4", 
          ",", "47", ",", "4", ",", "4"}], "}"}]}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "17", ",", "22", ",", "4", ",", "23", ",", "24", ",", "4", ",", "31", 
         ",", "29"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "17", ",", "22", ",", "4", ",", "47", ",", "18", ",", "4", ",", "15", 
         ",", "19"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "41", ",", "16", ",", "4", ",", "47", ",", "18", ",", "4", ",", "15", 
         ",", "19"}], "}"}]}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"init0", ",", "init1"}], "}"}], "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IntegerDigits", "[", 
       RowBox[{
        RowBox[{"216", " ", 
         RowBox[{"(", 
          RowBox[{"#", "+", 
           RowBox[{"432", " ", 
            SuperscriptBox["10", 
             RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "49"}]]}]}], ")"}]}],
         ",", "2"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "246005560154658471735510051750569922628065067661", ",", 
       "1043746165489466852897089830441756550889834709645"}], "}"}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"bgi", "=", 
   RowBox[{"IntegerDigits", "[", 
    RowBox[{"9976", ",", "2"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"bg", "[", 
   RowBox[{"s_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Array", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"bgi", "\[LeftDoubleBracket]", 
      RowBox[{"1", "+", 
       RowBox[{"Mod", "[", 
        RowBox[{
         RowBox[{"#", "-", "1"}], ",", "14"}], "]"}]}], 
      "\[RightDoubleBracket]"}], "&"}], ",", "n", ",", "s"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"ev", "[", 
   RowBox[{"s", "[", 
    RowBox[{
     RowBox[{"d", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ",", "pl_", ",", "pr_", ",", "b_"}], 
    "]"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"r", ",", "pl1", ",", "pr1"}], "}"}], ",", 
    RowBox[{
     RowBox[{"r", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{"BitAnd", "[", 
        RowBox[{
         RowBox[{"2", "^", 
          RowBox[{"ListConvolve", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"bg", "[", 
               RowBox[{
                RowBox[{"pl", "-", "2"}], ",", "2"}], "]"}], ",", "b", ",", 
              RowBox[{"bg", "[", 
               RowBox[{"pr", ",", "2"}], "]"}]}], "]"}]}], "]"}]}], ",", 
         "110"}], "]"}], "]"}]}], ";", 
     RowBox[{"pl1", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"r", "-", 
            RowBox[{"bg", "[", 
             RowBox[{
              RowBox[{"pl", "+", "3"}], ",", 
              RowBox[{"Length", "[", "r", "]"}]}], "]"}]}], ",", 
           RowBox[{"1", "|", 
            RowBox[{"-", "1"}]}]}], "]"}], "/.", "\[InvisibleSpace]", 
         RowBox[{
          RowBox[{"{", "}"}], "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "r", "]"}], "}"}], "}"}]}]}], ")"}], 
       "\[LeftDoubleBracket]", 
       RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
     RowBox[{"pr1", "=", 
      RowBox[{"Max", "[", 
       RowBox[{"pl1", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{"r", "-", 
              RowBox[{"bg", "[", 
               RowBox[{
                RowBox[{"pr", "+", "5", "-", 
                 RowBox[{"Length", "[", "r", "]"}]}], ",", 
                RowBox[{"Length", "[", "r", "]"}]}], "]"}]}], ",", 
             RowBox[{"1", "|", 
              RowBox[{"-", "1"}]}]}], "]"}], "/.", "\[InvisibleSpace]", 
           RowBox[{
            RowBox[{"{", "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"{", "1", "}"}], "}"}]}]}], ")"}], 
         "\[LeftDoubleBracket]", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "\[RightDoubleBracket]"}]}], 
       "]"}]}], ";", 
     RowBox[{"s", "[", 
      RowBox[{
       RowBox[{"d", "[", 
        RowBox[{
         RowBox[{"x", "+", "pl1", "-", "2"}], ",", 
         RowBox[{"y", "+", "1"}]}], "]"}], ",", 
       RowBox[{"pl1", "+", 
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"pl", "+", "2"}], ",", "14"}], "]"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"pr", "+", "4"}], ",", "14"}], "]"}], "+", "pr1", "-", 
        RowBox[{"Length", "[", "r", "]"}]}], ",", 
       RowBox[{"Take", "[", 
        RowBox[{"r", ",", 
         RowBox[{"{", 
          RowBox[{"pl1", ",", "pr1"}], "}"}]}], "]"}]}], "]"}]}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"struct", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x_", ",", "y_", ",", "pl_", ",", "pr_", ",", "b_", ",", "bl_"}],
      "}"}], ",", 
    RowBox[{"p_Integer", ":", "1"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"gr", "=", 
       RowBox[{"s", "[", 
        RowBox[{
         RowBox[{"d", "[", 
          RowBox[{"x", ",", "y"}], "]"}], ",", "pl", ",", "pr", ",", 
         RowBox[{"IntegerDigits", "[", 
          RowBox[{"b", ",", "2", ",", "bl"}], "]"}]}], "]"}]}], ",", 
      RowBox[{"p2", "=", 
       RowBox[{"p", "+", "1"}]}]}], "}"}], ",", 
    RowBox[{"Drop", "[", 
     RowBox[{
      RowBox[{"NestWhile", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#", ",", 
           RowBox[{"ev", "[", 
            RowBox[{"Last", "[", "#", "]"}], "]"}]}], "]"}], "&"}], ",", 
        RowBox[{"{", "gr", "}"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Rest", "[", 
              RowBox[{"Last", "[", "#", "]"}], "]"}], "===", 
             RowBox[{"Rest", "[", "gr", "]"}]}], ",", 
            RowBox[{"p2", "--"}]}], "]"}], ";", 
          RowBox[{"p2", ">", "0"}]}], "&"}]}], "]"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"sadd", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], ",", "b_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"d", "[", 
       RowBox[{"dx_", ",", "dy_"}], "]"}], ",", "st_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x1", "=", 
       RowBox[{"dx", "-", "x"}]}], ",", 
      RowBox[{"y1", "=", 
       RowBox[{"dy", "-", "y"}]}], ",", "b2", ",", "x2", ",", "y2"}], "}"}], 
    ",", 
    RowBox[{
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{"y1", ">", "0"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x1", ",", "y1"}], "}"}], "+=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "st", "]"}], "==", "30"}], ",", 
          RowBox[{"{", 
           RowBox[{"8", ",", 
            RowBox[{"-", "30"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "2"}], ",", 
            RowBox[{"-", "3"}]}], "}"}]}], "]"}]}]}], "]"}], ";", 
     RowBox[{"b2", "=", 
      RowBox[{"First", "[", 
       RowBox[{"Cases", "[", 
        RowBox[{"st", ",", 
         RowBox[{
          RowBox[{"s", "[", 
           RowBox[{
            RowBox[{"d", "[", 
             RowBox[{"x3_", ",", 
              RowBox[{"-", "y1"}]}], "]"}], ",", "pl_", ",", "_", ",", 
            "sb_"}], "]"}], "\[RuleDelayed]", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"bg", "[", 
             RowBox[{
              RowBox[{"pl", "-", "x1", "-", "x3"}], ",", 
              RowBox[{"x1", "+", "x3"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"x2", "=", 
              RowBox[{"x3", "+", 
               RowBox[{"Length", "[", "sb", "]"}]}]}], ";", 
             RowBox[{"y2", "=", 
              RowBox[{"-", "y1"}]}], ";", "sb"}]}], "]"}]}]}], "]"}], "]"}]}],
      ";", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"d", "[", 
        RowBox[{"x2", ",", "y2"}], "]"}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{"b", ",", "b2"}], "]"}]}], "}"}]}]}], "]"}]}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"Length", ",", 
   RowBox[{"CTToR110", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
        "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"98176", ",", "32713", ",", "88316"}], "}"}]], "Output",
 CellChangeTimes->{{3.413734405371037*^9, 3.4137344305230217`*^9}, 
   3.428254849607415*^9, 3.432324960509763*^9, 3.4323255750765743`*^9, 
   3.432325793810389*^9, 3.4323258350463743`*^9, 3.432326462380929*^9, 
   3.5002117053799543`*^9, 3.5130898797031193`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Class 4 Behavior and Universality", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 693 \[CenterDot] 2D cellular automata\
\>", "Subsection"], Cell[" (page 1117)", "TI"]}
   }], TextForm]], "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "/.", "\[InvisibleSpace]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"0", "\[Rule]", "0"}], ",", 
    RowBox[{"1", "\[Rule]", "2"}], ",", 
    RowBox[{"2", "\[Rule]", "3"}], ",", 
    RowBox[{"3", "\[RuleDelayed]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"0", "<", "u", "<", "3"}], ",", "1", ",", "3"}], "]"}]}]}], 
   "}"}]}]], "Subsubsection"],

Cell["The below shows how WireWorld can replicate a NAND gate.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"WWstep", "[", "list_", "]"}], " ", ":=", " ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Function", "[", 
      RowBox[{"x", ",", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"x", "\[Equal]", "0"}], ",", "0", ",", 
         RowBox[{"x", "\[Equal]", "1"}], ",", "2", ",", 
         RowBox[{"x", "\[Equal]", "2"}], ",", "3", ",", 
         RowBox[{"x", "\[Equal]", " ", "3"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"0", "<", 
            RowBox[{"Count", "[", " ", 
             RowBox[{
              RowBox[{"Extract", "[", 
               RowBox[{"list", ",", "\[IndentingNewLine]", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"i", "-", "a"}], ",", 
                    RowBox[{"j", "-", "b"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"a", ",", 
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"b", ",", 
                    RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], ",", 
                  "1"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", "1"}], 
             "]"}], "<", "3"}], ",", "1", ",", "3"}], "]"}]}], "]"}]}], "]"}],
      "[", 
     RowBox[{"list", "[", 
      RowBox[{"[", 
       RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"Length", "[", "list", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", 
      RowBox[{"Length", "[", 
       RowBox[{"list", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "/@", 
  RowBox[{"NestList", "[", 
   RowBox[{"WWstep", ",", 
    RowBox[{"Transpose", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
         "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "3", ",", "3", ",", 
         "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0", ",", "1", ",", "3", ",", "3", ",", "3", ",", "0", ",", "3", ",", 
         "3", ",", "3", ",", "3", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "3", ",", "3", ",", 
         "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "3", ",", "3", ",", 
         "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "0", ",", 
         "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "0", ",", 
         "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "3", ",", "0", ",", 
         "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
         "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], ",", "5"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5130885357397833`*^9, 3.513088543129209*^9}, {
  3.520262231841394*^9, 3.520262232708172*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "1", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "3", "3", "3", "3", "0", "0", "0", "0"},
      {"0", "3", "0", "3", "3", "3", "3", "3", "0"},
      {"0", "3", "3", "3", "3", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"}
     },
     AutoDelete->False,
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
    "Grid"], ",", 
   TagBox[GridBox[{
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "2", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "1", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "3", "3", "3", "3", "0", "0", "0", "0"},
      {"0", "3", "0", "3", "3", "3", "3", "3", "0"},
      {"0", "3", "3", "3", "3", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"}
     },
     AutoDelete->False,
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
    "Grid"], ",", 
   TagBox[GridBox[{
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "2", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "1", "0", "0", "0", "0", "0", "0"},
      {"0", "3", "3", "3", "3", "0", "0", "0", "0"},
      {"0", "3", "0", "3", "3", "3", "3", "3", "0"},
      {"0", "3", "3", "3", "3", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"}
     },
     AutoDelete->False,
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
    "Grid"], ",", 
   TagBox[GridBox[{
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "2", "0", "0", "0", "0", "0", "0"},
      {"0", "1", "1", "1", "3", "0", "0", "0", "0"},
      {"0", "3", "0", "3", "3", "3", "3", "3", "0"},
      {"0", "3", "3", "3", "3", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"}
     },
     AutoDelete->False,
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
    "Grid"], ",", 
   TagBox[GridBox[{
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "2", "2", "2", "1", "0", "0", "0", "0"},
      {"0", "1", "0", "1", "1", "3", "3", "3", "0"},
      {"0", "3", "3", "3", "3", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"}
     },
     AutoDelete->False,
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
    "Grid"], ",", 
   TagBox[GridBox[{
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "3", "3", "3", "2", "0", "0", "0", "0"},
      {"0", "2", "0", "2", "2", "1", "3", "3", "0"},
      {"0", "1", "1", "1", "1", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "3", "0", "0", "0", "0", "0", "0"},
      {"0", "0", "0", "0", "0", "0", "0", "0", "0"}
     },
     AutoDelete->False,
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
    "Grid"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.413734430701313*^9, 3.428254867369751*^9, 3.432324960659959*^9, 
   3.4323255765088882`*^9, 3.4323257947682323`*^9, 3.4323258354906282`*^9, 
   3.432326462533991*^9, 3.500211717546403*^9, {3.5130885435466337`*^9, 
   3.513088546668519*^9}, 3.520262235307889*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Universality in Turing Machines and Other Systems", "Section",
 CellChangeTimes->{3.513089944712364*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 706 \[CenterDot]  Minsky's Turing machine\
\>", "Subsection"], Cell[" (page 1119)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{3.513089944714966*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TagToMTM", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "rule_"}], "}"}], ",", "init_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"b", "=", 
      RowBox[{"FoldList", "[", 
       RowBox[{"Plus", ",", "1", ",", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"Length", ",", "rule"}], "]"}], "+", "1"}]}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"Drop", "[", 
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Reverse", "[", 
          RowBox[{"Flatten", "[", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Map", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"b", "\[LeftDoubleBracket]", 
                    RowBox[{"#", "+", "1"}], "\[RightDoubleBracket]"}], 
                    "}"}]}], "]"}]}], "}"}], "&"}], ",", "#"}], "]"}], ",", 
                  "1"}], "}"}], "&"}], ",", "rule"}], "]"}], ",", "1"}], 
            "}"}], "]"}], "]"}], ",", "0", ",", "0", ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{"2", ",", 
                RowBox[{"{", 
                 RowBox[{"b", "\[LeftDoubleBracket]", 
                  RowBox[{"#", "+", "1"}], "\[RightDoubleBracket]"}], "}"}]}],
                "]"}], ",", "3"}], "}"}], "&"}], ",", "init"}], "]"}]}], 
        "}"}], "]"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}]}]], "Subsubsection",
 CellChangeTimes->{3.5130899447161903`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TagToMTM", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "rule_"}], "}"}], ",", "init_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"b", "=", 
      RowBox[{"FoldList", "[", 
       RowBox[{"Plus", ",", "1", ",", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"Length", ",", "rule"}], "]"}], "+", "1"}]}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"Drop", "[", 
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Reverse", "[", 
          RowBox[{"Flatten", "[", 
           RowBox[{"{", 
            RowBox[{"1", ",", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Map", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"b", "\[LeftDoubleBracket]", 
                    RowBox[{"#", "+", "1"}], "\[RightDoubleBracket]"}], 
                    "}"}]}], "]"}]}], "}"}], "&"}], ",", "#"}], "]"}], ",", 
                  "1"}], "}"}], "&"}], ",", "rule"}], "]"}], ",", "1"}], 
            "}"}], "]"}], "]"}], ",", "0", ",", "0", ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{"2", ",", 
                RowBox[{"{", 
                 RowBox[{"b", "\[LeftDoubleBracket]", 
                  RowBox[{"#", "+", "1"}], "\[RightDoubleBracket]"}], "}"}]}],
                "]"}], ",", "3"}], "}"}], "&"}], ",", "init"}], "]"}]}], 
        "}"}], "]"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{3.513089944717448*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TagToMTM", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.513089944717888*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
   "2", ",", "3", ",", "2", ",", "3", ",", "2", ",", "2", ",", "2", ",", "2", 
   ",", "3", ",", "2", ",", "2", ",", "2", ",", "2"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.4137344307703533`*^9, 3.42825487717898*^9, 
  3.432324960739191*^9, 3.432325577094722*^9, 3.432325797604663*^9, 
  3.432325835719076*^9, 3.4323264626165943`*^9, 3.500211723286441*^9, 
  3.513089944718315*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 707 \[CenterDot]  Rule 110 Turing machines\
\>", "Subsection"], Cell[" (page 1119)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{3.513089944719309*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"4", ",", "0", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "2", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", "2"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"4", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2", ",", 
      RowBox[{"-", "1"}]}], "}"}]}]}], "}"}]], "Subsubsection",
 CellChangeTimes->{3.513089944720242*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "3", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "2", ",", "1"}], "}"}]}]}], "}"}]], "Subsubsection",
 CellChangeTimes->{3.513089944720882*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Rule 60 Turing machines", "Subsection"], Cell[" (page 1119)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{3.513089944721792*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "2", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1"}], "}"}]}]}], "}"}]], "Subsubsection",
 CellChangeTimes->{3.513089944722506*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1"}], "}"}]}]}], "}"}]], "Subsubsection",
 CellChangeTimes->{3.5130899447230797`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["s=2, k=2 Turing machines", "Subsection"], Cell[
     " (page 1120)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{3.5130899447242117`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "0"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1"}], "}"}]}]}], "}"}]], "Subsubsection",
 CellChangeTimes->{3.513089944724875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 709 \[CenterDot] Machine 596440", "Subsection"], Cell[
     " (page 1120)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{3.513089944725832*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"1", "+", 
         RowBox[{"Rest", "[", 
          RowBox[{"FoldList", "[", 
           RowBox[{"Plus", ",", "0", ",", "#"}], "]"}], "]"}]}], ",", "2"}], 
       "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "0", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
       "\[LeftDoubleBracket]", 
       RowBox[{
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"Apply", "[", 
           RowBox[{"Plus", ",", "#"}], "]"}], ",", "2"}], "]"}], "+", "1"}], 
       "\[RightDoubleBracket]"}]}], "]"}], "&"}], ",", "init", ",", "t"}], 
  "]"}]], "Subsubsection",
 CellChangeTimes->{3.513089944726492*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"t", "=", "3"}], ",", 
     RowBox[{"init", "=", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
        "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
       "}"}]}]}], "}"}], ",", 
   RowBox[{"NestList", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", "0", "}"}], ",", 
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"1", "+", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{"Plus", ",", "0", ",", "#"}], "]"}], "]"}]}], ",", "2"}],
          "]"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
         "\[LeftDoubleBracket]", 
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"Apply", "[", 
             RowBox[{"Plus", ",", "#"}], "]"}], ",", "2"}], "]"}], "+", "1"}],
          "\[RightDoubleBracket]"}]}], "]"}], "&"}], ",", "init", ",", "t"}], 
    "]"}]}], "]"}]], "Input",
 CellChangeTimes->{3.513089944727415*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", 
     ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0",
      ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", 
     ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734430845335*^9, 3.428255013133247*^9, 
  3.4323249607978687`*^9, 3.432325577148994*^9, 3.4323257979452133`*^9, 
  3.4323258358044853`*^9, 3.432326462676414*^9, 3.5002117290801373`*^9, 
  3.5130899447280293`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Encoding sequences by integers", "Subsection"], Cell[
     " (page 1120)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{3.513089944728965*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CRT", "[", 
    RowBox[{"list_", ",", "p_"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"m", "=", 
       RowBox[{"Apply", "[", 
        RowBox[{"Times", ",", "p"}], "]"}]}], "}"}], ",", 
     RowBox[{"Mod", "[", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{"Plus", ",", 
         RowBox[{"MapThread", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"#1", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"m", "/", "#2"}], ")"}], "^", 
              RowBox[{"EulerPhi", "[", "#2", "]"}]}]}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{"list", ",", "p"}], "}"}]}], "]"}]}], "]"}], ",", "m"}], 
      "]"}]}], "]"}]}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LE", "[", "list_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "list", "]"}]}], ",", 
       RowBox[{"i", "=", 
        RowBox[{
         RowBox[{"Max", "[", 
          RowBox[{"MapIndexed", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"#1", "-", "#2"}], "&"}], ",", 
            RowBox[{"PrimePi", "[", "list", "]"}]}], "]"}], "]"}], "+", 
         "1"}]}]}], "}"}], ",", 
     RowBox[{"CRT", "[", 
      RowBox[{
       RowBox[{"PadRight", "[", 
        RowBox[{"list", ",", 
         RowBox[{"n", "+", "i"}]}], "]"}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Prime", "[", 
             RowBox[{"i", "+", "#"}], "]"}], "&"}], ",", "n"}], "]"}], ",", 
         RowBox[{"Array", "[", 
          RowBox[{"Prime", ",", "i"}], "]"}]}], "]"}]}], "]"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Mod", "[", 
  RowBox[{"x", ",", 
   RowBox[{"Prime", "[", 
    RowBox[{"Rest", "[", 
     RowBox[{"NestList", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NestWhile", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "+", "1"}], "&"}], ",", 
          RowBox[{"#", "+", "1"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"x", ",", 
              RowBox[{"Prime", "[", "#", "]"}]}], "]"}], "==", "0"}], "&"}]}],
          "]"}], "&"}], ",", "0", ",", "n"}], "]"}], "]"}], "]"}]}], 
  "]"}]}], "Subsubsection",
 CellChangeTimes->{3.513089944730369*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CRT", "[", 
   RowBox[{"list_", ",", "p_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", "=", 
      RowBox[{"Apply", "[", 
       RowBox[{"Times", ",", "p"}], "]"}]}], "}"}], ",", 
    RowBox[{"Mod", "[", 
     RowBox[{
      RowBox[{"Apply", "[", 
       RowBox[{"Plus", ",", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#1", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"m", "/", "#2"}], ")"}], "^", 
             RowBox[{"EulerPhi", "[", "#2", "]"}]}]}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"list", ",", "p"}], "}"}]}], "]"}]}], "]"}], ",", "m"}], 
     "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"LE", "[", "list_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "list", "]"}]}], ",", 
      RowBox[{"i", "=", 
       RowBox[{
        RowBox[{"Max", "[", 
         RowBox[{"MapIndexed", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"#1", "-", "#2"}], "&"}], ",", 
           RowBox[{"PrimePi", "[", "list", "]"}]}], "]"}], "]"}], "+", 
        "1"}]}]}], "}"}], ",", 
    RowBox[{"CRT", "[", 
     RowBox[{
      RowBox[{"PadRight", "[", 
       RowBox[{"list", ",", 
        RowBox[{"n", "+", "i"}]}], "]"}], ",", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Prime", "[", 
            RowBox[{"i", "+", "#"}], "]"}], "&"}], ",", "n"}], "]"}], ",", 
        RowBox[{"Array", "[", 
         RowBox[{"Prime", ",", "i"}], "]"}]}], "]"}]}], "]"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{3.5130899447317963`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CRT", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "7", ",", "11", ",", "13"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.513089944732181*^9}],

Cell[BoxData["1641"], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734430930644*^9, 3.428255019375844*^9, 
  3.4323249608737507`*^9, 3.43232557732848*^9, 3.432325798026833*^9, 
  3.432325835950275*^9, 3.432326462750146*^9, 3.500211735572239*^9, 
  3.513089944732422*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mod", "[", 
  RowBox[{"1641", ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "7", ",", "11", ",", "13"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.513089944732752*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "3", ",", "2", ",", "3"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.4137344309965773`*^9, 3.428255020841991*^9, 
  3.4323249609301367`*^9, 3.432325577398985*^9, 3.4323257980853767`*^9, 
  3.432325836036427*^9, 3.432326462809717*^9, 3.5002117369072742`*^9, 
  3.513089944733007*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LE", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "3", ",", "2", ",", "3"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.5002117382943563`*^9, 3.500211738901608*^9}, 
   3.513089944733333*^9}],

Cell[BoxData["58"], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.4137344310635767`*^9, 3.428255022335615*^9, 
  3.432324960964246*^9, 3.43232557746647*^9, 3.432325798135866*^9, 
  3.432325836389385*^9, 3.432326462872919*^9, 3.5002117392611933`*^9, 
  3.513089944733569*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"n", "=", "4"}], ",", 
     RowBox[{"x", "=", "58"}]}], "}"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{"x", ",", 
     RowBox[{"Prime", "[", 
      RowBox[{"Rest", "[", 
       RowBox[{"NestList", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"NestWhile", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "+", "1"}], "&"}], ",", 
            RowBox[{"#", "+", "1"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Mod", "[", 
               RowBox[{"x", ",", 
                RowBox[{"Prime", "[", "#", "]"}]}], "]"}], "==", "0"}], 
             "&"}]}], "]"}], "&"}], ",", "0", ",", "n"}], "]"}], "]"}], 
      "]"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{3.513089944734254*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "3", ",", "2", ",", "3"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734431130747*^9, 3.4282550240276937`*^9, 
  3.432324960995454*^9, 3.432325577532569*^9, 3.432325798186067*^9, 
  3.432325837316687*^9, 3.432326462923461*^9, 3.500211740596586*^9, 
  3.5130899447345123`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Register machines", "Subsection"], Cell[" (page 1121)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{{3.513089944735478*^9, 3.513089959239393*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"4", ",", "40"}], "]"}], ",", 
    RowBox[{"i", "[", "5", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"3", ",", "9"}], "]"}], ",", 
    RowBox[{"i", "[", "3", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"7", ",", "4"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"5", ",", "14"}], "]"}], ",", 
    RowBox[{"i", "[", "6", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"3", ",", "3"}], "]"}], ",", 
    RowBox[{"i", "[", "7", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"6", ",", "2"}], "]"}], ",", 
    RowBox[{"i", "[", "6", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"5", ",", "11"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"6", ",", "3"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"4", ",", "35"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"6", ",", "15"}], "]"}], ",", 
    RowBox[{"i", "[", "4", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"8", ",", "16"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"5", ",", "21"}], "]"}], ",", 
    RowBox[{"i", "[", "1", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"3", ",", "1"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"5", ",", "25"}], "]"}], ",", 
    RowBox[{"i", "[", "2", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"3", ",", "1"}], "]"}], ",", 
    RowBox[{"i", "[", "6", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"5", ",", "32"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"1", ",", "28"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"3", ",", "1"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"4", ",", "28"}], "]"}], ",", 
    RowBox[{"i", "[", "4", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"6", ",", "29"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"3", ",", "1"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"5", ",", "24"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"2", ",", "28"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"3", ",", "1"}], "]"}], ",", 
    RowBox[{"i", "[", "8", "]"}], ",", 
    RowBox[{"i", "[", "6", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"5", ",", "36"}], "]"}], ",", 
    RowBox[{"i", "[", "6", "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"3", ",", "3"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"6", ",", "40"}], "]"}], ",", 
    RowBox[{"d", "[", 
     RowBox[{"4", ",", "3"}], "]"}]}], "}"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"R2ToURM", "[", 
   RowBox[{"prog_", ",", "init_"}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{"init", ",", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "prog", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "+", 
         RowBox[{"LE", "[", 
          RowBox[{
           RowBox[{"Reverse", "[", "prog", "]"}], "/.", "\[InvisibleSpace]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"i", "[", "x_", "]"}], "\[Rule]", "x"}], ",", 
             RowBox[{
              RowBox[{"d", "[", 
               RowBox[{"x_", ",", "y_"}], "]"}], "\[Rule]", 
              RowBox[{"4", "+", 
               RowBox[{"2", " ", "n"}], "+", "x", "-", 
               RowBox[{"2", " ", "y"}]}]}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"n", "+", "1"}], ",", "0", ",", "0", ",", "0", ",", "0"}], 
       "}"}]}], "]"}]}], "]"}]}]}], "Subsubsection",
 CellChangeTimes->{3.5130899447375298`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RMEncode", "[", "list_", "]"}], ":=", 
  RowBox[{"Product", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Prime", "[", "j", "]"}], "^", 
     RowBox[{"list", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]}],
     ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", 
      RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"RMToRM2", "[", "prog_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"segs", ",", "adrs"}], "}"}], ",", 
    RowBox[{
     RowBox[{"segs", "=", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{"seg", ",", "prog"}], "]"}]}], ";", 
     RowBox[{"adrs", "=", 
      RowBox[{"FoldList", "[", 
       RowBox[{"Plus", ",", "1", ",", 
        RowBox[{"Map", "[", 
         RowBox[{"Length", ",", "segs"}], "]"}]}], "]"}]}], ";", 
     RowBox[{"MapIndexed", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "/.", "\[InvisibleSpace]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"ds", "[", 
             RowBox[{"r_", ",", "s_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{"d", "[", 
             RowBox[{"r", ",", 
              RowBox[{
              "adrs", "\[LeftDoubleBracket]", "s", 
               "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
           RowBox[{
            RowBox[{"dr", "[", 
             RowBox[{"r_", ",", "j_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{"d", "[", 
             RowBox[{"r", ",", 
              RowBox[{"j", "+", 
               RowBox[{"First", "[", "#2", "]"}]}]}], "]"}]}]}], "}"}]}], 
        "&"}], ",", 
       RowBox[{"Flatten", "[", "segs", "]"}]}], "]"}]}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"seg", "[", 
   RowBox[{
    RowBox[{"i", "[", "r_", "]"}], ",", 
    RowBox[{"{", "a_", "}"}]}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", "=", 
      RowBox[{"Prime", "[", "r", "]"}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"i", "[", "2", "]"}], ",", 
         RowBox[{"{", "p", "}"}]}], "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "p"}]}], "]"}], ",", 
       RowBox[{"i", "[", "1", "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"2", ",", 
         RowBox[{"-", "1"}]}], "]"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"dr", "[", 
          RowBox[{"1", ",", "1"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"p", "+", "1"}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"seg", "[", 
   RowBox[{
    RowBox[{"d", "[", 
     RowBox[{"r_", ",", "n_"}], "]"}], ",", 
    RowBox[{"{", "a_", "}"}]}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", "=", 
      RowBox[{"Prime", "[", "r", "]"}]}], "}"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"i", "[", "2", "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"1", ",", "5"}], "]"}], ",", 
       RowBox[{"i", "[", "1", "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"2", ",", 
         RowBox[{"-", "1"}]}], "]"}], ",", 
       RowBox[{"dr", "[", 
        RowBox[{"1", ",", "1"}], "]"}], ",", 
       RowBox[{"ds", "[", 
        RowBox[{"1", ",", "n"}], "]"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"m", "==", 
              RowBox[{"p", "-", "1"}]}], ",", 
             RowBox[{"ds", "[", 
              RowBox[{"1", ",", "a"}], "]"}], ",", 
             RowBox[{"dr", "[", 
              RowBox[{"1", ",", 
               RowBox[{
                RowBox[{"3", " ", "p"}], "+", "2", "-", "m"}]}], "]"}]}], 
            "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"i", "[", "1", "]"}], ",", 
             RowBox[{"{", "p", "}"}]}], "]"}], ",", 
           RowBox[{"dr", "[", 
            RowBox[{"2", ",", 
             RowBox[{"-", "p"}]}], "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"dr", "[", 
              RowBox[{"1", ",", "1"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"2", " ", "p"}], "-", "m", "-", "1"}], "}"}]}], "]"}], 
           ",", 
           RowBox[{"ds", "[", 
            RowBox[{"1", ",", 
             RowBox[{"a", "+", "1"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", 
           RowBox[{"p", "-", "1"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"CRT", "[", 
   RowBox[{"list_", ",", "p_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", "=", 
      RowBox[{"Apply", "[", 
       RowBox[{"Times", ",", "p"}], "]"}]}], "}"}], ",", 
    RowBox[{"Mod", "[", 
     RowBox[{
      RowBox[{"Apply", "[", 
       RowBox[{"Plus", ",", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#1", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"m", "/", "#2"}], ")"}], "^", 
             RowBox[{"EulerPhi", "[", "#2", "]"}]}]}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"list", ",", "p"}], "}"}]}], "]"}]}], "]"}], ",", "m"}], 
     "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"LE", "[", "list_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "list", "]"}]}], ",", 
      RowBox[{"i", "=", 
       RowBox[{
        RowBox[{"Max", "[", 
         RowBox[{"MapIndexed", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"#1", "-", "#2"}], "&"}], ",", 
           RowBox[{"PrimePi", "[", "list", "]"}]}], "]"}], "]"}], "+", 
        "1"}]}]}], "}"}], ",", 
    RowBox[{"CRT", "[", 
     RowBox[{
      RowBox[{"PadRight", "[", 
       RowBox[{"list", ",", 
        RowBox[{"n", "+", "i"}]}], "]"}], ",", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Prime", "[", 
            RowBox[{"i", "+", "#"}], "]"}], "&"}], ",", "n"}], "]"}], ",", 
        RowBox[{"Array", "[", 
         RowBox[{"Prime", ",", "i"}], "]"}]}], "]"}]}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"R2ToURM", "[", 
   RowBox[{"prog_", ",", "init_"}], "]"}], ":=", 
  RowBox[{"Join", "[", 
   RowBox[{"init", ",", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "prog", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "+", 
         RowBox[{"LE", "[", 
          RowBox[{
           RowBox[{"Reverse", "[", "prog", "]"}], "/.", "\[InvisibleSpace]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"i", "[", "x_", "]"}], "\[Rule]", "x"}], ",", 
             RowBox[{
              RowBox[{"d", "[", 
               RowBox[{"x_", ",", "y_"}], "]"}], "\[Rule]", 
              RowBox[{"4", "+", 
               RowBox[{"2", " ", "n"}], "+", "x", "-", 
               RowBox[{"2", " ", "y"}]}]}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"n", "+", "1"}], ",", "0", ",", "0", ",", "0", ",", "0"}], 
       "}"}]}], "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{3.513089944742455*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"R2ToURM", "[", 
  RowBox[{
   RowBox[{"RMToRM2", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"i", "[", "1", "]"}], ",", 
      RowBox[{"d", "[", 
       RowBox[{"1", ",", "1"}], "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.513089944742939*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1481529032337833153571827451980121559156261", ",", 
   "22", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734431208214*^9, 3.42825503444291*^9, 
  3.432324961075159*^9, 3.432325577624014*^9, 3.432325798279538*^9, 
  3.4323258374143*^9, 3.432326463003581*^9, 3.5002117483120813`*^9, 
  3.5130899447432413`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"R2ToURM", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"i", "[", "1", "]"}], ",", 
     RowBox[{"d", "[", 
      RowBox[{"1", ",", "1"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.5130899447436543`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1471", ",", "3", ",", "0", ",", "0", ",", "0", ",", 
   "0"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734431281274*^9, 3.428255037241465*^9, 
  3.432324961131858*^9, 3.4323255777020206`*^9, 3.432325798337665*^9, 
  3.432325837566596*^9, 3.432326463056929*^9, 3.500211750412408*^9, 
  3.513089944743922*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Recursive functions", "Subsection"], Cell[" (page 1121)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{{3.5130899447449408`*^9, 3.513089964926393*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TSToPR", "[", 
   RowBox[{"{", 
    RowBox[{"n_", ",", "rule_"}], "}"}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Apply", "[", 
      RowBox[{"c", ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"#1", ",", 
          RowBox[{"Array", "[", 
           RowBox[{"p", ",", "#2"}], "]"}], ",", 
          RowBox[{"c", "[", 
           RowBox[{
            RowBox[{"r", "[", 
             RowBox[{"z", ",", 
              RowBox[{"c", "[", 
               RowBox[{
                RowBox[{"r", "[", 
                 RowBox[{
                  RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
                RowBox[{"c", "[", 
                 RowBox[{
                  RowBox[{"r", "[", 
                   RowBox[{"z", ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}], ",", 
                  RowBox[{"c", "[", 
                   RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
                RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"p", "[", "#2", "]"}]}], "]"}]}], "}"}], "]"}]}], "]"}], 
     "&"}], ",", 
    RowBox[{"c", "[", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{
        RowBox[{"r", "[", 
         RowBox[{
          RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
        RowBox[{"p", "[", "1", "]"}], ",", 
        RowBox[{"c", "[", 
         RowBox[{
          RowBox[{"r", "[", 
           RowBox[{
            RowBox[{"p", "[", "1", "]"}], ",", 
            RowBox[{"r", "[", 
             RowBox[{"z", ",", 
              RowBox[{"c", "[", 
               RowBox[{"s", ",", 
                RowBox[{"c", "[", 
                 RowBox[{"s", ",", "s"}], "]"}]}], "]"}]}], "]"}]}], "]"}], 
          ",", 
          RowBox[{"c", "[", 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{
              RowBox[{"r", "[", 
               RowBox[{"z", ",", 
                RowBox[{"c", "[", 
                 RowBox[{
                  RowBox[{"r", "[", 
                   RowBox[{
                    RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
                  RowBox[{"c", "[", 
                   RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"p", "[", "1", "]"}], ",", 
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"p", "[", "2", "]"}], ",", 
                    RowBox[{"p", "[", "3", "]"}]}], "]"}]}], "]"}], ",", 
                  RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}], ",", 
              RowBox[{"p", "[", "1", "]"}], ",", 
              RowBox[{"p", "[", "1", "]"}]}], "]"}], ",", 
            RowBox[{"p", "[", "1", "]"}]}], "]"}], ",", 
          RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
      RowBox[{"p", "[", 
       RowBox[{"n", "+", "1"}], "]"}], ",", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"c", "[", 
          RowBox[{
           RowBox[{"r", "[", 
            RowBox[{"z", ",", 
             RowBox[{"c", "[", 
              RowBox[{
               RowBox[{"r", "[", 
                RowBox[{
                 RowBox[{"p", "[", "1", "]"}], ",", 
                 RowBox[{"p", "[", "4", "]"}]}], "]"}], ",", 
               RowBox[{"p", "[", "2", "]"}], ",", 
               RowBox[{"p", "[", "3", "]"}], ",", 
               RowBox[{"p", "[", "4", "]"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"c", "[", 
            RowBox[{
             RowBox[{"r", "[", 
              RowBox[{"z", ",", 
               RowBox[{"r", "[", 
                RowBox[{
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", "z"}], "]"}], ",", 
                 RowBox[{"c", "[", 
                  RowBox[{
                   RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                   RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
             ",", 
             RowBox[{"p", "[", 
              RowBox[{
               RowBox[{"Length", "[", "#2", "]"}], "+", "1"}], "]"}]}], "]"}],
            ",", 
           RowBox[{
           "#1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
           RowBox[{
           "#1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
          "]"}], "&"}], ",", 
        RowBox[{"Nest", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Nest", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"c", "[", 
                RowBox[{"s", ",", "#"}], "]"}], "&"}], ",", "z", ",", 
              RowBox[{"FromDigits", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Reverse", "[", 
                  RowBox[{
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{"i", ",", "2", ",", "n"}], "]"}], "/.", 
                   "\[InvisibleSpace]", "rule"}], "]"}], "+", "1"}], ",", 
                "3"}], "]"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", 
              RowBox[{
               SuperscriptBox["2", 
                RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]], "-", 
               "1"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"n", "-", "1"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ",", 
    RowBox[{"Range", "[", 
     RowBox[{"n", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}]}]], "Subsubsection",
 CellChangeTimes->{3.51308994474931*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TSToPR", "[", 
   RowBox[{"{", 
    RowBox[{"n_", ",", "rule_"}], "}"}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Apply", "[", 
      RowBox[{"c", ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"#1", ",", 
          RowBox[{"Array", "[", 
           RowBox[{"p", ",", "#2"}], "]"}], ",", 
          RowBox[{"c", "[", 
           RowBox[{
            RowBox[{"r", "[", 
             RowBox[{"z", ",", 
              RowBox[{"c", "[", 
               RowBox[{
                RowBox[{"r", "[", 
                 RowBox[{
                  RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
                RowBox[{"c", "[", 
                 RowBox[{
                  RowBox[{"r", "[", 
                   RowBox[{"z", ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}], ",", 
                  RowBox[{"c", "[", 
                   RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
                RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"p", "[", "#2", "]"}]}], "]"}]}], "}"}], "]"}]}], "]"}], 
     "&"}], ",", 
    RowBox[{"c", "[", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{
        RowBox[{"r", "[", 
         RowBox[{
          RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
        RowBox[{"p", "[", "1", "]"}], ",", 
        RowBox[{"c", "[", 
         RowBox[{
          RowBox[{"r", "[", 
           RowBox[{
            RowBox[{"p", "[", "1", "]"}], ",", 
            RowBox[{"r", "[", 
             RowBox[{"z", ",", 
              RowBox[{"c", "[", 
               RowBox[{"s", ",", 
                RowBox[{"c", "[", 
                 RowBox[{"s", ",", "s"}], "]"}]}], "]"}]}], "]"}]}], "]"}], 
          ",", 
          RowBox[{"c", "[", 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{
              RowBox[{"r", "[", 
               RowBox[{"z", ",", 
                RowBox[{"c", "[", 
                 RowBox[{
                  RowBox[{"r", "[", 
                   RowBox[{
                    RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
                  RowBox[{"c", "[", 
                   RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"p", "[", "1", "]"}], ",", 
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"p", "[", "2", "]"}], ",", 
                    RowBox[{"p", "[", "3", "]"}]}], "]"}]}], "]"}], ",", 
                  RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}], ",", 
              RowBox[{"p", "[", "1", "]"}], ",", 
              RowBox[{"p", "[", "1", "]"}]}], "]"}], ",", 
            RowBox[{"p", "[", "1", "]"}]}], "]"}], ",", 
          RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
      RowBox[{"p", "[", 
       RowBox[{"n", "+", "1"}], "]"}], ",", 
      RowBox[{"MapIndexed", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"c", "[", 
          RowBox[{
           RowBox[{"r", "[", 
            RowBox[{"z", ",", 
             RowBox[{"c", "[", 
              RowBox[{
               RowBox[{"r", "[", 
                RowBox[{
                 RowBox[{"p", "[", "1", "]"}], ",", 
                 RowBox[{"p", "[", "4", "]"}]}], "]"}], ",", 
               RowBox[{"p", "[", "2", "]"}], ",", 
               RowBox[{"p", "[", "3", "]"}], ",", 
               RowBox[{"p", "[", "4", "]"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"c", "[", 
            RowBox[{
             RowBox[{"r", "[", 
              RowBox[{"z", ",", 
               RowBox[{"r", "[", 
                RowBox[{
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", "z"}], "]"}], ",", 
                 RowBox[{"c", "[", 
                  RowBox[{
                   RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                   RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
             ",", 
             RowBox[{"p", "[", 
              RowBox[{
               RowBox[{"Length", "[", "#2", "]"}], "+", "1"}], "]"}]}], "]"}],
            ",", 
           RowBox[{
           "#1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
           RowBox[{
           "#1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
          "]"}], "&"}], ",", 
        RowBox[{"Nest", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{"#", ",", "2"}], "]"}], "&"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Nest", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"c", "[", 
                RowBox[{"s", ",", "#"}], "]"}], "&"}], ",", "z", ",", 
              RowBox[{"FromDigits", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Reverse", "[", 
                  RowBox[{
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{"i", ",", "2", ",", "n"}], "]"}], "/.", 
                   "\[InvisibleSpace]", "rule"}], "]"}], "+", "1"}], ",", 
                "3"}], "]"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", 
              RowBox[{
               SuperscriptBox["2", 
                RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "n"}]], "-", 
               "1"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"n", "-", "1"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], ",", 
    RowBox[{"Range", "[", 
     RowBox[{"n", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{3.513089944758609*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TSToPR", "[", 
  RowBox[{"{", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"{", "0", "}"}], "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"{", "1", "}"}], "\[Rule]", 
       RowBox[{"{", "0", "}"}]}]}], "}"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{3.513089944759322*^9}],

Cell[BoxData[
 RowBox[{"c", "[", 
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{
         RowBox[{"r", "[", 
          RowBox[{
           RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
         RowBox[{"p", "[", "1", "]"}], ",", 
         RowBox[{"c", "[", 
          RowBox[{
           RowBox[{"r", "[", 
            RowBox[{
             RowBox[{"p", "[", "1", "]"}], ",", 
             RowBox[{"r", "[", 
              RowBox[{"z", ",", 
               RowBox[{"c", "[", 
                RowBox[{"s", ",", 
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", "s"}], "]"}]}], "]"}]}], "]"}]}], "]"}], 
           ",", 
           RowBox[{"c", "[", 
            RowBox[{
             RowBox[{"c", "[", 
              RowBox[{
               RowBox[{"r", "[", 
                RowBox[{"z", ",", 
                 RowBox[{"c", "[", 
                  RowBox[{
                   RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
                   RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"p", "[", "1", "]"}], ",", 
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{"z", ",", 
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"p", "[", "2", "]"}], ",", 
                    RowBox[{"p", "[", "3", "]"}]}], "]"}]}], "]"}], ",", 
                   RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}], ",", 
               RowBox[{"p", "[", "1", "]"}], ",", 
               RowBox[{"p", "[", "1", "]"}]}], "]"}], ",", 
             RowBox[{"p", "[", "1", "]"}]}], "]"}], ",", 
           RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"p", "[", "3", "]"}], ",", 
       RowBox[{"c", "[", 
        RowBox[{
         RowBox[{"r", "[", 
          RowBox[{"z", ",", 
           RowBox[{"c", "[", 
            RowBox[{
             RowBox[{"r", "[", 
              RowBox[{
               RowBox[{"p", "[", "1", "]"}], ",", 
               RowBox[{"p", "[", "4", "]"}]}], "]"}], ",", 
             RowBox[{"p", "[", "2", "]"}], ",", 
             RowBox[{"p", "[", "3", "]"}], ",", 
             RowBox[{"p", "[", "4", "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"c", "[", 
          RowBox[{
           RowBox[{"r", "[", 
            RowBox[{"z", ",", 
             RowBox[{"r", "[", 
              RowBox[{
               RowBox[{"c", "[", 
                RowBox[{"s", ",", "z"}], "]"}], ",", 
               RowBox[{"c", "[", 
                RowBox[{
                 RowBox[{"r", "[", 
                  RowBox[{
                   RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                  "]"}], ",", 
                 RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"p", "[", "1", "]"}]}], "]"}], ",", 
         RowBox[{"c", "[", 
          RowBox[{
           RowBox[{"r", "[", 
            RowBox[{"z", ",", 
             RowBox[{"c", "[", 
              RowBox[{
               RowBox[{"r", "[", 
                RowBox[{
                 RowBox[{"p", "[", "1", "]"}], ",", 
                 RowBox[{"p", "[", "4", "]"}]}], "]"}], ",", 
               RowBox[{"p", "[", "2", "]"}], ",", 
               RowBox[{"p", "[", "3", "]"}], ",", 
               RowBox[{"p", "[", "4", "]"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"c", "[", 
            RowBox[{
             RowBox[{"r", "[", 
              RowBox[{"z", ",", 
               RowBox[{"r", "[", 
                RowBox[{
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", "z"}], "]"}], ",", 
                 RowBox[{"c", "[", 
                  RowBox[{
                   RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                   RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
             ",", 
             RowBox[{"p", "[", "2", "]"}]}], "]"}], ",", 
           RowBox[{"c", "[", 
            RowBox[{"s", ",", 
             RowBox[{"c", "[", 
              RowBox[{"s", ",", 
               RowBox[{"c", "[", 
                RowBox[{"s", ",", 
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", "z"}], "]"}]}], "]"}]}], "]"}]}], "]"}], 
           ",", 
           RowBox[{"c", "[", 
            RowBox[{"s", ",", 
             RowBox[{"c", "[", 
              RowBox[{"s", ",", 
               RowBox[{"c", "[", 
                RowBox[{"s", ",", 
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", 
                   RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}]}], "]"}]}], 
                  "]"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"c", "[", 
          RowBox[{
           RowBox[{"r", "[", 
            RowBox[{"z", ",", 
             RowBox[{"c", "[", 
              RowBox[{
               RowBox[{"r", "[", 
                RowBox[{
                 RowBox[{"p", "[", "1", "]"}], ",", 
                 RowBox[{"p", "[", "4", "]"}]}], "]"}], ",", 
               RowBox[{"p", "[", "2", "]"}], ",", 
               RowBox[{"p", "[", "3", "]"}], ",", 
               RowBox[{"p", "[", "4", "]"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"c", "[", 
            RowBox[{
             RowBox[{"r", "[", 
              RowBox[{"z", ",", 
               RowBox[{"r", "[", 
                RowBox[{
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", "z"}], "]"}], ",", 
                 RowBox[{"c", "[", 
                  RowBox[{
                   RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                   RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
             ",", 
             RowBox[{"p", "[", "2", "]"}]}], "]"}], ",", 
           RowBox[{"c", "[", 
            RowBox[{"s", ",", 
             RowBox[{"c", "[", 
              RowBox[{"s", ",", 
               RowBox[{"c", "[", 
                RowBox[{"s", ",", 
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", 
                   RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}]}], "]"}]}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"c", "[", 
            RowBox[{"s", ",", 
             RowBox[{"c", "[", 
              RowBox[{"s", ",", 
               RowBox[{"c", "[", 
                RowBox[{"s", ",", 
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", 
                   RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}]}], "]"}]}], 
                    "]"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}]}], 
        "]"}]}], "]"}], ",", 
     RowBox[{"p", "[", "1", "]"}], ",", 
     RowBox[{"p", "[", "2", "]"}], ",", 
     RowBox[{"c", "[", 
      RowBox[{
       RowBox[{"r", "[", 
        RowBox[{"z", ",", 
         RowBox[{"c", "[", 
          RowBox[{
           RowBox[{"r", "[", 
            RowBox[{
             RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
           RowBox[{"c", "[", 
            RowBox[{
             RowBox[{"r", "[", 
              RowBox[{"z", ",", 
               RowBox[{"p", "[", "2", "]"}]}], "]"}], ",", 
             RowBox[{"c", "[", 
              RowBox[{
               RowBox[{"r", "[", 
                RowBox[{"z", ",", 
                 RowBox[{"r", "[", 
                  RowBox[{
                   RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}], ",", 
                   RowBox[{"c", "[", 
                    RowBox[{
                    RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                    RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
               ",", 
               RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
           RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
   RowBox[{"p", "[", "1", "]"}], ",", 
   RowBox[{"c", "[", 
    RowBox[{
     RowBox[{"r", "[", 
      RowBox[{"z", ",", 
       RowBox[{"c", "[", 
        RowBox[{
         RowBox[{"r", "[", 
          RowBox[{
           RowBox[{"p", "[", "1", "]"}], ",", "s"}], "]"}], ",", 
         RowBox[{"c", "[", 
          RowBox[{
           RowBox[{"r", "[", 
            RowBox[{"z", ",", 
             RowBox[{"p", "[", "2", "]"}]}], "]"}], ",", 
           RowBox[{"c", "[", 
            RowBox[{
             RowBox[{"r", "[", 
              RowBox[{"z", ",", 
               RowBox[{"r", "[", 
                RowBox[{
                 RowBox[{"c", "[", 
                  RowBox[{"s", ",", "z"}], "]"}], ",", 
                 RowBox[{"c", "[", 
                  RowBox[{
                   RowBox[{"r", "[", 
                    RowBox[{
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"s", ",", "z"}], "]"}]}], "]"}], ",", "z"}], 
                    "]"}], ",", 
                   RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}]}], "]"}], 
             ",", 
             RowBox[{"p", "[", "2", "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"p", "[", "1", "]"}]}], "]"}]}], "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734431365746*^9, 3.428255048148979*^9, 
  3.432324961240286*^9, 3.432325577797329*^9, 3.432325798504486*^9, 
  3.432325837655818*^9, 3.432326463144389*^9, 3.500211758985774*^9, 
  3.5130899447624474`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "^", 
   RowBox[{"FromDigits", "[", 
    RowBox[{"Reverse", "[", 
     RowBox[{"Take", "[", 
      RowBox[{"list", ",", 
       RowBox[{"n", "-", "1"}]}], "]"}], "]"}], "]"}]}], " ", 
  RowBox[{"3", "^", 
   RowBox[{"FromDigits", "[", 
    RowBox[{"Take", "[", 
     RowBox[{"list", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"n", "+", "1"}], ",", 
        RowBox[{"-", "1"}]}], "}"}]}], "]"}], "]"}]}], " ", 
  RowBox[{"5", "^", 
   RowBox[{"list", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}]}], 
  " ", 
  SuperscriptBox["7", 
   RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "s"}]]}]], "Subsubsection",
 CellChangeTimes->{3.513089944763092*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"s", "=", "2"}], ",", 
     RowBox[{"list", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"n", "=", "3"}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"2", "^", 
     RowBox[{"FromDigits", "[", 
      RowBox[{"Reverse", "[", 
       RowBox[{"Take", "[", 
        RowBox[{"list", ",", 
         RowBox[{"n", "-", "1"}]}], "]"}], "]"}], "]"}]}], " ", 
    RowBox[{"3", "^", 
     RowBox[{"FromDigits", "[", 
      RowBox[{"Take", "[", 
       RowBox[{"list", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"n", "+", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}], "]"}]}], " ", 
    RowBox[{"5", "^", 
     RowBox[{"list", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}]}],
     " ", 
    SuperscriptBox["7", 
     RowBox[{"\[VeryThinSpace]\[VeryThinSpace]", "s"}]]}]}], "]"}]], "Input",
 CellChangeTimes->{3.513089944764392*^9}],

Cell[BoxData["245"], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.41373443143239*^9, 3.428255060582074*^9, 
  3.4323249612827*^9, 3.432325577852467*^9, 3.432325798572974*^9, 
  3.432325837703867*^9, 3.432326463195559*^9, 3.500211766055385*^9, 
  3.51308994476464*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Page 711 \[CenterDot] Combinators", "Subsection"], Cell[
     " (page 1121)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{
  3.5130899447656727`*^9, {3.513089986629208*^9, 3.513089986749414*^9}}],

Cell[BoxData[
 RowBox[{"crules", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptS]", "[", "x_", "]"}], "[", "y_", "]"}], "[", "z_", 
      "]"}], "\[Rule]", 
     RowBox[{
      RowBox[{"x", "[", "z", "]"}], "[", 
      RowBox[{"y", "[", "z", "]"}], "]"}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"\[ScriptK]", "[", "x_", "]"}], "[", "y_", "]"}], "\[Rule]", 
     "x"}]}], "}"}]}]], "Subsubsection",
 CellChangeTimes->{3.5130899447662697`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"id", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
    "]"}]}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ToC", "[", 
    RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
   RowBox[{"Fold", "[", 
    RowBox[{"rm", ",", "expr", ",", 
     RowBox[{"Reverse", "[", "vars", "]"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"rm", "[", 
    RowBox[{"v_", ",", "v_"}], "]"}], "=", "id"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{
      RowBox[{"f_", "[", "v_", "]"}], ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"f", ",", "v"}], "]"}]}], "=", "f"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{"h_", ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"h", ",", "v"}], "]"}]}], "=", 
   RowBox[{"\[ScriptK]", "[", "h", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"rm", "[", 
   RowBox[{
    RowBox[{"f_", "[", "g_", "]"}], ",", "v_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{"rm", "[", 
     RowBox[{"f", ",", "v"}], "]"}], "]"}], "[", 
   RowBox[{"rm", "[", 
    RowBox[{"g", ",", "v"}], "]"}], "]"}]}]}], "Subsubsection",
 CellChangeTimes->{3.5130899447672358`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"id", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ToC", "[", 
   RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{"rm", ",", "expr", ",", 
    RowBox[{"Reverse", "[", "vars", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"rm", "[", 
    RowBox[{"v_", ",", "v_"}], "]"}], "=", "id"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{
      RowBox[{"f_", "[", "v_", "]"}], ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"f", ",", "v"}], "]"}]}], "=", "f"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{"h_", ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"h", ",", "v"}], "]"}]}], "=", 
   RowBox[{"\[ScriptK]", "[", "h", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rm", "[", 
   RowBox[{
    RowBox[{"f_", "[", "g_", "]"}], ",", "v_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{"rm", "[", 
     RowBox[{"f", ",", "v"}], "]"}], "]"}], "[", 
   RowBox[{"rm", "[", 
    RowBox[{"g", ",", "v"}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{3.513089944768404*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToC", "[", 
  RowBox[{
   RowBox[{"x", "[", 
    RowBox[{
     RowBox[{"y", "[", "x", "]"}], "[", "z", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.5130899447688627`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptS]", "[", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
      "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{"\[ScriptK]", "[", 
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{
       RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
       "]"}], "]"}], "]"}], "]"}], "[", "\[ScriptK]", "]"}], "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.4137344314913483`*^9, 3.428255069854856*^9, 
  3.432324961359028*^9, 3.432325577943678*^9, 3.4323257986859903`*^9, 
  3.432325837800617*^9, 3.43232646331319*^9, 3.5002117747014236`*^9, 
  3.5130899447692623`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"zero", "=", 
   RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"inc", "=", 
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
     "\[ScriptK]", "]"}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"plus", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", 
       RowBox[{"\[ScriptS]", "[", 
        RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "]"}], "]"}], 
     "[", 
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}]}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"times", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", "\[ScriptK]",
     "]"}]}], "\n"}], "\n", 
 RowBox[{"power", "=", 
  RowBox[{
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{"\[ScriptK]", "[", 
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{
       RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
       "]"}], "]"}], "]"}], "]"}], "[", "\[ScriptK]", 
   "]"}]}]}], "Subsubsection",
 CellChangeTimes->{3.513089944770165*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"crules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptS]", "[", "x_", "]"}], "[", "y_", "]"}], "[", "z_", 
       "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"x", "[", "z", "]"}], "[", 
       RowBox[{"y", "[", "z", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptK]", "[", "x_", "]"}], "[", "y_", "]"}], "\[Rule]", 
      "x"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"zero", "=", 
   RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"inc", "=", 
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
     "\[ScriptK]", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"plus", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", 
       RowBox[{"\[ScriptS]", "[", 
        RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "]"}], "]"}], 
     "[", 
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"times", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", "\[ScriptK]",
     "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"power", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{"\[ScriptK]", "[", 
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
        "]"}], "]"}], "]"}], "]"}], "[", "\[ScriptK]", "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{3.513089944771594*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Nest", "[", 
  RowBox[{"inc", ",", "zero", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{3.5130899447719097`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptS]", "[", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", "\[ScriptK]",
     "]"}], "]"}], "[", 
  RowBox[{
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
     "\[ScriptK]", "]"}], "]"}], "[", 
   RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734431625724*^9, 3.428255079209546*^9, 
  3.4323249614312057`*^9, 3.432325578028737*^9, 3.4323257987651777`*^9, 
  3.432325837900517*^9, 3.43232646340519*^9, 3.500211781246262*^9, 
  3.5130899447722607`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Nest", "[", 
     RowBox[{"inc", ",", "zero", ",", "3"}], "]"}], "[", "a", "]"}], "[", "b",
    "]"}], "//.", "crules"}]], "Input",
 CellChangeTimes->{3.513089944772683*^9}],

Cell[BoxData[
 RowBox[{"a", "[", 
  RowBox[{"a", "[", 
   RowBox[{"a", "[", "b", "]"}], "]"}], "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734431701339*^9, 3.428255081021851*^9, 
  3.432324961484223*^9, 3.432325578086754*^9, 3.432325798841545*^9, 
  3.432325837959985*^9, 3.432326463551119*^9, 3.500211784202675*^9, 
  3.513089944772951*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"times", "[", 
      RowBox[{"Nest", "[", 
       RowBox[{"inc", ",", "zero", ",", "3"}], "]"}], "]"}], "[", 
     RowBox[{"Nest", "[", 
      RowBox[{"inc", ",", "zero", ",", "2"}], "]"}], "]"}], "[", "a", "]"}], 
   "[", "b", "]"}], "//.", "crules"}]], "Input",
 CellChangeTimes->{3.5130899447734423`*^9}],

Cell[BoxData[
 RowBox[{"a", "[", 
  RowBox[{"a", "[", 
   RowBox[{"a", "[", 
    RowBox[{"a", "[", 
     RowBox[{"a", "[", 
      RowBox[{"a", "[", "b", "]"}], "]"}], "]"}], "]"}], "]"}], 
  "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734431767919*^9, 3.4282550825309553`*^9, 
  3.432324961518338*^9, 3.432325578154695*^9, 3.432325798890596*^9, 
  3.432325838007724*^9, 3.432326463594249*^9, 3.500211786069127*^9, 
  3.513089944773736*^9}]
}, Open  ]]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptS]", "[", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
          "]"}], "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", 
             RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
            "\[ScriptK]", "]"}], "]"}], "[", 
          RowBox[{
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
           "]"}], "]"}], "]"}], "]"}], "]"}], "[", 
      RowBox[{"\[ScriptK]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
          "\[ScriptK]", "]"}], "]"}], "[", 
        RowBox[{
         RowBox[{"\[ScriptS]", "[", 
          RowBox[{
           RowBox[{"\[ScriptS]", "[", 
            RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
           "\[ScriptK]", "]"}], "]"}], "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
          "]"}], "]"}], "]"}], "]"}], "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{
       RowBox[{"\[ScriptS]", "[", 
        RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
          RowBox[{
           RowBox[{"\[ScriptS]", "[", 
            RowBox[{"\[ScriptK]", "[", 
             RowBox[{"\[ScriptS]", "[", 
              RowBox[{
               RowBox[{"\[ScriptS]", "[", 
                RowBox[{
                 RowBox[{"\[ScriptS]", "[", 
                  RowBox[{
                   RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], 
                    "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "[", 
                   RowBox[{"\[ScriptK]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], 
                    "[", "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "]"}], "[", 
                 RowBox[{"\[ScriptK]", "[", 
                  RowBox[{
                   RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], 
                    "[", "\[ScriptK]", "]"}], "]"}], "[", 
                   RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], 
                    "[", "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "]"}], "]"}], 
               "[", 
               RowBox[{"\[ScriptK]", "[", 
                RowBox[{
                 RowBox[{"\[ScriptS]", "[", 
                  RowBox[{
                   RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], 
                    "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", 
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", 
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], 
                    "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "]"}], "]"}], "]"}], "]"}], "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "]"}], "]"}], "]"}], "]"}], "[", 
                   RowBox[{"\[ScriptK]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "]"}], "]"}], "]"}], "[", 
                 RowBox[{"\[ScriptK]", "[", 
                  RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                 "]"}], "]"}], "]"}], "]"}], "]"}], "]"}], "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", 
             RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "[", 
            RowBox[{
             RowBox[{"\[ScriptS]", "[", 
              RowBox[{
               RowBox[{"\[ScriptS]", "[", 
                RowBox[{
                 RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                 "\[ScriptK]", "]"}], "]"}], "[", 
               RowBox[{"\[ScriptK]", "[", 
                RowBox[{
                 RowBox[{"\[ScriptS]", "[", 
                  RowBox[{
                   RowBox[{"\[ScriptS]", "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], 
                   "[", "\[ScriptK]", "]"}], "]"}], "[", 
                 RowBox[{
                  RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                  "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "]"}], "[", 
             RowBox[{"\[ScriptK]", "[", 
              RowBox[{
               RowBox[{"\[ScriptS]", "[", 
                RowBox[{
                 RowBox[{"\[ScriptS]", "[", 
                  RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
                 "\[ScriptK]", "]"}], "]"}], "[", 
               RowBox[{
                RowBox[{"\[ScriptS]", "[", 
                 RowBox[{
                  RowBox[{"\[ScriptS]", "[", 
                   RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[",
                   "\[ScriptK]", "]"}], "]"}], "[", 
                RowBox[{
                 RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                 "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "]"}], "]"}], 
           "]"}], "]"}], "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "[", 
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", 
             RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
            "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "]"}], "]"}], "]"}], 
     "[", 
     RowBox[{"\[ScriptK]", "[", 
      RowBox[{
       RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
       "]"}], "]"}], "]"}], "]"}], "]"}], "[", 
  RowBox[{"\[ScriptK]", "[", 
   RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
  "]"}]], "Subsubsection",
 CellChangeTimes->{3.5130899447777357`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 712 \[CenterDot] Combinator properties\
\>", "Subsection"], Cell[" (page 1122)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{3.51308994477894*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"h", "[", "2", "]"}], "=", 
    RowBox[{
     RowBox[{"h", "[", "3", "]"}], "=", "12"}]}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"h", "[", "t_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{"t", ",", "4"}], "]"}], "==", "2"}], ",", "2", ",", "1"}], 
     "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"h", "[", 
       RowBox[{
        RowBox[{"Ceiling", "[", 
         RowBox[{"t", "/", "2"}], "]"}], "-", "1"}], "]"}], "+", "t"}], 
     ")"}]}], "+", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "5", ",", 
      RowBox[{"-", "7"}], ",", 
      RowBox[{"-", "1"}]}], "}"}], "\[LeftDoubleBracket]", 
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{"t", ",", "4"}], "]"}], "+", "1"}], 
    "\[RightDoubleBracket]"}]}]}]}], "Subsubsection",
 CellChangeTimes->{3.5130899447797422`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"h", "[", "2", "]"}], "=", 
    RowBox[{
     RowBox[{"h", "[", "3", "]"}], "=", "12"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"h", "[", "t_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{"t", ",", "4"}], "]"}], "==", "2"}], ",", "2", ",", "1"}], 
     "]"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"h", "[", 
       RowBox[{
        RowBox[{"Ceiling", "[", 
         RowBox[{"t", "/", "2"}], "]"}], "-", "1"}], "]"}], "+", "t"}], 
     ")"}]}], "+", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "5", ",", 
      RowBox[{"-", "7"}], ",", 
      RowBox[{"-", "1"}]}], "}"}], "\[LeftDoubleBracket]", 
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{"t", ",", "4"}], "]"}], "+", "1"}], 
    "\[RightDoubleBracket]"}]}]}]}], "Input",
 CellChangeTimes->{3.5130899447806463`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"h", ",", "20"}], "]"}]], "Input",
 CellChangeTimes->{3.5130899447809467`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "12", ",", "12", ",", "12", ",", "19", ",", "22", ",", "29", ",", "18", ",",
    "23", ",", "33", ",", "51", ",", "32", ",", "37", ",", "47", ",", "79", 
   ",", "32", ",", "37", ",", "45", ",", "75", ",", "51", ",", "56"}], 
  "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734431852985*^9, 3.428255092327091*^9, 
  3.4323249616500473`*^9, 3.432325578335186*^9, 3.43232579898245*^9, 
  3.432325838084406*^9, 3.4323264636732073`*^9, 3.5002117940009947`*^9, 
  3.513089944781299*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["Single combinators", "Subsection"], Cell[" (page 1123)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{3.513089944782267*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "x_", "]"}], "[", 
      "y_", "]"}], "[", "z_", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"x", "[", "z", "]"}], "[", 
     RowBox[{"y", "[", "z", "]"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", 
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "]"}], "[", "x_", 
      "]"}], "[", "y_", "]"}], "\[Rule]", "x"}]}], "}"}]], "Subsubsection",
 CellChangeTimes->{3.5130899447829037`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"#", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "x_", "]"}], 
          "[", "y_", "]"}], "[", "z_", "]"}], "\[Rule]", 
        RowBox[{
         RowBox[{"x", "[", "z", "]"}], "[", 
         RowBox[{"y", "[", "z", "]"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"\[ScriptJ]", "[", 
           RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "]"}], "[", "x_", 
          "]"}], "[", "y_", "]"}], "\[Rule]", "x"}]}], "}"}]}], "&"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "]"}], "[", 
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", "]"}],
     "]"}], ",", "5"}], "]"}]], "Input",
 CellChangeTimes->{3.5130899447840347`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "]"}], "[", 
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", "]"}],
     "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
        "]"}], "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
        "]"}], "]"}], "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", "]"}],
     "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
      "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
        "]"}], "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
      "]"}], "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
      "]"}], "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
         "]"}], "]"}], "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{
      RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
      "]"}], "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
         "]"}], "]"}], "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"\[ScriptJ]", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
         RowBox[{
          RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
          "]"}], "]"}], "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
        "]"}], "]"}], "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
         "]"}], "]"}], "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
         RowBox[{
          RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
          "]"}], "]"}], "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
        "]"}], "]"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"\[ScriptJ]", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
         RowBox[{
          RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
          "]"}], "]"}], "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
        "]"}], "]"}], "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
        "]"}], "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
        "]"}], "[", 
       RowBox[{
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
         RowBox[{
          RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
          RowBox[{
           RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
           "]"}], "]"}], "]"}], "[", 
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
         "]"}], "]"}], "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
       "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
        "]"}], "[", 
       RowBox[{
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
         RowBox[{
          RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", 
          RowBox[{
           RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
           "]"}], "]"}], "]"}], "[", 
        RowBox[{
         RowBox[{"\[ScriptJ]", "[", "\[ScriptJ]", "]"}], "[", "\[ScriptJ]", 
         "]"}], "]"}], "]"}], "]"}], "]"}], "]"}]}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734431904467*^9, 3.428255097142192*^9, 
  3.4323249617049227`*^9, 3.4323255784088717`*^9, 3.432325799061696*^9, 
  3.4323258381487923`*^9, 3.432326463735815*^9, 3.500211799334558*^9, 
  3.513089944786311*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox[GridBox[{
    {Cell["\<\
Page 714 \[CenterDot]  Cellular automaton combinators\
\>", "Subsection"], Cell[" (page 1123)", "TI"]}
   }], TextForm]], "Subsection",
 CellChangeTimes->{3.5130899447873993`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Apply", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{
          RowBox[{"p", "[", 
           RowBox[{
            RowBox[{"p", "[", "#1", "]"}], "[", "#2", "]"}], "]"}], "[", 
          RowBox[{
           RowBox[{"p", "[", "#3", "]"}], "[", "#4", "]"}], "]"}], "]"}], "[", 
        RowBox[{
         RowBox[{"p", "[", 
          RowBox[{
           RowBox[{"p", "[", "#5", "]"}], "[", "#6", "]"}], "]"}], "[", 
         RowBox[{
          RowBox[{"p", "[", "#7", "]"}], "[", "#8", "]"}], "]"}], "]"}], "/.",
        "\[InvisibleSpace]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"0", "\[Rule]", "\[ScriptK]"}], ",", 
         RowBox[{"1", "\[Rule]", 
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}]}]}], "}"}]}], "&"}], 
     ",", 
     RowBox[{"IntegerDigits", "[", 
      RowBox[{"m", ",", "2", ",", "8"}], "]"}]}], "]"}], "//.", 
   "\[InvisibleSpace]", "crules"}], "\n"}], "\n", 
 RowBox[{"p", "=", 
  RowBox[{
   RowBox[{"ToC", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"z", "[", "y", "]"}], "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}], "//.", 
   "\[InvisibleSpace]", "crules"}]}]}], "Subsubsection",
 CellChangeTimes->{3.5130899447884617`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"id", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ToC", "[", 
   RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{"rm", ",", "expr", ",", 
    RowBox[{"Reverse", "[", "vars", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"rm", "[", 
    RowBox[{"v_", ",", "v_"}], "]"}], "=", "id"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{
      RowBox[{"f_", "[", "v_", "]"}], ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"f", ",", "v"}], "]"}]}], "=", "f"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{"h_", ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"h", ",", "v"}], "]"}]}], "=", 
   RowBox[{"\[ScriptK]", "[", "h", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rm", "[", 
   RowBox[{
    RowBox[{"f_", "[", "g_", "]"}], ",", "v_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{"rm", "[", 
     RowBox[{"f", ",", "v"}], "]"}], "]"}], "[", 
   RowBox[{"rm", "[", 
    RowBox[{"g", ",", "v"}], "]"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"crules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptS]", "[", "x_", "]"}], "[", "y_", "]"}], "[", "z_", 
       "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"x", "[", "z", "]"}], "[", 
       RowBox[{"y", "[", "z", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptK]", "[", "x_", "]"}], "[", "y_", "]"}], "\[Rule]", 
      "x"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"p", "=", 
   RowBox[{
    RowBox[{"ToC", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"z", "[", "y", "]"}], "[", "x", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}], "//.", 
    "\[InvisibleSpace]", "crules"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.413738261448596*^9, 3.4137382662598*^9}, {
   3.43232327737251*^9, 3.432323291526696*^9}, 3.513089944790331*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"m", "=", "90"}], "}"}], ",", 
   RowBox[{
    RowBox[{"Apply", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"p", "[", 
          RowBox[{
           RowBox[{"p", "[", 
            RowBox[{
             RowBox[{"p", "[", "#1", "]"}], "[", "#2", "]"}], "]"}], "[", 
           RowBox[{
            RowBox[{"p", "[", "#3", "]"}], "[", "#4", "]"}], "]"}], "]"}], 
         "[", 
         RowBox[{
          RowBox[{"p", "[", 
           RowBox[{
            RowBox[{"p", "[", "#5", "]"}], "[", "#6", "]"}], "]"}], "[", 
          RowBox[{
           RowBox[{"p", "[", "#7", "]"}], "[", "#8", "]"}], "]"}], "]"}], "/.",
         "\[InvisibleSpace]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"0", "\[Rule]", "\[ScriptK]"}], ",", 
          RowBox[{"1", "\[Rule]", 
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}]}]}], "}"}]}], "&"}],
       ",", 
      RowBox[{"IntegerDigits", "[", 
       RowBox[{"m", ",", "2", ",", "8"}], "]"}]}], "]"}], "//.", 
    "\[InvisibleSpace]", "crules"}]}], "]"}]], "Input",
 CellChangeTimes->{3.51308994479135*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptS]", "[", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
      "]"}], "]"}], "[", 
    RowBox[{"\[ScriptK]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
          "]"}], "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", 
             RowBox[{
              RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
              "\[ScriptK]", "]"}], "]"}], "[", 
            RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "[", 
          RowBox[{"\[ScriptK]", "[", 
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], 
         "]"}], "]"}], "]"}], "[", 
      RowBox[{"\[ScriptK]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]",
             "]"}], "]"}], "[", 
          RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", 
         RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
      "]"}], "]"}], "]"}], "]"}], "[", 
  RowBox[{"\[ScriptK]", "[", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
        "]"}], "]"}], "[", 
      RowBox[{"\[ScriptK]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]",
             "]"}], "]"}], "[", 
          RowBox[{"\[ScriptK]", "[", 
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], 
         "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
     "]"}], "[", 
    RowBox[{"\[ScriptK]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
          "]"}], "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", 
         RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
      "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
   "]"}], "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.4137344322409678`*^9, 3.4137382694745417`*^9, 
  3.4282551046177464`*^9, 3.432324961845249*^9, 3.432325578628562*^9, 
  3.432325799186343*^9, 3.432325838239463*^9, 3.432326463842285*^9, 
  3.500211805007471*^9, 3.513089944792245*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"p", "[", 
     RowBox[{"num", "[", 
      RowBox[{"Length", "[", "list", "]"}], "]"}], "]"}], "[", 
    RowBox[{"Fold", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{"Nest", "[", 
          RowBox[{"\[ScriptS]", ",", "\[ScriptK]", ",", "#2"}], "]"}], "]"}], 
        "[", "#1", "]"}], "&"}], ",", 
      RowBox[{
       RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", "]"}], ",", 
      "list"}], "]"}], "]"}], "//.", "\[InvisibleSpace]", "crules"}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"num", "[", "n_", "]"}], ":=", 
   RowBox[{"Nest", "[", 
    RowBox[{"inc", ",", 
     RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], ",", "n"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"inc", "=", 
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
     "\[ScriptK]", "]"}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"Extract", "[", 
   RowBox[{"expr", ",", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Reverse", "[", 
        RowBox[{"IntegerDigits", "[", 
         RowBox[{"#", ",", "2"}], "]"}], "]"}], "&"}], ",", 
      RowBox[{"3", "+", 
       RowBox[{
        RowBox[{"59", "/", "15"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"16", "^", 
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Depth", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"expr", "[", 
                   RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "[",
                   "\[ScriptS]", "]"}], "[", "\[ScriptK]", "]"}], "//.", 
                "\[InvisibleSpace]", "crules"}], "]"}], "-", "1"}], ",", "1", 
             ",", 
             RowBox[{"-", "1"}]}], "]"}]}], "-", "1"}], ")"}]}]}]}], "]"}]}], 
   "]"}], "/.", "\[InvisibleSpace]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\[ScriptK]", "\[Rule]", "0"}], ",", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "\[Rule]", "1"}]}], 
   "}"}]}]}], "Subsubsection",
 CellChangeTimes->{3.5130899447935038`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"id", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ToC", "[", 
   RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{"rm", ",", "expr", ",", 
    RowBox[{"Reverse", "[", "vars", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"rm", "[", 
    RowBox[{"v_", ",", "v_"}], "]"}], "=", "id"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{
      RowBox[{"f_", "[", "v_", "]"}], ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"f", ",", "v"}], "]"}]}], "=", "f"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{"h_", ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"h", ",", "v"}], "]"}]}], "=", 
   RowBox[{"\[ScriptK]", "[", "h", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rm", "[", 
   RowBox[{
    RowBox[{"f_", "[", "g_", "]"}], ",", "v_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{"rm", "[", 
     RowBox[{"f", ",", "v"}], "]"}], "]"}], "[", 
   RowBox[{"rm", "[", 
    RowBox[{"g", ",", "v"}], "]"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"crules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptS]", "[", "x_", "]"}], "[", "y_", "]"}], "[", "z_", 
       "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"x", "[", "z", "]"}], "[", 
       RowBox[{"y", "[", "z", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptK]", "[", "x_", "]"}], "[", "y_", "]"}], "\[Rule]", 
      "x"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"p", "=", 
   RowBox[{
    RowBox[{"ToC", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"z", "[", "y", "]"}], "[", "x", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}], "//.", 
    "\[InvisibleSpace]", "crules"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"num", "[", "n_", "]"}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{"inc", ",", 
    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], ",", "n"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"inc", "=", 
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
     "\[ScriptK]", "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{3.513089944795557*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"list", "=", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{
    RowBox[{
     RowBox[{"p", "[", 
      RowBox[{"num", "[", 
       RowBox[{"Length", "[", "list", "]"}], "]"}], "]"}], "[", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"p", "[", 
          RowBox[{"Nest", "[", 
           RowBox[{"\[ScriptS]", ",", "\[ScriptK]", ",", "#2"}], "]"}], "]"}],
          "[", "#1", "]"}], "&"}], ",", 
       RowBox[{
        RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", "]"}], ",", 
       "list"}], "]"}], "]"}], "//.", "\[InvisibleSpace]", "crules"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.413738421942648*^9, 3.41373842284207*^9}, 
   3.513089944796327*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptS]", "[", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
      "]"}], "]"}], "[", 
    RowBox[{"\[ScriptK]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
          "]"}], "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", 
             RowBox[{
              RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
              "\[ScriptK]", "]"}], "]"}], "[", 
            RowBox[{"\[ScriptK]", "[", 
             RowBox[{
              RowBox[{"\[ScriptS]", "[", 
               RowBox[{
                RowBox[{"\[ScriptS]", "[", 
                 RowBox[{
                  RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                  "\[ScriptK]", "]"}], "]"}], "[", 
                RowBox[{"\[ScriptK]", "[", 
                 RowBox[{
                  RowBox[{"\[ScriptS]", "[", 
                   RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", 
                    RowBox[{
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
                    "\[ScriptK]", "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "]"}], "]"}], "[", 
                    RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "]"}], "]"}], "[", 
                  RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], 
                 "]"}], "]"}], "]"}], "[", 
              RowBox[{"\[ScriptK]", "[", 
               RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], 
             "]"}], "]"}], "]"}], "[", 
          RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}],
        "]"}], "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
   "]"}], "[", 
  RowBox[{"\[ScriptK]", "[", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
      "\[ScriptK]", "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{
       RowBox[{"\[ScriptS]", "[", 
        RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
       "\[ScriptK]", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
        "\[ScriptK]", "]"}], "]"}], "[", 
      RowBox[{
       RowBox[{"\[ScriptS]", "[", 
        RowBox[{
         RowBox[{"\[ScriptS]", "[", 
          RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
         "\[ScriptK]", "]"}], "]"}], "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
          "\[ScriptK]", "]"}], "]"}], "[", 
        RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
     "]"}], "]"}], "]"}], "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.4137344323449183`*^9, 3.41373842325323*^9, 
  3.42825511387569*^9, 3.432324961956517*^9, 3.432325578761064*^9, 
  3.432325799290331*^9, 3.4323258383111773`*^9, 3.4323264639275227`*^9, 
  3.500211811797431*^9, 3.51308994479746*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"expr", "=", "%"}], "}"}], ",", 
   RowBox[{
    RowBox[{"Extract", "[", 
     RowBox[{"expr", ",", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Reverse", "[", 
          RowBox[{"IntegerDigits", "[", 
           RowBox[{"#", ",", "2"}], "]"}], "]"}], "&"}], ",", 
        RowBox[{"3", "+", 
         RowBox[{
          RowBox[{"59", "/", "15"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"16", "^", 
             RowBox[{"Range", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Depth", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"expr", "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "[", "\[ScriptS]", "]"}], "[", "\[ScriptK]", "]"}], "//.",
                   "\[InvisibleSpace]", "crules"}], "]"}], "-", "1"}], ",", 
               "1", ",", 
               RowBox[{"-", "1"}]}], "]"}]}], "-", "1"}], ")"}]}]}]}], 
       "]"}]}], "]"}], "/.", "\[InvisibleSpace]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[ScriptK]", "\[Rule]", "0"}], ",", 
      RowBox[{
       RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "\[Rule]", "1"}]}], 
     "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{3.513089944798443*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.4137344324831333`*^9, 3.413738427557748*^9, 
  3.428255115431346*^9, 3.432324962027336*^9, 3.432325578846222*^9, 
  3.4323257993644247`*^9, 3.4323258383595943`*^9, 3.432326463979941*^9, 
  3.500211813246366*^9, 3.513089944798709*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"w", "=", 
   RowBox[{"cr", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"inc", "[", 
        RowBox[{"inc", "[", 
         RowBox[{"x", "[", 
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}],
        "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"inc", "[", 
          RowBox[{"x", "[", 
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "[", 
         RowBox[{"cr", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"p", "[", 
             RowBox[{
              RowBox[{"y", "[", 
               RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "[", 
              "\[ScriptK]", "]"}], "]"}], "[", 
            RowBox[{
             RowBox[{"p", "[", 
              RowBox[{
               RowBox[{"y", "[", 
                RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "[", 
               RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], 
             "[", 
             RowBox[{"y", "[", "\[ScriptK]", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", "y", "}"}]}], "]"}], "]"}], "[", 
        RowBox[{
         RowBox[{"p", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "[", 
             RowBox[{"cr", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"p", "[", 
                 RowBox[{
                  RowBox[{"p", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"f", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"y", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
                    "]"}], "[", "\[ScriptK]", "]"}], "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"y", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
                    "]"}], "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "[", 
                    RowBox[{
                    RowBox[{"y", "[", "\[ScriptK]", "]"}], "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "]"}], "[", 
                  RowBox[{"y", "[", 
                   RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                  "]"}], "]"}], "[", 
                RowBox[{
                 RowBox[{"y", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
                 "]"}], "]"}], ",", 
               RowBox[{"{", "y", "}"}]}], "]"}], "]"}], "[", 
            RowBox[{
             RowBox[{"p", "[", 
              RowBox[{
               RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
               "]"}], "]"}], "[", 
             RowBox[{
              RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", 
              RowBox[{"x", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "[", 
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "[", 
         RowBox[{
          RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", 
          RowBox[{
           RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", "]"}], 
          "]"}], "]"}], "]"}], "[", "\[ScriptK]", "]"}], "]"}], ",", 
     RowBox[{"{", "x", "}"}]}], "]"}]}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"cr", "[", 
   RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"ToC", "[", 
   RowBox[{
    RowBox[{"expr", "//.", "\[InvisibleSpace]", "crules"}], ",", "vars"}], 
   "]"}]}]}], "Subsubsection",
 CellChangeTimes->{3.5130899448007812`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"id", "=", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ToC", "[", 
   RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{"rm", ",", "expr", ",", 
    RowBox[{"Reverse", "[", "vars", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"rm", "[", 
    RowBox[{"v_", ",", "v_"}], "]"}], "=", "id"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{
      RowBox[{"f_", "[", "v_", "]"}], ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"f", ",", "v"}], "]"}]}], "=", "f"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rm", "[", 
     RowBox[{"h_", ",", "v_"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"h", ",", "v"}], "]"}]}], "=", 
   RowBox[{"\[ScriptK]", "[", "h", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rm", "[", 
   RowBox[{
    RowBox[{"f_", "[", "g_", "]"}], ",", "v_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{"rm", "[", 
     RowBox[{"f", ",", "v"}], "]"}], "]"}], "[", 
   RowBox[{"rm", "[", 
    RowBox[{"g", ",", "v"}], "]"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"w", "=", 
   RowBox[{"cr", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"inc", "[", 
        RowBox[{"inc", "[", 
         RowBox[{"x", "[", 
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}],
        "]"}], "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"inc", "[", 
          RowBox[{"x", "[", 
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "[", 
         RowBox[{"cr", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"p", "[", 
             RowBox[{
              RowBox[{"y", "[", 
               RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "[", 
              "\[ScriptK]", "]"}], "]"}], "[", 
            RowBox[{
             RowBox[{"p", "[", 
              RowBox[{
               RowBox[{"y", "[", 
                RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "[", 
               RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], 
             "[", 
             RowBox[{"y", "[", "\[ScriptK]", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", "y", "}"}]}], "]"}], "]"}], "[", 
        RowBox[{
         RowBox[{"p", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "[", 
             RowBox[{"cr", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"p", "[", 
                 RowBox[{
                  RowBox[{"p", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"f", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"y", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
                    "]"}], "[", "\[ScriptK]", "]"}], "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"y", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
                    "]"}], "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "[", 
                    RowBox[{
                    RowBox[{"y", "[", "\[ScriptK]", "]"}], "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "]"}], "]"}], "[", 
                  RowBox[{"y", "[", 
                   RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                  "]"}], "]"}], "[", 
                RowBox[{
                 RowBox[{"y", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
                 "]"}], "]"}], ",", 
               RowBox[{"{", "y", "}"}]}], "]"}], "]"}], "[", 
            RowBox[{
             RowBox[{"p", "[", 
              RowBox[{
               RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
               "]"}], "]"}], "[", 
             RowBox[{
              RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", 
              RowBox[{"x", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], "[", 
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "[", 
         RowBox[{
          RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", 
          RowBox[{
           RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", "]"}], 
          "]"}], "]"}], "]"}], "[", "\[ScriptK]", "]"}], "]"}], ",", 
     RowBox[{"{", "x", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"cr", "[", 
   RowBox[{"expr_", ",", "vars_"}], "]"}], ":=", 
  RowBox[{"ToC", "[", 
   RowBox[{
    RowBox[{"expr", "//.", "\[InvisibleSpace]", "crules"}], ",", "vars"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"crules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptS]", "[", "x_", "]"}], "[", "y_", "]"}], "[", "z_", 
       "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"x", "[", "z", "]"}], "[", 
       RowBox[{"y", "[", "z", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"\[ScriptK]", "[", "x_", "]"}], "[", "y_", "]"}], "\[Rule]", 
      "x"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"p", "=", 
   RowBox[{
    RowBox[{"ToC", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"z", "[", "y", "]"}], "[", "x", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}], "//.", 
    "\[InvisibleSpace]", "crules"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"num", "[", "n_", "]"}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{"inc", ",", 
    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], ",", "n"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"inc", "=", 
   RowBox[{"\[ScriptS]", "[", 
    RowBox[{
     RowBox[{"\[ScriptS]", "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptS]", "]"}], "]"}], "[", 
     "\[ScriptK]", "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.413738438170394*^9, 3.4137384405568247`*^9}, {
   3.432323302153545*^9, 3.432323303455501*^9}, 3.513089944804186*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", "=", "90"}], "}"}], ",", 
    RowBox[{
     RowBox[{"Apply", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"p", "[", 
           RowBox[{
            RowBox[{"p", "[", 
             RowBox[{
              RowBox[{"p", "[", "#1", "]"}], "[", "#2", "]"}], "]"}], "[", 
            RowBox[{
             RowBox[{"p", "[", "#3", "]"}], "[", "#4", "]"}], "]"}], "]"}], 
          "[", 
          RowBox[{
           RowBox[{"p", "[", 
            RowBox[{
             RowBox[{"p", "[", "#5", "]"}], "[", "#6", "]"}], "]"}], "[", 
           RowBox[{
            RowBox[{"p", "[", "#7", "]"}], "[", "#8", "]"}], "]"}], "]"}], "/.",
          "\[InvisibleSpace]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0", "\[Rule]", "\[ScriptK]"}], ",", 
           RowBox[{"1", "\[Rule]", 
            RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}]}]}], "}"}]}], 
        "&"}], ",", 
       RowBox[{"IntegerDigits", "[", 
        RowBox[{"m", ",", "2", ",", "8"}], "]"}]}], "]"}], "//.", 
     "\[InvisibleSpace]", "crules"}]}], "]"}]}]], "Input",
 CellChangeTimes->{3.513089944805077*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ScriptS]", "[", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
      "]"}], "]"}], "[", 
    RowBox[{"\[ScriptK]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
          "]"}], "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", 
             RowBox[{
              RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", 
              "\[ScriptK]", "]"}], "]"}], "[", 
            RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "[", 
          RowBox[{"\[ScriptK]", "[", 
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], 
         "]"}], "]"}], "]"}], "[", 
      RowBox[{"\[ScriptK]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]",
             "]"}], "]"}], "[", 
          RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", 
         RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
      "]"}], "]"}], "]"}], "]"}], "[", 
  RowBox[{"\[ScriptK]", "[", 
   RowBox[{
    RowBox[{"\[ScriptS]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
        "]"}], "]"}], "[", 
      RowBox[{"\[ScriptK]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", 
           RowBox[{
            RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]",
             "]"}], "]"}], "[", 
          RowBox[{"\[ScriptK]", "[", 
           RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], 
         "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
     "]"}], "[", 
    RowBox[{"\[ScriptK]", "[", 
     RowBox[{
      RowBox[{"\[ScriptS]", "[", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", 
         RowBox[{
          RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", 
          "]"}], "]"}], "[", 
        RowBox[{"\[ScriptK]", "[", 
         RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
      "[", 
      RowBox[{"\[ScriptK]", "[", "\[ScriptK]", "]"}], "]"}], "]"}], "]"}], 
   "]"}], "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734432573739*^9, 3.4137384437554827`*^9, 
  3.428255121286705*^9, 3.432324962166363*^9, 3.432325578955819*^9, 
  3.432325799563347*^9, 3.432325838423324*^9, 3.432326464062167*^9, 
  3.500211819140994*^9, 3.513089944805828*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Block", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"list", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ",", 
     "init", ",", "expr"}], "}"}], ",", 
   RowBox[{
    RowBox[{"init", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"p", "[", 
        RowBox[{"num", "[", 
         RowBox[{"Length", "[", "list", "]"}], "]"}], "]"}], "[", 
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"p", "[", 
            RowBox[{"Nest", "[", 
             RowBox[{"\[ScriptS]", ",", "\[ScriptK]", ",", "#2"}], "]"}], 
            "]"}], "[", "#1", "]"}], "&"}], ",", 
         RowBox[{
          RowBox[{"p", "[", "\[ScriptK]", "]"}], "[", "\[ScriptK]", "]"}], 
         ",", "list"}], "]"}], "]"}], "//.", "\[InvisibleSpace]", 
      "crules"}]}], ";", 
    RowBox[{"expr", "=", 
     RowBox[{
      RowBox[{"w", "[", "init", "]"}], "//.", "crules"}]}], ";", 
    RowBox[{
     RowBox[{"Extract", "[", 
      RowBox[{"expr", ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Reverse", "[", 
           RowBox[{"IntegerDigits", "[", 
            RowBox[{"#", ",", "2"}], "]"}], "]"}], "&"}], ",", 
         RowBox[{"3", "+", 
          RowBox[{
           RowBox[{"59", "/", "15"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"16", "^", 
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Depth", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"expr", "[", 
                    RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "]"}], 
                    "[", "\[ScriptS]", "]"}], "[", "\[ScriptK]", "]"}], "//.",
                    "\[InvisibleSpace]", "crules"}], "]"}], "-", "1"}], ",", 
                "1", ",", 
                RowBox[{"-", "1"}]}], "]"}]}], "-", "1"}], ")"}]}]}]}], 
        "]"}]}], "]"}], "/.", "\[InvisibleSpace]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[ScriptK]", "\[Rule]", "0"}], ",", 
       RowBox[{
        RowBox[{"\[ScriptS]", "[", "\[ScriptK]", "]"}], "\[Rule]", "1"}]}], 
      "}"}]}]}]}], "]"}]], "Input",
 CellChangeTimes->{3.513089944807001*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.413734432800009*^9, 3.413738445658472*^9, 
  3.428255123004201*^9, 3.432324962298769*^9, 3.432325579058517*^9, 
  3.4323257996651382`*^9, 3.432325838508524*^9, 3.4323264641536827`*^9, 
  3.5002118204885273`*^9, 3.513089944807384*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{708, 841},
WindowMargins->{{-2, Automatic}, {Automatic, 0}},
CellContext->CellGroup,
Magnification->1.,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions for NKS Webcode", "Subtitle"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 12], 
         Cell[
          StyleData[All, "Condensed"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{8, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 8], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, 
          CellLabelMargins -> {{2, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 5, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, CellFrameLabelMargins -> 
          6, StyleMenuListing -> None]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], ShowCellBracket -> False, 
             CellMargins -> {{36, 6}, {20, 3}}, 
             CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
             "NaturalLanguage", CounterIncrements -> "Title", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}}, FontSize -> 
             36], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 40}}, LineSpacing -> {1, 0}, 
             FontSize -> 44], 
            Cell[
             StyleData["Title", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 8}}, FontSize -> 20], 
            Cell[
             StyleData["Title", "Printout"], 
             CellMargins -> {{2, 10}, {12, 30}}, FontSize -> 24]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TitleHeader"], CellFrame -> {{0, 0}, {0.25, 0}}, 
             ShowCellBracket -> False, 
             CellMargins -> {{36, Inherited}, {3, 25}}, 
             CellGroupingRules -> {"TitleGrouping", 20}, PageBreakBelow -> 
             False, CellFrameMargins -> {{8, 8}, {4, 8}}, 
             DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
             "NaturalLanguage", FontSize -> 14], 
            Cell[
             StyleData["TitleHeader", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["TitleHeader", "Condensed"], 
             CellMargins -> {{8, 10}, {8, 8}}, FontSize -> 12], 
            Cell[
             StyleData["TitleHeader", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 10}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subsubtitle", 0}}, FontFamily -> "Helvetica", 
             FontSize -> 24], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 36], 
            Cell[
             StyleData["Subtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 4}}, FontSize -> 14], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.25, 0}}, 
             ShowCellBracket -> False, ShowGroupOpener -> True, 
             CellMargins -> {{36, 3}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, 
             CellFrameMargins -> {{Inherited, Inherited}, {4, Inherited}}, 
             CellFrameColor -> GrayLevel[0.6], DefaultNewInlineCellStyle -> 
             "None", InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 18], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellMargins -> {{40, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Section", "Condensed"], 
             CellMargins -> {{18, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{13, 0}, {7, 22}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], ShowCellBracket -> False, 
             ShowGroupOpener -> True, CellMargins -> {{50, 6}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsection", CounterAssignments -> {{"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 14, FontWeight -> "Bold", 
             GridBoxOptions -> {
              GridBoxAlignment -> {
                "Columns" -> {Left, {Right}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}}, 
               GridBoxItemSize -> {"Columns" -> {
                   Scaled[0.8], {
                    Scaled[0.2]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
                 "RowsIndexed" -> {}}}], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{36, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsection", "Condensed"], 
             CellMargins -> {{16, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 22}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellFrame -> 2, ShowCellBracket -> 
             False, ShowGroupOpener -> True, 
             CellMargins -> {{70, 2}, {8, 18}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             Evaluatable -> False, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, CellFrameColor -> RGBColor[1, 0.730007, 0.360006], 
             DefaultFormatType -> DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Subsubsection", FontWeight -> "Bold", 
             Background -> RGBColor[1, 0.970001, 0.840009]], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{34, 10}, {11, 26}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Subsubsection", "Condensed"], 
             CellMargins -> {{17, Inherited}, {6, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 14}}, FontSize -> 11]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TitleCell1"], ShowCellBracket -> False, 
             CellMargins -> {{0, 0}, {20, 0}}, 
             CellFrameMargins -> {{-1, 0}, {-1, -1}}, Hyphenation -> True, 
             StyleMenuListing -> None, FontSize -> 2, Magnification -> 1, 
             Background -> GrayLevel[0.2]], 
            Cell[
             StyleData["TitleCell1", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, FontSize -> 16], 
            Cell[
             StyleData["TitleCell1", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, FontSize -> 11], 
            Cell[
             StyleData["TitleCell1", "Printout"], 
             CellMargins -> {{2, 2}, {6, 6}}, TextJustification -> 0.5, 
             FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["TitleCell2"], ShowCellBracket -> False, 
             CellMargins -> {{12, 10}, {-3, 7}}, Hyphenation -> True, 
             StyleMenuListing -> None, Background -> GrayLevel[0.98999]], 
            Cell[
             StyleData["TitleCell2", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, FontSize -> 16], 
            Cell[
             StyleData["TitleCell2", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, FontSize -> 11], 
            Cell[
             StyleData["TitleCell2", "Printout"], 
             CellMargins -> {{2, 2}, {6, 6}}, TextJustification -> 0.5, 
             FontSize -> 10]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{80, 10}, {7, 7}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             Hyphenation -> True, LineSpacing -> {1, 3}, CounterIncrements -> 
             "Text"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Text", "Condensed"], CellMargins -> {{8, 10}, {6, 6}},
              LineSpacing -> {1, 1}, FontSize -> 11], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{2, 2}, {6, 6}}, 
             TextJustification -> 0.5, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SmallText"], CellMargins -> {{12, 10}, {6, 6}}, 
             DefaultNewInlineCellStyle -> "None", Hyphenation -> True, 
             LineSpacing -> {1, 3}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "SmallText", FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Presentation"], 
             CellMargins -> {{24, 10}, {8, 8}}, LineSpacing -> {1, 5}, 
             FontSize -> 12], 
            Cell[
             StyleData["SmallText", "Condensed"], 
             CellMargins -> {{8, 10}, {5, 5}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Printout"], 
             CellMargins -> {{2, 2}, {5, 5}}, TextJustification -> 0.5, 
             FontSize -> 7]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). ", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellMargins -> {{80, 10}, {5, 7}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Input", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{39, 0}, {4, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9]}, 
           Closed]], 
         Cell[
          StyleData["InputOnly"], Evaluatable -> True, CellGroupingRules -> 
          "InputGrouping", CellHorizontalScrolling -> True, DefaultFormatType -> 
          DefaultInputFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", StyleMenuListing -> None, FontWeight -> 
          "Bold"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellMargins -> {{80, 10}, {7, 5}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellEditDuplicate -> True, CellGroupingRules -> "OutputGrouping",
              CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, DefaultFormatType -> 
             DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Output"], 
            Cell[
             StyleData["Output", "Presentation"], 
             CellMargins -> {{72, Inherited}, {10, 8}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Output", "Condensed"], 
             CellMargins -> {{41, Inherited}, {3, 2}}, FontSize -> 11], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{39, 0}, {6, 4}}, FontSize -> 9]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{80, Inherited}, {Inherited, Inherited}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Message", StyleMenuListing -> 
             None, FontSize -> 11, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Message", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 7, FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{80, Inherited}, {Inherited, Inherited}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Print", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Print", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], 
             CellMargins -> {{80, Inherited}, {Inherited, Inherited}}, 
             CellBracketOptions -> {"Color" -> RGBColor[1, 0, 0]}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, LanguageCategory -> 
             None, FormatType -> InputForm, CounterIncrements -> "Graphics", 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 
             10], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             ImageMargins -> {{62, Inherited}, {Inherited, 0}}], 
            Cell[
             StyleData["Graphics", "Condensed"], 
             ImageMargins -> {{38, Inherited}, {Inherited, 0}}, Magnification -> 
             0.6], 
            Cell[
             StyleData["Graphics", "Printout"], 
             ImageMargins -> {{30, Inherited}, {Inherited, 0}}, Magnification -> 
             0.8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["CellLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["FrameLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9], 
            Cell[
             StyleData["FrameLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["FrameLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["FrameLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["SO10", "EnhancedPrintout"], StyleMenuListing -> None, 
             FontFamily -> "Futura", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 10, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Placeholder Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making placeholder objects \
in palette templates.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Placeholder"], Placeholder -> True, StyleMenuListing -> 
             None, FontSlant -> "Italic", FontColor -> 
             RGBColor[0.890623, 0.864698, 0.384756], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["Placeholder", "Presentation"]], 
            Cell[
             StyleData["Placeholder", "Condensed"]], 
            Cell[
             StyleData["Placeholder", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PrimaryPlaceholder"], StyleMenuListing -> None, 
             DrawHighlighted -> True, FontSlant -> "Italic", Background -> 
             RGBColor[0.912505, 0.891798, 0.507774], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["PrimaryPlaceholder", "Presentation"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Condensed"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Printout"]]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.", "Text"], 
         Cell[
          StyleData["CellExpression"], PageWidth -> Infinity, 
          CellMargins -> {{6, Inherited}, {Inherited, Inherited}}, 
          ShowCellLabel -> False, ShowSpecialCharacters -> False, 
          AllowInlineCells -> False, Hyphenation -> False, 
          AutoItalicWords -> {}, StyleMenuListing -> None, FontFamily -> 
          "Courier", FontSize -> 12, Background -> GrayLevel[1]], 
         Cell[
          StyleData["InputForm"], InputAutoReplacements -> {}, 
          AllowInlineCells -> False, Hyphenation -> False, StyleMenuListing -> 
          None, FontFamily -> "Courier"], 
         Cell[
          StyleData["OutputForm"], PageWidth -> Infinity, TextAlignment -> 
          Left, LineSpacing -> {0.6, 1}, StyleMenuListing -> None, FontFamily -> 
          "Courier"], 
         Cell[
          StyleData["StandardForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          StyleMenuListing -> None, FontFamily -> "Courier"], 
         Cell[
          StyleData["TraditionalForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          SingleLetterItalics -> True, TraditionalFunctionNotation -> True, 
          DelimiterMatching -> None, StyleMenuListing -> None], 
         Cell[
         "The style defined below is mixed in to any cell that is in an \
inline cell within another.", "Text"], 
         Cell[
          StyleData["InlineCell"], LanguageCategory -> "Formula", ScriptLevel -> 
          1, StyleMenuListing -> None], 
         Cell[
          StyleData["InlineCellEditing"], StyleMenuListing -> None, 
          Background -> RGBColor[1, 0.749996, 0.8]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Automatic Styles", "Section"], 
         Cell[
         "The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).", "Text"], 
         Cell[
          StyleData["UnmatchedBracket"], StyleMenuListing -> None, FontColor -> 
          RGBColor[0.760006, 0.330007, 0.8]]}, Closed]]}, Open]]}, Visible -> 
  False, FrontEndVersion -> 
  "8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[1235, 30, 1845, 38, 25, "TitleCell1"],
Cell[3083, 70, 234, 7, 24, "Text"],
Cell[3320, 79, 43, 0, 46, "TitleHeader"],
Cell[CellGroupData[{
Cell[3388, 83, 42, 0, 59, "Title"],
Cell[CellGroupData[{
Cell[3455, 87, 52, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[3532, 91, 179, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[3736, 100, 2327, 76, 138, "Subsubsection"],
Cell[6066, 178, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[6814, 204, 3260, 92, 119, "Input"],
Cell[10077, 298, 1216, 26, 282, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11354, 331, 177, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[11556, 340, 4278, 134, 187, "Subsubsection"],
Cell[15837, 476, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[16585, 502, 5840, 158, 216, "Input"],
Cell[22428, 662, 2748, 41, 249, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25249, 711, 49, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[25323, 715, 222, 7, 46, "Subsection"],
Cell[CellGroupData[{
Cell[25570, 726, 105, 3, 58, "Subsubsection"],
Cell[25678, 731, 97, 3, 24, "Input"],
Cell[CellGroupData[{
Cell[25800, 738, 164, 5, 24, "Input"],
Cell[25967, 745, 343, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[26359, 757, 243, 8, 44, "Subsubsection"],
Cell[26605, 767, 240, 8, 24, "Input"],
Cell[CellGroupData[{
Cell[26870, 779, 164, 5, 24, "Input"],
Cell[27037, 786, 332, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[27418, 798, 196, 6, 44, "Subsubsection"],
Cell[27617, 806, 188, 6, 24, "Input"],
Cell[CellGroupData[{
Cell[27830, 816, 164, 5, 24, "Input"],
Cell[27997, 823, 334, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[28380, 835, 397, 14, 44, "Subsubsection"],
Cell[28780, 851, 389, 14, 24, "Input"],
Cell[CellGroupData[{
Cell[29194, 869, 164, 5, 24, "Input"],
Cell[29361, 876, 336, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[29746, 888, 451, 15, 44, "Subsubsection"],
Cell[30200, 905, 439, 14, 24, "Input"],
Cell[CellGroupData[{
Cell[30664, 923, 164, 5, 24, "Input"],
Cell[30831, 930, 336, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[31216, 942, 181, 5, 44, "Subsubsection"],
Cell[31400, 949, 173, 5, 24, "Input"],
Cell[CellGroupData[{
Cell[31598, 958, 164, 5, 24, "Input"],
Cell[31765, 965, 343, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[32157, 977, 190, 5, 44, "Subsubsection"],
Cell[32350, 984, 182, 5, 24, "Input"],
Cell[CellGroupData[{
Cell[32557, 993, 164, 5, 24, "Input"],
Cell[32724, 1000, 333, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[33106, 1012, 259, 8, 44, "Subsubsection"],
Cell[33368, 1022, 251, 8, 24, "Input"],
Cell[CellGroupData[{
Cell[33644, 1034, 229, 6, 24, "Input"],
Cell[33876, 1042, 335, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[34260, 1054, 391, 13, 44, "Subsubsection"],
Cell[34654, 1069, 383, 13, 24, "Input"],
Cell[CellGroupData[{
Cell[35062, 1086, 164, 5, 24, "Input"],
Cell[35229, 1093, 340, 6, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[35618, 1105, 257, 8, 44, "Subsubsection"],
Cell[35878, 1115, 342, 10, 24, "Input"],
Cell[CellGroupData[{
Cell[36245, 1129, 164, 5, 24, "Input"],
Cell[36412, 1136, 341, 6, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[36826, 1150, 49, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[36900, 1154, 180, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[37105, 1163, 11418, 340, 449, "Subsubsection"],
Cell[48526, 1505, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[49274, 1531, 1373, 40, 70, "Input"],
Cell[50650, 1573, 575, 12, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51262, 1590, 12946, 335, 455, "Input"],
Cell[64211, 1927, 8181, 128, 505, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[72453, 2062, 161, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[72639, 2070, 1584, 45, 149, "Subsubsection"],
Cell[74226, 2117, 1129, 32, 85, "Input"],
Cell[CellGroupData[{
Cell[75380, 2153, 667, 21, 40, "Input"],
Cell[76050, 2176, 1643, 42, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[77766, 2226, 65, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[77856, 2230, 165, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[78046, 2238, 1284, 40, 104, "Subsubsection"],
Cell[79333, 2280, 2052, 63, 130, "Input"],
Cell[CellGroupData[{
Cell[81410, 2347, 2344, 64, 100, "Input"],
Cell[83757, 2413, 896, 18, 106, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[84714, 2438, 165, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[84904, 2446, 1350, 46, 104, "Subsubsection"],
Cell[86257, 2494, 1996, 67, 115, "Input"],
Cell[CellGroupData[{
Cell[88278, 2565, 1628, 47, 85, "Input"],
Cell[89909, 2614, 1382, 30, 186, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[91352, 2651, 172, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[91549, 2660, 4245, 133, 169, "Subsubsection"],
Cell[95797, 2795, 3847, 123, 166, "Input"],
Cell[CellGroupData[{
Cell[99669, 2922, 1914, 55, 70, "Input"],
Cell[101586, 2979, 1863, 31, 346, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[103510, 3017, 183, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[103718, 3026, 10037, 292, 359, "Subsubsection"],
Cell[113758, 3320, 10800, 315, 385, "Input"],
Cell[CellGroupData[{
Cell[124583, 3639, 305, 10, 24, "Input"],
Cell[124891, 3651, 390, 8, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[125318, 3664, 1121, 35, 40, "Input"],
Cell[126442, 3701, 3117, 85, 115, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[129620, 3793, 167, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[129812, 3801, 5926, 184, 310, "Subsubsection"],
Cell[135741, 3987, 6456, 202, 260, "Input"],
Cell[CellGroupData[{
Cell[142222, 4193, 874, 23, 40, "Input"],
Cell[143099, 4218, 3239, 73, 506, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[146399, 4298, 174, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[146598, 4307, 2029, 68, 108, "Subsubsection"],
Cell[148630, 4377, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[149378, 4403, 2705, 79, 120, "Input"],
Cell[152086, 4484, 1658, 30, 346, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[153805, 4521, 164, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[153994, 4529, 2952, 89, 167, "Subsubsection"],
Cell[156949, 4620, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[157697, 4646, 3874, 101, 149, "Input"],
Cell[161574, 4749, 1122, 20, 170, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[162757, 4776, 153, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[162935, 4784, 2741, 87, 124, "Subsubsection"],
Cell[165679, 4873, 723, 22, 70, "Input"],
Cell[CellGroupData[{
Cell[166427, 4899, 5098, 139, 198, "Input"],
Cell[171528, 5040, 2727, 41, 266, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[174328, 5089, 65, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[174418, 5093, 165, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[174608, 5101, 4556, 123, 220, "Subsubsection"],
Cell[179167, 5226, 5798, 168, 261, "Input"],
Cell[CellGroupData[{
Cell[184990, 5398, 1047, 30, 70, "Input"],
Cell[186040, 5430, 4427, 110, 175, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[190528, 5547, 166, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[190719, 5555, 1497, 49, 91, "Subsubsection"],
Cell[192219, 5606, 3158, 102, 162, "Input"],
Cell[CellGroupData[{
Cell[195402, 5712, 989, 29, 55, "Input"],
Cell[196394, 5743, 3946, 104, 175, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[200401, 5854, 183, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[200609, 5863, 1094, 34, 74, "Subsubsection"],
Cell[201706, 5899, 2689, 82, 175, "Input"],
Cell[CellGroupData[{
Cell[204420, 5985, 466, 11, 40, "Input"],
Cell[204889, 5998, 2698, 41, 506, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[207648, 6046, 161, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[207834, 6054, 2258, 67, 119, "Subsubsection"],
Cell[210095, 6123, 3410, 101, 160, "Input"],
Cell[CellGroupData[{
Cell[213530, 6228, 674, 17, 40, "Input"],
Cell[214207, 6247, 2745, 75, 106, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[217013, 6329, 166, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[217204, 6337, 2014, 62, 119, "Subsubsection"],
Cell[219221, 6401, 484, 13, 55, "Input"],
Cell[CellGroupData[{
Cell[219730, 6418, 835, 28, 40, "Input"],
Cell[220568, 6448, 610, 16, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[221215, 6469, 2172, 69, 70, "Input"],
Cell[223390, 6540, 3235, 111, 85, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[226662, 6656, 3633, 104, 109, "Input"],
Cell[230298, 6762, 6747, 206, 174, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[237106, 6975, 168, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[237299, 6983, 2130, 71, 164, "Subsubsection"],
Cell[239432, 7056, 2638, 93, 145, "Input"],
Cell[CellGroupData[{
Cell[242095, 7153, 352, 12, 24, "Input"],
Cell[242450, 7167, 611, 16, 24, "Output"]
}, Open  ]],
Cell[243076, 7186, 168, 3, 26, "Text"],
Cell[CellGroupData[{
Cell[243269, 7193, 159, 5, 24, "Input"],
Cell[243431, 7200, 397, 8, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[243865, 7213, 591, 19, 40, "Input"],
Cell[244459, 7234, 4708, 122, 205, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[249204, 7361, 823, 26, 40, "Input"],
Cell[250030, 7389, 720, 17, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[250811, 7413, 178, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[251014, 7422, 8278, 212, 340, "Subsubsection"],
Cell[259295, 7636, 8877, 238, 385, "Input"],
Cell[CellGroupData[{
Cell[268197, 7878, 2222, 65, 100, "Input"],
Cell[270422, 7945, 4179, 94, 175, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[274662, 8046, 186, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[274873, 8055, 6064, 167, 359, "Subsubsection"],
Cell[280940, 8224, 5066, 137, 190, "Input"],
Cell[CellGroupData[{
Cell[286031, 8365, 1113, 36, 40, "Input"],
Cell[287147, 8403, 9148, 275, 220, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[296332, 8683, 2549, 75, 145, "Input"],
Cell[298884, 8760, 1803, 59, 55, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[300748, 8826, 167, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[300940, 8834, 4597, 141, 269, "Subsubsection"],
Cell[305540, 8977, 6240, 193, 280, "Input"],
Cell[CellGroupData[{
Cell[311805, 9174, 775, 25, 40, "Input"],
Cell[312583, 9201, 4312, 123, 130, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[316932, 9329, 1012, 32, 55, "Input"],
Cell[317947, 9363, 7848, 251, 205, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[325832, 9619, 633, 21, 40, "Input"],
Cell[326468, 9642, 384, 6, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[326913, 9655, 165, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[327103, 9663, 4934, 147, 284, "Subsubsection"],
Cell[332040, 9812, 6682, 208, 325, "Input"],
Cell[CellGroupData[{
Cell[338747, 10024, 1258, 37, 69, "Input"],
Cell[340008, 10063, 2645, 90, 66, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[342714, 10160, 163, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[342902, 10168, 860, 26, 74, "Subsubsection"],
Cell[343765, 10196, 1964, 66, 115, "Input"],
Cell[CellGroupData[{
Cell[345754, 10266, 1091, 33, 55, "Input"],
Cell[346848, 10301, 3466, 110, 100, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[350375, 10418, 168, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[350568, 10426, 4235, 117, 239, "Subsubsection"],
Cell[354806, 10545, 3546, 96, 175, "Input"],
Cell[CellGroupData[{
Cell[358377, 10645, 516, 15, 24, "Input"],
Cell[358896, 10662, 358, 7, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[359291, 10674, 1533, 45, 100, "Input"],
Cell[360827, 10721, 958, 30, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[361846, 10758, 129, 3, 46, "Subsection"],
Cell[CellGroupData[{
Cell[362000, 10765, 1362, 41, 149, "Subsubsection"],
Cell[363365, 10808, 1025, 30, 70, "Input"],
Cell[CellGroupData[{
Cell[364415, 10842, 104, 2, 24, "Input"],
Cell[364522, 10846, 1668, 25, 130, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[366227, 10876, 392, 12, 24, "Input"],
Cell[366622, 10890, 367, 8, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[367062, 10906, 50, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[367137, 10910, 168, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[367330, 10918, 20474, 583, 1078, "Subsubsection"],
Cell[387807, 11503, 19927, 573, 865, "Input"],
Cell[CellGroupData[{
Cell[407759, 12080, 463, 14, 28, "Input"],
Cell[408225, 12096, 359, 6, 27, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[408657, 12110, 52, 0, 50, "Section"],
Cell[CellGroupData[{
Cell[408734, 12114, 172, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[408931, 12123, 388, 11, 58, "Subsubsection"],
Cell[409322, 12136, 72, 0, 26, "Text"],
Cell[409397, 12138, 1887, 48, 85, "Input"],
Cell[CellGroupData[{
Cell[411309, 12190, 1898, 45, 115, "Input"],
Cell[413210, 12237, 4726, 103, 372, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[418009, 12348, 110, 1, 50, "Section"],
Cell[CellGroupData[{
Cell[418144, 12353, 218, 6, 46, "Subsection"],
Cell[CellGroupData[{
Cell[418387, 12363, 2009, 56, 134, "Subsubsection"],
Cell[420399, 12421, 1999, 56, 100, "Input"],
Cell[CellGroupData[{
Cell[422423, 12481, 421, 13, 24, "Input"],
Cell[422847, 12496, 786, 14, 40, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[423694, 12517, 219, 6, 46, "Subsection"],
Cell[423916, 12525, 2080, 70, 89, "Subsubsection"],
Cell[425999, 12597, 1362, 45, 60, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[427398, 12647, 187, 4, 46, "Subsection"],
Cell[427588, 12653, 1384, 46, 74, "Subsubsection"],
Cell[428975, 12701, 1060, 35, 60, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[430072, 12741, 196, 5, 46, "Subsection"],
Cell[430271, 12748, 754, 25, 58, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[431062, 12778, 206, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[431293, 12787, 904, 28, 89, "Subsubsection"],
Cell[CellGroupData[{
Cell[432222, 12819, 1307, 39, 70, "Input"],
Cell[433532, 12860, 1373, 30, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[434966, 12897, 200, 5, 46, "Subsection"],
Cell[CellGroupData[{
Cell[435191, 12906, 2515, 78, 149, "Subsubsection"],
Cell[437709, 12986, 1797, 57, 85, "Input"],
Cell[CellGroupData[{
Cell[439531, 13047, 261, 7, 24, "Input"],
Cell[439795, 13056, 309, 6, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[440141, 13067, 195, 5, 24, "Input"],
Cell[440339, 13074, 378, 8, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[440754, 13087, 216, 5, 24, "Input"],
Cell[440973, 13094, 309, 6, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[441319, 13105, 843, 26, 70, "Input"],
Cell[442165, 13133, 374, 8, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[442600, 13148, 205, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[442830, 13156, 3528, 101, 179, "Subsubsection"],
Cell[446361, 13259, 7514, 227, 355, "Input"],
Cell[CellGroupData[{
Cell[453900, 13490, 352, 11, 24, "Input"],
Cell[454255, 13503, 461, 10, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[454753, 13518, 314, 10, 24, "Input"],
Cell[455070, 13530, 422, 10, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[455553, 13547, 209, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[455787, 13555, 8351, 215, 373, "Subsubsection"],
Cell[464141, 13772, 8344, 215, 374, "Input"],
Cell[CellGroupData[{
Cell[472510, 13991, 406, 13, 24, "Input"],
Cell[472919, 14006, 12413, 320, 295, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[485381, 14332, 710, 21, 62, "Subsubsection"],
Cell[CellGroupData[{
Cell[486116, 14357, 1020, 30, 65, "Input"],
Cell[487139, 14389, 303, 6, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[487503, 14402, 254, 6, 46, "Subsection"],
Cell[487760, 14410, 505, 16, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[488290, 14430, 1370, 45, 195, "Subsubsection"],
Cell[489663, 14477, 1275, 42, 100, "Input"],
Cell[CellGroupData[{
Cell[490963, 14523, 272, 8, 24, "Input"],
Cell[491238, 14533, 1006, 25, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[492293, 14564, 1355, 40, 165, "Subsubsection"],
Cell[493651, 14606, 1836, 57, 100, "Input"],
Cell[CellGroupData[{
Cell[495512, 14667, 139, 3, 24, "Input"],
Cell[495654, 14672, 753, 19, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[496444, 14696, 233, 7, 24, "Input"],
Cell[496680, 14705, 389, 9, 24, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[497106, 14719, 380, 11, 24, "Input"],
Cell[497489, 14732, 487, 13, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[498003, 14749, 9838, 221, 240, "Subsubsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[507878, 14975, 214, 6, 46, "Subsection"],
Cell[CellGroupData[{
Cell[508117, 14985, 997, 34, 89, "Subsubsection"],
Cell[509117, 15021, 988, 34, 55, "Input"],
Cell[CellGroupData[{
Cell[510130, 15059, 126, 3, 24, "Input"],
Cell[510259, 15064, 569, 12, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[510889, 15083, 182, 4, 46, "Subsection"],
Cell[CellGroupData[{
Cell[511096, 15091, 592, 18, 58, "Subsubsection"],
Cell[CellGroupData[{
Cell[511713, 15113, 1312, 37, 40, "Input"],
Cell[513028, 15152, 7168, 196, 145, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[520257, 15355, 227, 6, 46, "Subsection"],
Cell[CellGroupData[{
Cell[520509, 15365, 1345, 40, 104, "Subsubsection"],
Cell[521857, 15407, 2133, 69, 130, "Input"],
Cell[CellGroupData[{
Cell[524015, 15480, 1186, 35, 55, "Input"],
Cell[525204, 15517, 3034, 79, 55, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[528287, 15602, 2275, 68, 165, "Subsubsection"],
Cell[530565, 15672, 2446, 80, 160, "Input"],
Cell[CellGroupData[{
Cell[533036, 15756, 871, 26, 40, "Input"],
Cell[533910, 15784, 4487, 109, 85, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[538434, 15898, 1415, 40, 70, "Input"],
Cell[539852, 15940, 408, 8, 24, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[540309, 15954, 3830, 97, 150, "Subsubsection"],
Cell[544142, 16053, 6303, 177, 280, "Input"],
Cell[CellGroupData[{
Cell[550470, 16234, 1244, 36, 70, "Input"],
Cell[551717, 16272, 3030, 79, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[554784, 16356, 2337, 66, 100, "Input"],
Cell[557124, 16424, 431, 9, 24, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

(* NotebookSignature ix0TnpUC2XJ1#DgIZAdIRcU6 *)
